GNU bug report logs - #43725
28.0.50; Include feature/native-comp into master

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Andrea Corallo <akrl@HIDDEN>; dated Wed, 30 Sep 2020 15:45:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 20 Mar 2021 11:00:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Mar 20 07:00:38 2021
Received: from localhost ([127.0.0.1]:51611 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lNZLS-0007Vb-9o
	for submit <at> debbugs.gnu.org; Sat, 20 Mar 2021 07:00:38 -0400
Received: from eggs.gnu.org ([209.51.188.92]:44216)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lNZLQ-0007PO-OO
 for 43725 <at> debbugs.gnu.org; Sat, 20 Mar 2021 07:00:37 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:52352)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lNZLJ-0005jv-NS; Sat, 20 Mar 2021 07:00:29 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4540
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lNZLH-0006v4-RZ; Sat, 20 Mar 2021 07:00:28 -0400
Date: Sat, 20 Mar 2021 13:00:25 +0200
Message-Id: <83h7l6ccom.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjf8s6oyypa.fsf@HIDDEN> (message from Andrea Corallo on Mon, 15
 Mar 2021 20:00:17 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
 <xjfk0qfrvwa.fsf@HIDDEN> <83v99znizq.fsf@HIDDEN>
 <xjfpn07qafm.fsf@HIDDEN> <83o8frnf2r.fsf@HIDDEN>
 <xjfh7ljq7nh.fsf@HIDDEN> <xjf5z1z3pmi.fsf@HIDDEN>
 <83r1khfy5d.fsf@HIDDEN> <xjfwnu9mu7a.fsf@HIDDEN>
 <83k0q9fr91.fsf@HIDDEN> <xjfk0q9mrol.fsf@HIDDEN>
 <838s6ofnr7.fsf@HIDDEN> <xjfh7lczalw.fsf@HIDDEN>
 <83y2eoe071.fsf@HIDDEN> <xjf8s6oyypa.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
> Date: Mon, 15 Mar 2021 20:00:17 +0000
> 
> >> This text is generated from 'Fprin1_to_string' that we use to
> >> essentially render in form of text immediate objects.  I thought
> >> this was disconnected from the encoding of the source file, am I
> >> wrong?
> >
> > If the original text is from Lisp strings in the Lisp source file,
> > then it isn't disconnected.  Those strings could include non-ASCII
> > characters, and they come out in UTF-8 (well, almost, modulo the raw
> > bytes etc.).
> 
> In december I've fixed a bug for multibyte strings adding also a
> testcase for that.  This was bug#45342 and the commit fixing and adding
> the testcase is 72c1a41573.
> 
> I'm no big expert into this area so you might want to have a look to the
> commit to suggets if this covers already the case you are suggesting or
> not.

SGTM, so I guess we can see this issue closed, until and unless we see
some specific bug reports.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 15 Mar 2021 20:00:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 15 16:00:24 2021
Received: from localhost ([127.0.0.1]:37257 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lLtO4-0007un-0O
	for submit <at> debbugs.gnu.org; Mon, 15 Mar 2021 16:00:24 -0400
Received: from mx.sdf.org ([205.166.94.24]:54855)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lLtNz-0007uc-Rt
 for 43725 <at> debbugs.gnu.org; Mon, 15 Mar 2021 16:00:22 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 12FK0HrN023830
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Mon, 15 Mar 2021 20:00:18 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
 <xjfk0qfrvwa.fsf@HIDDEN> <83v99znizq.fsf@HIDDEN>
 <xjfpn07qafm.fsf@HIDDEN> <83o8frnf2r.fsf@HIDDEN>
 <xjfh7ljq7nh.fsf@HIDDEN> <xjf5z1z3pmi.fsf@HIDDEN>
 <83r1khfy5d.fsf@HIDDEN> <xjfwnu9mu7a.fsf@HIDDEN>
 <83k0q9fr91.fsf@HIDDEN> <xjfk0q9mrol.fsf@HIDDEN>
 <838s6ofnr7.fsf@HIDDEN> <xjfh7lczalw.fsf@HIDDEN>
 <83y2eoe071.fsf@HIDDEN>
Date: Mon, 15 Mar 2021 20:00:17 +0000
In-Reply-To: <83y2eoe071.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 15 Mar
 2021 20:33:38 +0200")
Message-ID: <xjf8s6oyypa.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
>> Date: Mon, 15 Mar 2021 15:43:07 +0000
>> 
>> Eli Zaretskii <eliz@HIDDEN> writes:
>> 
>> > The issue is this: our Lisp files are generally encoded in UTF-8.  But
>> > there's no guarantee that GCC expects the source to be encoded in
>> > UTF-8.  If the text we submit to libgccjit for compilation is in the
>> > same encoding as the original .el files, then shouldn't we tell GCC
>> > its actual encoding, to make sure non-ASCII text aren't mangled?
>> 
>> The only generated text we are passing to libgccjit is feed to
>> 'gcc_jit_context_new_string_literal'.
>
> What kind of "string literals" go this way?  Are these constant
> strings from Lisp, or can some other data types from Lisp end up being
> passed like that?

This are essentially all Lisp objects that we'd put in the constant
vector for the bytecode case.

>> This text is generated from 'Fprin1_to_string' that we use to
>> essentially render in form of text immediate objects.  I thought
>> this was disconnected from the encoding of the source file, am I
>> wrong?
>
> If the original text is from Lisp strings in the Lisp source file,
> then it isn't disconnected.  Those strings could include non-ASCII
> characters, and they come out in UTF-8 (well, almost, modulo the raw
> bytes etc.).

In december I've fixed a bug for multibyte strings adding also a
testcase for that.  This was bug#45342 and the commit fixing and adding
the testcase is 72c1a41573.

I'm no big expert into this area so you might want to have a look to the
commit to suggets if this covers already the case you are suggesting or
not.

Thanks!

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 15 Mar 2021 18:33:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 15 14:33:39 2021
Received: from localhost ([127.0.0.1]:37085 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lLs27-0005ZW-JO
	for submit <at> debbugs.gnu.org; Mon, 15 Mar 2021 14:33:39 -0400
Received: from eggs.gnu.org ([209.51.188.92]:55050)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lLs25-0005Z6-5B
 for 43725 <at> debbugs.gnu.org; Mon, 15 Mar 2021 14:33:38 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:48750)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lLs1w-00044h-0R; Mon, 15 Mar 2021 14:33:29 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2637
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lLs1u-0004g1-GG; Mon, 15 Mar 2021 14:33:27 -0400
Date: Mon, 15 Mar 2021 20:33:38 +0200
Message-Id: <83y2eoe071.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfh7lczalw.fsf@HIDDEN> (message from Andrea Corallo on Mon, 15
 Mar 2021 15:43:07 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
 <xjfk0qfrvwa.fsf@HIDDEN> <83v99znizq.fsf@HIDDEN>
 <xjfpn07qafm.fsf@HIDDEN> <83o8frnf2r.fsf@HIDDEN>
 <xjfh7ljq7nh.fsf@HIDDEN> <xjf5z1z3pmi.fsf@HIDDEN>
 <83r1khfy5d.fsf@HIDDEN> <xjfwnu9mu7a.fsf@HIDDEN>
 <83k0q9fr91.fsf@HIDDEN> <xjfk0q9mrol.fsf@HIDDEN>
 <838s6ofnr7.fsf@HIDDEN> <xjfh7lczalw.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
> Date: Mon, 15 Mar 2021 15:43:07 +0000
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > The issue is this: our Lisp files are generally encoded in UTF-8.  But
> > there's no guarantee that GCC expects the source to be encoded in
> > UTF-8.  If the text we submit to libgccjit for compilation is in the
> > same encoding as the original .el files, then shouldn't we tell GCC
> > its actual encoding, to make sure non-ASCII text aren't mangled?
> 
> The only generated text we are passing to libgccjit is feed to
> 'gcc_jit_context_new_string_literal'.

What kind of "string literals" go this way?  Are these constant
strings from Lisp, or can some other data types from Lisp end up being
passed like that?

> This text is generated from 'Fprin1_to_string' that we use to
> essentially render in form of text immediate objects.  I thought
> this was disconnected from the encoding of the source file, am I
> wrong?

If the original text is from Lisp strings in the Lisp source file,
then it isn't disconnected.  Those strings could include non-ASCII
characters, and they come out in UTF-8 (well, almost, modulo the raw
bytes etc.).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 15 Mar 2021 15:43:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 15 11:43:14 2021
Received: from localhost ([127.0.0.1]:36405 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lLpNC-0006ha-Je
	for submit <at> debbugs.gnu.org; Mon, 15 Mar 2021 11:43:14 -0400
Received: from mx.sdf.org ([205.166.94.24]:56311)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lLpN8-0006hL-R6
 for 43725 <at> debbugs.gnu.org; Mon, 15 Mar 2021 11:43:13 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 12FFh7t4028128
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Mon, 15 Mar 2021 15:43:08 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
 <xjfk0qfrvwa.fsf@HIDDEN> <83v99znizq.fsf@HIDDEN>
 <xjfpn07qafm.fsf@HIDDEN> <83o8frnf2r.fsf@HIDDEN>
 <xjfh7ljq7nh.fsf@HIDDEN> <xjf5z1z3pmi.fsf@HIDDEN>
 <83r1khfy5d.fsf@HIDDEN> <xjfwnu9mu7a.fsf@HIDDEN>
 <83k0q9fr91.fsf@HIDDEN> <xjfk0q9mrol.fsf@HIDDEN>
 <838s6ofnr7.fsf@HIDDEN>
Date: Mon, 15 Mar 2021 15:43:07 +0000
In-Reply-To: <838s6ofnr7.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 15 Mar
 2021 17:19:24 +0200")
Message-ID: <xjfh7lczalw.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> One issue that I have in my notes about native-comp is the issue with
> input encoding of the source we submit to the native-compiler.
>
> The issue is this: our Lisp files are generally encoded in UTF-8.  But
> there's no guarantee that GCC expects the source to be encoded in
> UTF-8.  If the text we submit to libgccjit for compilation is in the
> same encoding as the original .el files, then shouldn't we tell GCC
> its actual encoding, to make sure non-ASCII text aren't mangled?

The only generated text we are passing to libgccjit is feed to
'gcc_jit_context_new_string_literal'.  This text is generated from
'Fprin1_to_string' that we use to essentially render in form of text
immediate objects.  I thought this was disconnected from the encoding of
the source file, am I wrong?

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 15 Mar 2021 15:19:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 15 11:19:24 2021
Received: from localhost ([127.0.0.1]:36384 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lLp08-00063B-Jd
	for submit <at> debbugs.gnu.org; Mon, 15 Mar 2021 11:19:24 -0400
Received: from eggs.gnu.org ([209.51.188.92]:50850)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lLp05-00062x-Js
 for 43725 <at> debbugs.gnu.org; Mon, 15 Mar 2021 11:19:23 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:43860)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lLozz-0008Fy-QV; Mon, 15 Mar 2021 11:19:15 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2031
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lLozy-0003Yv-IB; Mon, 15 Mar 2021 11:19:15 -0400
Date: Mon, 15 Mar 2021 17:19:24 +0200
Message-Id: <838s6ofnr7.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfk0q9mrol.fsf@HIDDEN> (message from Andrea Corallo on Sun, 14
 Mar 2021 20:00:26 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
 <xjfk0qfrvwa.fsf@HIDDEN> <83v99znizq.fsf@HIDDEN>
 <xjfpn07qafm.fsf@HIDDEN> <83o8frnf2r.fsf@HIDDEN>
 <xjfh7ljq7nh.fsf@HIDDEN> <xjf5z1z3pmi.fsf@HIDDEN>
 <83r1khfy5d.fsf@HIDDEN> <xjfwnu9mu7a.fsf@HIDDEN>
 <83k0q9fr91.fsf@HIDDEN> <xjfk0q9mrol.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

One issue that I have in my notes about native-comp is the issue with
input encoding of the source we submit to the native-compiler.

The issue is this: our Lisp files are generally encoded in UTF-8.  But
there's no guarantee that GCC expects the source to be encoded in
UTF-8.  If the text we submit to libgccjit for compilation is in the
same encoding as the original .el files, then shouldn't we tell GCC
its actual encoding, to make sure non-ASCII text aren't mangled?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 15 Mar 2021 14:57:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 15 10:57:34 2021
Received: from localhost ([127.0.0.1]:36340 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lLof0-0005Sq-BD
	for submit <at> debbugs.gnu.org; Mon, 15 Mar 2021 10:57:34 -0400
Received: from eggs.gnu.org ([209.51.188.92]:45546)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lLoex-0005SY-3f
 for 43725 <at> debbugs.gnu.org; Mon, 15 Mar 2021 10:57:32 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:43259)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lLoeq-00072E-OK; Mon, 15 Mar 2021 10:57:24 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4572
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lLoen-0006xL-JW; Mon, 15 Mar 2021 10:57:22 -0400
Date: Mon, 15 Mar 2021 16:57:31 +0200
Message-Id: <83a6r4foro.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: akrl@HIDDEN
In-Reply-To: <83k0q9fr91.fsf@HIDDEN> (message from Eli Zaretskii on Sun, 14
 Mar 2021 21:51:38 +0200)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
 <xjfk0qfrvwa.fsf@HIDDEN> <83v99znizq.fsf@HIDDEN>
 <xjfpn07qafm.fsf@HIDDEN> <83o8frnf2r.fsf@HIDDEN>
 <xjfh7ljq7nh.fsf@HIDDEN> <xjf5z1z3pmi.fsf@HIDDEN>
 <83r1khfy5d.fsf@HIDDEN> <xjfwnu9mu7a.fsf@HIDDEN> <83k0q9fr91.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Date: Sun, 14 Mar 2021 21:51:38 +0200
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
> 
> I will go over the code and replace 'concat' where needed.

Done.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 14 Mar 2021 20:00:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 14 16:00:30 2021
Received: from localhost ([127.0.0.1]:34258 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lLWuc-0000dR-D0
	for submit <at> debbugs.gnu.org; Sun, 14 Mar 2021 16:00:30 -0400
Received: from mx.sdf.org ([205.166.94.24]:54858)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lLWuZ-0000dI-UL
 for 43725 <at> debbugs.gnu.org; Sun, 14 Mar 2021 16:00:29 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 12EK0QvG018959
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Sun, 14 Mar 2021 20:00:27 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
 <xjfk0qfrvwa.fsf@HIDDEN> <83v99znizq.fsf@HIDDEN>
 <xjfpn07qafm.fsf@HIDDEN> <83o8frnf2r.fsf@HIDDEN>
 <xjfh7ljq7nh.fsf@HIDDEN> <xjf5z1z3pmi.fsf@HIDDEN>
 <83r1khfy5d.fsf@HIDDEN> <xjfwnu9mu7a.fsf@HIDDEN>
 <83k0q9fr91.fsf@HIDDEN>
Date: Sun, 14 Mar 2021 20:00:26 +0000
In-Reply-To: <83k0q9fr91.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 14 Mar
 2021 21:51:38 +0200")
Message-ID: <xjfk0q9mrol.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
>> Date: Sun, 14 Mar 2021 19:06:01 +0000
>> 
>> Probably in this case I thought that because I've used
>> Ffile_name_as_directory its output could just be concatenated without
>> having to use Fexpand_file_name.
>> 
>> Is this practice incorrect or dangerous?
>
> It's "not recommended".  The reason is that expand-file-name deals
> with irregularities such as multiple consecutive slashes, unibyte vs
> multibyte strings, drive letters on MS-Windows, etc., and 'concat'
> doesn't.

I probably thought there was safe by construction but I see your point.

> I will go over the code and replace 'concat' where needed.

Thanks (again)

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 14 Mar 2021 19:51:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 14 15:51:36 2021
Received: from localhost ([127.0.0.1]:34250 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lLWm0-0000Oz-5s
	for submit <at> debbugs.gnu.org; Sun, 14 Mar 2021 15:51:36 -0400
Received: from eggs.gnu.org ([209.51.188.92]:51134)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lLWlz-0000Om-4F
 for 43725 <at> debbugs.gnu.org; Sun, 14 Mar 2021 15:51:35 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:58485)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lLWlt-0005aN-CI; Sun, 14 Mar 2021 15:51:29 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1553
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lLWls-00074s-Ow; Sun, 14 Mar 2021 15:51:29 -0400
Date: Sun, 14 Mar 2021 21:51:38 +0200
Message-Id: <83k0q9fr91.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfwnu9mu7a.fsf@HIDDEN> (message from Andrea Corallo on Sun, 14
 Mar 2021 19:06:01 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
 <xjfk0qfrvwa.fsf@HIDDEN> <83v99znizq.fsf@HIDDEN>
 <xjfpn07qafm.fsf@HIDDEN> <83o8frnf2r.fsf@HIDDEN>
 <xjfh7ljq7nh.fsf@HIDDEN> <xjf5z1z3pmi.fsf@HIDDEN>
 <83r1khfy5d.fsf@HIDDEN> <xjfwnu9mu7a.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
> Date: Sun, 14 Mar 2021 19:06:01 +0000
> 
> Probably in this case I thought that because I've used
> Ffile_name_as_directory its output could just be concatenated without
> having to use Fexpand_file_name.
> 
> Is this practice incorrect or dangerous?

It's "not recommended".  The reason is that expand-file-name deals
with irregularities such as multiple consecutive slashes, unibyte vs
multibyte strings, drive letters on MS-Windows, etc., and 'concat'
doesn't.

I will go over the code and replace 'concat' where needed.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 14 Mar 2021 19:06:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 14 15:06:04 2021
Received: from localhost ([127.0.0.1]:34218 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lLW3w-0007T7-4L
	for submit <at> debbugs.gnu.org; Sun, 14 Mar 2021 15:06:04 -0400
Received: from mx.sdf.org ([205.166.94.24]:57342)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lLW3u-0007T0-WA
 for 43725 <at> debbugs.gnu.org; Sun, 14 Mar 2021 15:06:03 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 12EJ617e012853
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Sun, 14 Mar 2021 19:06:02 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
 <xjfk0qfrvwa.fsf@HIDDEN> <83v99znizq.fsf@HIDDEN>
 <xjfpn07qafm.fsf@HIDDEN> <83o8frnf2r.fsf@HIDDEN>
 <xjfh7ljq7nh.fsf@HIDDEN> <xjf5z1z3pmi.fsf@HIDDEN>
 <83r1khfy5d.fsf@HIDDEN>
Date: Sun, 14 Mar 2021 19:06:01 +0000
In-Reply-To: <83r1khfy5d.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 14 Mar
 2021 19:22:38 +0200")
Message-ID: <xjfwnu9mu7a.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Andrea, I see in comp.c and comp.el you many times use 'concat'
> instead of expand-file-name to construct a file name from the leading
> directories and a basename.  Sometimes even a mix of the two.  Here's
> one example:
>
>   return Fexpand_file_name (filename,
> 			    concat2 (Ffile_name_as_directory (base_dir),
> 				     Vcomp_native_version_dir));
>
> Is there a reason for using 'concat' in these cases?  E.g., the above
> could be written as
>
>   return Fexpand_file_name (filename
>   	 		    Fexpand_file_name (Vcomp_native_version_dir,
> 			   		       base_dir));
>
> which also makes only 2 function calls instead of 3.  Am I missing
> something?

I guess is more likely that *I* missed something here :)

Probably in this case I thought that because I've used
Ffile_name_as_directory its output could just be concatenated without
having to use Fexpand_file_name.

Is this practice incorrect or dangerous?

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 14 Mar 2021 17:22:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 14 13:22:41 2021
Received: from localhost ([127.0.0.1]:34137 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lLURt-0004PD-GZ
	for submit <at> debbugs.gnu.org; Sun, 14 Mar 2021 13:22:41 -0400
Received: from eggs.gnu.org ([209.51.188.92]:53334)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lLURr-0004Oz-6E
 for 43725 <at> debbugs.gnu.org; Sun, 14 Mar 2021 13:22:40 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:55653)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lLURl-0003HY-6s; Sun, 14 Mar 2021 13:22:33 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4365
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lLURh-0001AE-WE; Sun, 14 Mar 2021 13:22:30 -0400
Date: Sun, 14 Mar 2021 19:22:38 +0200
Message-Id: <83r1khfy5d.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjf5z1z3pmi.fsf@HIDDEN> (message from Andrea Corallo on Wed, 10
 Mar 2021 17:06:13 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
 <xjfk0qfrvwa.fsf@HIDDEN> <83v99znizq.fsf@HIDDEN>
 <xjfpn07qafm.fsf@HIDDEN> <83o8frnf2r.fsf@HIDDEN>
 <xjfh7ljq7nh.fsf@HIDDEN> <xjf5z1z3pmi.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Andrea, I see in comp.c and comp.el you many times use 'concat'
instead of expand-file-name to construct a file name from the leading
directories and a basename.  Sometimes even a mix of the two.  Here's
one example:

  return Fexpand_file_name (filename,
			    concat2 (Ffile_name_as_directory (base_dir),
				     Vcomp_native_version_dir));

Is there a reason for using 'concat' in these cases?  E.g., the above
could be written as

  return Fexpand_file_name (filename
  	 		    Fexpand_file_name (Vcomp_native_version_dir,
			   		       base_dir));

which also makes only 2 function calls instead of 3.  Am I missing
something?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 10 Mar 2021 17:06:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 10 12:06:20 2021
Received: from localhost ([127.0.0.1]:51751 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lK2Hr-0002YZ-KM
	for submit <at> debbugs.gnu.org; Wed, 10 Mar 2021 12:06:19 -0500
Received: from mx.sdf.org ([205.166.94.24]:64427)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lK2Hp-0002YL-2m
 for 43725 <at> debbugs.gnu.org; Wed, 10 Mar 2021 12:06:17 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 12AH6D9G010559
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Wed, 10 Mar 2021 17:06:13 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
 <xjfk0qfrvwa.fsf@HIDDEN> <83v99znizq.fsf@HIDDEN>
 <xjfpn07qafm.fsf@HIDDEN> <83o8frnf2r.fsf@HIDDEN>
 <xjfh7ljq7nh.fsf@HIDDEN>
Date: Wed, 10 Mar 2021 17:06:13 +0000
In-Reply-To: <xjfh7ljq7nh.fsf@HIDDEN> (Andrea Corallo via's message of "Wed, 
 10 Mar 2021 16:45:54 +0000")
Message-ID: <xjf5z1z3pmi.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
text editors" <bug-gnu-emacs@HIDDEN> writes:

> Eli Zaretskii <eliz@HIDDEN> writes:
>
>>> From: Andrea Corallo <akrl@HIDDEN>
>>> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
>>> Date: Wed, 10 Mar 2021 15:45:49 +0000
>>> 
>>> this is not expected and I cannot reproduce it here.
>>
>> OK, so just to be sure we are taking about the same scenario:
>>
>>   . I touch comp.el while a comp-NNNNN.eln already exists in
>>     ~/.emacs.d/eln-cache.
>>   . I then start "emacs -Q" and invoke "C-h f" for some function whose
>>     .el file doesn't yet have a .eln file.  For example,
>>
>>         C-h f ruler-mode RET
>>
>>   . What I see next is that Emacs starts compiling in the background,
>>     and I later find that both ruler-mode.el and comp.el have been
>>     natively-compiled.
>>
>> Hmmm... now I see that it doesn't happen every time.  So I guess some
>> additional factor is at work here, indeed.
>>
>>> The file is hashed using the content + its filename so access and
>>> modification times should not come into play.  Are we sure the file
>>> content wasn't modified?
>>
>> The file wasn't modified, that's for sure.
>>
>>> Or we might be possibly looking at different issue here.
>>
>> Probably.  I'll try to step through the code, but could you give me
>> some pointers: where do we decide whether to native-compile a file
>> that we load?
>
> The triggering point we are interested in here should be
> 'maybe_defer_native_compilation' (called by 'Fdefalias').

Sorry thinking about I believe for this case would be more interesting
to see why 'maybe_swap_for_eln' is failing to find the corresponding
.eln.  This is called in 'openp'.

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 10 Mar 2021 17:06:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 10 12:06:22 2021
Received: from localhost ([127.0.0.1]:51754 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lK2Ht-0002Yp-VN
	for submit <at> debbugs.gnu.org; Wed, 10 Mar 2021 12:06:22 -0500
Received: from lists.gnu.org ([209.51.188.17]:41784)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lK2Ht-0002Yi-DC
 for submit <at> debbugs.gnu.org; Wed, 10 Mar 2021 12:06:21 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:60690)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>) id 1lK2Ht-0005p8-5M
 for bug-gnu-emacs@HIDDEN; Wed, 10 Mar 2021 12:06:21 -0500
Received: from mx.sdf.org ([205.166.94.24]:64421)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>)
 id 1lK2Hr-0000GT-5P; Wed, 10 Mar 2021 12:06:20 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 12AH6D9G010559
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Wed, 10 Mar 2021 17:06:13 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
 <xjfk0qfrvwa.fsf@HIDDEN> <83v99znizq.fsf@HIDDEN>
 <xjfpn07qafm.fsf@HIDDEN> <83o8frnf2r.fsf@HIDDEN>
 <xjfh7ljq7nh.fsf@HIDDEN>
Date: Wed, 10 Mar 2021 17:06:13 +0000
In-Reply-To: <xjfh7ljq7nh.fsf@HIDDEN> (Andrea Corallo via's message of "Wed, 
 10 Mar 2021 16:45:54 +0000")
Message-ID: <xjf5z1z3pmi.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
Received-SPF: pass client-ip=205.166.94.24; envelope-from=akrl@HIDDEN;
 helo=mx.sdf.org
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
text editors" <bug-gnu-emacs@HIDDEN> writes:

> Eli Zaretskii <eliz@HIDDEN> writes:
>
>>> From: Andrea Corallo <akrl@HIDDEN>
>>> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
>>> Date: Wed, 10 Mar 2021 15:45:49 +0000
>>> 
>>> this is not expected and I cannot reproduce it here.
>>
>> OK, so just to be sure we are taking about the same scenario:
>>
>>   . I touch comp.el while a comp-NNNNN.eln already exists in
>>     ~/.emacs.d/eln-cache.
>>   . I then start "emacs -Q" and invoke "C-h f" for some function whose
>>     .el file doesn't yet have a .eln file.  For example,
>>
>>         C-h f ruler-mode RET
>>
>>   . What I see next is that Emacs starts compiling in the background,
>>     and I later find that both ruler-mode.el and comp.el have been
>>     natively-compiled.
>>
>> Hmmm... now I see that it doesn't happen every time.  So I guess some
>> additional factor is at work here, indeed.
>>
>>> The file is hashed using the content + its filename so access and
>>> modification times should not come into play.  Are we sure the file
>>> content wasn't modified?
>>
>> The file wasn't modified, that's for sure.
>>
>>> Or we might be possibly looking at different issue here.
>>
>> Probably.  I'll try to step through the code, but could you give me
>> some pointers: where do we decide whether to native-compile a file
>> that we load?
>
> The triggering point we are interested in here should be
> 'maybe_defer_native_compilation' (called by 'Fdefalias').

Sorry thinking about I believe for this case would be more interesting
to see why 'maybe_swap_for_eln' is failing to find the corresponding
.eln.  This is called in 'openp'.

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 10 Mar 2021 16:46:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 10 11:46:00 2021
Received: from localhost ([127.0.0.1]:51719 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lK1yC-00023C-AK
	for submit <at> debbugs.gnu.org; Wed, 10 Mar 2021 11:46:00 -0500
Received: from mx.sdf.org ([205.166.94.24]:49746)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lK1y9-00022w-Kk
 for 43725 <at> debbugs.gnu.org; Wed, 10 Mar 2021 11:45:58 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 12AGjsIf014311
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Wed, 10 Mar 2021 16:45:54 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
 <xjfk0qfrvwa.fsf@HIDDEN> <83v99znizq.fsf@HIDDEN>
 <xjfpn07qafm.fsf@HIDDEN> <83o8frnf2r.fsf@HIDDEN>
Date: Wed, 10 Mar 2021 16:45:54 +0000
In-Reply-To: <83o8frnf2r.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 10 Mar
 2021 18:33:48 +0200")
Message-ID: <xjfh7ljq7nh.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
>> Date: Wed, 10 Mar 2021 15:45:49 +0000
>> 
>> this is not expected and I cannot reproduce it here.
>
> OK, so just to be sure we are taking about the same scenario:
>
>   . I touch comp.el while a comp-NNNNN.eln already exists in
>     ~/.emacs.d/eln-cache.
>   . I then start "emacs -Q" and invoke "C-h f" for some function whose
>     .el file doesn't yet have a .eln file.  For example,
>
>         C-h f ruler-mode RET
>
>   . What I see next is that Emacs starts compiling in the background,
>     and I later find that both ruler-mode.el and comp.el have been
>     natively-compiled.
>
> Hmmm... now I see that it doesn't happen every time.  So I guess some
> additional factor is at work here, indeed.
>
>> The file is hashed using the content + its filename so access and
>> modification times should not come into play.  Are we sure the file
>> content wasn't modified?
>
> The file wasn't modified, that's for sure.
>
>> Or we might be possibly looking at different issue here.
>
> Probably.  I'll try to step through the code, but could you give me
> some pointers: where do we decide whether to native-compile a file
> that we load?

The triggering point we are interested in here should be
'maybe_defer_native_compilation' (called by 'Fdefalias').

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 10 Mar 2021 16:34:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 10 11:34:01 2021
Received: from localhost ([127.0.0.1]:51697 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lK1mb-0001lb-Et
	for submit <at> debbugs.gnu.org; Wed, 10 Mar 2021 11:34:01 -0500
Received: from eggs.gnu.org ([209.51.188.92]:53714)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lK1mZ-0001lO-Bt
 for 43725 <at> debbugs.gnu.org; Wed, 10 Mar 2021 11:33:59 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:37107)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lK1mS-0005lx-2g; Wed, 10 Mar 2021 11:33:52 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2608
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lK1mQ-0002lB-Qc; Wed, 10 Mar 2021 11:33:51 -0500
Date: Wed, 10 Mar 2021 18:33:48 +0200
Message-Id: <83o8frnf2r.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfpn07qafm.fsf@HIDDEN> (message from Andrea Corallo on Wed, 10
 Mar 2021 15:45:49 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
 <xjfk0qfrvwa.fsf@HIDDEN> <83v99znizq.fsf@HIDDEN>
 <xjfpn07qafm.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
> Date: Wed, 10 Mar 2021 15:45:49 +0000
> 
> this is not expected and I cannot reproduce it here.

OK, so just to be sure we are taking about the same scenario:

  . I touch comp.el while a comp-NNNNN.eln already exists in
    ~/.emacs.d/eln-cache.
  . I then start "emacs -Q" and invoke "C-h f" for some function whose
    .el file doesn't yet have a .eln file.  For example,

        C-h f ruler-mode RET

  . What I see next is that Emacs starts compiling in the background,
    and I later find that both ruler-mode.el and comp.el have been
    natively-compiled.

Hmmm... now I see that it doesn't happen every time.  So I guess some
additional factor is at work here, indeed.

> The file is hashed using the content + its filename so access and
> modification times should not come into play.  Are we sure the file
> content wasn't modified?

The file wasn't modified, that's for sure.

> Or we might be possibly looking at different issue here.

Probably.  I'll try to step through the code, but could you give me
some pointers: where do we decide whether to native-compile a file
that we load?

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 10 Mar 2021 15:45:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 10 10:45:54 2021
Received: from localhost ([127.0.0.1]:51645 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lK121-0000Yn-UC
	for submit <at> debbugs.gnu.org; Wed, 10 Mar 2021 10:45:54 -0500
Received: from mx.sdf.org ([205.166.94.24]:54402)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lK120-0000Yd-0H
 for 43725 <at> debbugs.gnu.org; Wed, 10 Mar 2021 10:45:52 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 12AFjn1T002032
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Wed, 10 Mar 2021 15:45:50 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
 <xjfk0qfrvwa.fsf@HIDDEN> <83v99znizq.fsf@HIDDEN>
Date: Wed, 10 Mar 2021 15:45:49 +0000
In-Reply-To: <83v99znizq.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 10 Mar
 2021 17:09:13 +0200")
Message-ID: <xjfpn07qafm.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> If I do this:
>
>    $ touch lisp/emacs-lisp/comp.el
>    $ ./src/emacs -Q
>    C-h f apropos RET
>
> then I see that Emacs starts natively-compiling comp.el, even though I
> already have a comp.eln file in the eln-cache.
>
> This is unlike what happens with the .elc files, where Emacs will
> never byte-compile a file without my say-so.  I could perhaps
> understand the automatic compilation if there was no .eln file
> anywhere in sight, but why should Emacs automatically compile Lisp
> files it loads when a .eln file for them does exist?
>
> Does this happen with any .el file, or is comp.el special in some
> sense?
>
> One situation where this gets in the way is when I make some changes
> in a .el file because I'm testing something or debugging some problem.
> In those cases I usually load a .el file manually and later either
> undo the changes or make them permanent, and re-byte-compile at that
> time.  But with natively-compilation it sounds like I've lost control
> on when the file is compiled and which version of it is compiled.
>
> Is this a reasonable default behavior?  Maybe it is reasonable for
> users who just use Emacs.  But for developers that constantly make
> changes in .el files this could be a nuisance, at least sometimes.

Hi Eli,

this is not expected and I cannot reproduce it here.

The file is hashed using the content + its filename so access and
modification times should not come into play.  Are we sure the file
content wasn't modified?  Or we might be possibly looking at different
issue here.

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 10 Mar 2021 15:09:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 10 10:09:28 2021
Received: from localhost ([127.0.0.1]:51549 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lK0Sm-0003qd-5u
	for submit <at> debbugs.gnu.org; Wed, 10 Mar 2021 10:09:28 -0500
Received: from eggs.gnu.org ([209.51.188.92]:56214)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lK0Sk-0003qS-RP
 for 43725 <at> debbugs.gnu.org; Wed, 10 Mar 2021 10:09:27 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:34876)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lK0Se-0006mP-L9; Wed, 10 Mar 2021 10:09:20 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1050
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lK0Sc-00082q-Hc; Wed, 10 Mar 2021 10:09:19 -0500
Date: Wed, 10 Mar 2021 17:09:13 +0200
Message-Id: <83v99znizq.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfk0qfrvwa.fsf@HIDDEN> (message from Andrea Corallo on Wed, 10
 Mar 2021 13:16:53 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
 <xjfk0qfrvwa.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

If I do this:

   $ touch lisp/emacs-lisp/comp.el
   $ ./src/emacs -Q
   C-h f apropos RET

then I see that Emacs starts natively-compiling comp.el, even though I
already have a comp.eln file in the eln-cache.

This is unlike what happens with the .elc files, where Emacs will
never byte-compile a file without my say-so.  I could perhaps
understand the automatic compilation if there was no .eln file
anywhere in sight, but why should Emacs automatically compile Lisp
files it loads when a .eln file for them does exist?

Does this happen with any .el file, or is comp.el special in some
sense?

One situation where this gets in the way is when I make some changes
in a .el file because I'm testing something or debugging some problem.
In those cases I usually load a .el file manually and later either
undo the changes or make them permanent, and re-byte-compile at that
time.  But with natively-compilation it sounds like I've lost control
on when the file is compiled and which version of it is compiled.

Is this a reasonable default behavior?  Maybe it is reasonable for
users who just use Emacs.  But for developers that constantly make
changes in .el files this could be a nuisance, at least sometimes.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 10 Mar 2021 13:16:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 10 08:16:56 2021
Received: from localhost ([127.0.0.1]:49141 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lJyhs-0004X5-AH
	for submit <at> debbugs.gnu.org; Wed, 10 Mar 2021 08:16:56 -0500
Received: from mx.sdf.org ([205.166.94.24]:51784)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lJyhq-0004Wx-Dz
 for 43725 <at> debbugs.gnu.org; Wed, 10 Mar 2021 08:16:55 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 12ADGr5I016527
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Wed, 10 Mar 2021 13:16:53 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
 <xjf7dmgt7hc.fsf@HIDDEN> <837dmfp2x7.fsf@HIDDEN>
Date: Wed, 10 Mar 2021 13:16:53 +0000
In-Reply-To: <837dmfp2x7.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 10 Mar
 2021 15:13:24 +0200")
Message-ID: <xjfk0qfrvwa.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
>> Date: Tue, 09 Mar 2021 20:09:03 +0000
>> 
>> >> > Looking at a running Emacs, I see that it loads the *.eln files that
>> >> > are preloaded.  I would expect those to be dumped into the emacs.pdmp
>> >> > file, as it happens with *.elc files.  If all the stuff is dumped into
>> >> > emacs.pdmp and loaded from there, why does Emacs still need to load
>> >> > those *.eln files as shared libraries?
>> >> 
>> >> For loaded you mean entering in 'load_comp_unit'?
>> >
>> > I looked at the shared libraries loaded by the program as shown by the
>> > GDB "info sharedlibrary" command.
>> 
>> Okay, that's normal.  The pdumper is dumping only the pseudovector
>> representing the CU.  When the image is loaded pdumper calls
>> 'load_comp_unit' to have the dynamic linker map again the .eln into
>> memory.
>
> This means that, unlike with preloaded *.elc files, one cannot delete
> the preloaded *.eln files once the pdumper file is created, because
> the *.eln files are still needed each time Emacs starts.

Precisely.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 10 Mar 2021 13:13:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 10 08:13:43 2021
Received: from localhost ([127.0.0.1]:49130 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lJyel-0004Pi-HZ
	for submit <at> debbugs.gnu.org; Wed, 10 Mar 2021 08:13:43 -0500
Received: from eggs.gnu.org ([209.51.188.92]:55814)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lJyej-0004PU-B1
 for 43725 <at> debbugs.gnu.org; Wed, 10 Mar 2021 08:13:41 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:60901)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lJyec-0007Id-Nr; Wed, 10 Mar 2021 08:13:35 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1740
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lJyeV-00012i-Di; Wed, 10 Mar 2021 08:13:33 -0500
Date: Wed, 10 Mar 2021 15:13:24 +0200
Message-Id: <837dmfp2x7.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjf7dmgt7hc.fsf@HIDDEN> (message from Andrea Corallo on Tue, 09
 Mar 2021 20:09:03 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN> <xjf7dmgt7hc.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
> Date: Tue, 09 Mar 2021 20:09:03 +0000
> 
> >> > Looking at a running Emacs, I see that it loads the *.eln files that
> >> > are preloaded.  I would expect those to be dumped into the emacs.pdmp
> >> > file, as it happens with *.elc files.  If all the stuff is dumped into
> >> > emacs.pdmp and loaded from there, why does Emacs still need to load
> >> > those *.eln files as shared libraries?
> >> 
> >> For loaded you mean entering in 'load_comp_unit'?
> >
> > I looked at the shared libraries loaded by the program as shown by the
> > GDB "info sharedlibrary" command.
> 
> Okay, that's normal.  The pdumper is dumping only the pseudovector
> representing the CU.  When the image is loaded pdumper calls
> 'load_comp_unit' to have the dynamic linker map again the .eln into
> memory.

This means that, unlike with preloaded *.elc files, one cannot delete
the preloaded *.eln files once the pdumper file is created, because
the *.eln files are still needed each time Emacs starts.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 9 Mar 2021 20:09:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Mar 09 15:09:11 2021
Received: from localhost ([127.0.0.1]:48017 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lJifG-0006JG-Tm
	for submit <at> debbugs.gnu.org; Tue, 09 Mar 2021 15:09:11 -0500
Received: from mx.sdf.org ([205.166.94.24]:61228)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lJifC-0006J4-9U
 for 43725 <at> debbugs.gnu.org; Tue, 09 Mar 2021 15:09:09 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 129K930p026791
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Tue, 9 Mar 2021 20:09:04 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN> <83k0qgp0hj.fsf@HIDDEN>
Date: Tue, 09 Mar 2021 20:09:03 +0000
In-Reply-To: <83k0qgp0hj.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 09 Mar
 2021 21:53:44 +0200")
Message-ID: <xjf7dmgt7hc.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
>> Date: Tue, 09 Mar 2021 19:28:19 +0000
>> 
>> > Looking at a running Emacs, I see that it loads the *.eln files that
>> > are preloaded.  I would expect those to be dumped into the emacs.pdmp
>> > file, as it happens with *.elc files.  If all the stuff is dumped into
>> > emacs.pdmp and loaded from there, why does Emacs still need to load
>> > those *.eln files as shared libraries?
>> 
>> For loaded you mean entering in 'load_comp_unit'?
>
> I looked at the shared libraries loaded by the program as shown by the
> GDB "info sharedlibrary" command.

Okay, that's normal.  The pdumper is dumping only the pseudovector
representing the CU.  When the image is loaded pdumper calls
'load_comp_unit' to have the dynamic linker map again the .eln into
memory.

I think here [1] at the time I wrote something about the reasons why I
ended-up with this solution, but the long story short is that the only
affordable and reliable way to have this job done is to ask the dynamic
linker to do it.

  Andrea

[1] <http://akrl.sdf.org/gccemacs.html#orgc59fae6>




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 9 Mar 2021 19:54:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Mar 09 14:54:06 2021
Received: from localhost ([127.0.0.1]:48013 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lJiQg-0003se-Hs
	for submit <at> debbugs.gnu.org; Tue, 09 Mar 2021 14:54:06 -0500
Received: from eggs.gnu.org ([209.51.188.92]:46260)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lJiQd-0003s9-4Q
 for 43725 <at> debbugs.gnu.org; Tue, 09 Mar 2021 14:54:05 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:44769)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lJiQX-0002eE-CC; Tue, 09 Mar 2021 14:53:57 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1472
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lJiQO-0004nb-4x; Tue, 09 Mar 2021 14:53:51 -0500
Date: Tue, 09 Mar 2021 21:53:44 +0200
Message-Id: <83k0qgp0hj.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfft14t9d8.fsf@HIDDEN> (message from Andrea Corallo on Tue, 09
 Mar 2021 19:28:19 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
 <xjfft14t9d8.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
> Date: Tue, 09 Mar 2021 19:28:19 +0000
> 
> > Looking at a running Emacs, I see that it loads the *.eln files that
> > are preloaded.  I would expect those to be dumped into the emacs.pdmp
> > file, as it happens with *.elc files.  If all the stuff is dumped into
> > emacs.pdmp and loaded from there, why does Emacs still need to load
> > those *.eln files as shared libraries?
> 
> For loaded you mean entering in 'load_comp_unit'?

I looked at the shared libraries loaded by the program as shown by the
GDB "info sharedlibrary" command.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 9 Mar 2021 19:28:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Mar 09 14:28:23 2021
Received: from localhost ([127.0.0.1]:47967 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lJi1m-0001AK-Po
	for submit <at> debbugs.gnu.org; Tue, 09 Mar 2021 14:28:23 -0500
Received: from mx.sdf.org ([205.166.94.24]:49367)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lJi1k-0001AB-KA
 for 43725 <at> debbugs.gnu.org; Tue, 09 Mar 2021 14:28:21 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 129JSJZF014035
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Tue, 9 Mar 2021 19:28:19 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
 <xjfa6rqfwxj.fsf@HIDDEN> <83lfawp2cc.fsf@HIDDEN>
Date: Tue, 09 Mar 2021 19:28:19 +0000
In-Reply-To: <83lfawp2cc.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 09 Mar
 2021 21:13:39 +0200")
Message-ID: <xjfft14t9d8.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Date: Fri, 26 Feb 2021 19:31:20 +0000
>> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
>> 
>> >> Thinking about if we don't need to use shortcuts also
>> >> '--with-native-compiler' might be okay WDYT?
>> >
>> > That sounds less appropriate to me.
>> >
>> 
>> Okay, 42fc752a14 changes the configure flag into
>> '--with-native-compilation'.
>
> Thanks.
>
> Looking at a running Emacs, I see that it loads the *.eln files that
> are preloaded.  I would expect those to be dumped into the emacs.pdmp
> file, as it happens with *.elc files.  If all the stuff is dumped into
> emacs.pdmp and loaded from there, why does Emacs still need to load
> those *.eln files as shared libraries?

For loaded you mean entering in 'load_comp_unit'?

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 9 Mar 2021 19:13:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Mar 09 14:13:54 2021
Received: from localhost ([127.0.0.1]:47957 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lJhnm-0000p6-65
	for submit <at> debbugs.gnu.org; Tue, 09 Mar 2021 14:13:54 -0500
Received: from eggs.gnu.org ([209.51.188.92]:38394)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lJhnj-0000os-Lw
 for 43725 <at> debbugs.gnu.org; Tue, 09 Mar 2021 14:13:52 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:43914)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lJhnc-00036G-Qs; Tue, 09 Mar 2021 14:13:45 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2991
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lJhnb-0007HE-CU; Tue, 09 Mar 2021 14:13:44 -0500
Date: Tue, 09 Mar 2021 21:13:39 +0200
Message-Id: <83lfawp2cc.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfa6rqfwxj.fsf@HIDDEN> (message from Andrea Corallo on Fri, 26
 Feb 2021 19:31:20 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN> <xjfa6rqfwxj.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Date: Fri, 26 Feb 2021 19:31:20 +0000
> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
> 
> >> Thinking about if we don't need to use shortcuts also
> >> '--with-native-compiler' might be okay WDYT?
> >
> > That sounds less appropriate to me.
> >
> 
> Okay, 42fc752a14 changes the configure flag into
> '--with-native-compilation'.

Thanks.

Looking at a running Emacs, I see that it loads the *.eln files that
are preloaded.  I would expect those to be dumped into the emacs.pdmp
file, as it happens with *.elc files.  If all the stuff is dumped into
emacs.pdmp and loaded from there, why does Emacs still need to load
those *.eln files as shared libraries?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 26 Feb 2021 19:31:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 26 14:31:25 2021
Received: from localhost ([127.0.0.1]:42558 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lFipg-0003m8-QA
	for submit <at> debbugs.gnu.org; Fri, 26 Feb 2021 14:31:25 -0500
Received: from mx.sdf.org ([205.166.94.24]:50892)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lFipe-0003m0-7U
 for 43725 <at> debbugs.gnu.org; Fri, 26 Feb 2021 14:31:23 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11QJVKCe020560
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Fri, 26 Feb 2021 19:31:21 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
 <xjfsg5nkgqx.fsf@HIDDEN> <83k0qzv54q.fsf@HIDDEN>
Date: Fri, 26 Feb 2021 19:31:20 +0000
In-Reply-To: <83k0qzv54q.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 23 Feb
 2021 05:23:49 +0200")
Message-ID: <xjfa6rqfwxj.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: 43725 <at> debbugs.gnu.org, larsi@HIDDEN, monnier@HIDDEN
>> Date: Mon, 22 Feb 2021 20:08:22 +0000
>> 
>> Thinking about if we don't need to use shortcuts also
>> '--with-native-compiler' might be okay WDYT?
>
> That sounds less appropriate to me.
>

Okay, 42fc752a14 changes the configure flag into
'--with-native-compilation'.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 23 Feb 2021 03:24:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 22 22:24:07 2021
Received: from localhost ([127.0.0.1]:58033 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lEOIx-0002vx-AA
	for submit <at> debbugs.gnu.org; Mon, 22 Feb 2021 22:24:07 -0500
Received: from eggs.gnu.org ([209.51.188.92]:43434)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lEOIu-0002vT-I2
 for 43725 <at> debbugs.gnu.org; Mon, 22 Feb 2021 22:24:05 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:39618)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lEOIn-000231-UC; Mon, 22 Feb 2021 22:23:57 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1582
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lEOIn-0007VO-Bd; Mon, 22 Feb 2021 22:23:57 -0500
Date: Tue, 23 Feb 2021 05:23:49 +0200
Message-Id: <83k0qzv54q.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfsg5nkgqx.fsf@HIDDEN> (message from Andrea Corallo on Mon, 22
 Feb 2021 20:08:22 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN> <xjfsg5nkgqx.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: 43725 <at> debbugs.gnu.org, larsi@HIDDEN, monnier@HIDDEN
> Date: Mon, 22 Feb 2021 20:08:22 +0000
> 
> Thinking about if we don't need to use shortcuts also
> '--with-native-compiler' might be okay WDYT?

That sounds less appropriate to me.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 22 Feb 2021 20:52:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 22 15:52:42 2021
Received: from localhost ([127.0.0.1]:57718 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lEIC9-00024h-PO
	for submit <at> debbugs.gnu.org; Mon, 22 Feb 2021 15:52:42 -0500
Received: from mail-ot1-f53.google.com ([209.85.210.53]:46600)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1lEIC8-00024V-0W
 for 43725 <at> debbugs.gnu.org; Mon, 22 Feb 2021 15:52:40 -0500
Received: by mail-ot1-f53.google.com with SMTP id k13so2878808otn.13
 for <43725 <at> debbugs.gnu.org>; Mon, 22 Feb 2021 12:52:39 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=C8jcgeDwnK6OGjgZ5IzOd8cvxvyBxrKiFxqGU0mOHzw=;
 b=Y+gO9EOw91cD0Wd3udGSRYd2brgZEYAz+SjB2LrSOUORKT4zi8K12i5mIfmQMyVnXj
 Adm4Hie7A2gbURfiN8hpLs0qCDYCVCl+08Kcmd37bY/Gx4GPddDAgkN+03FoReFQTLtR
 Q6VB9TVLHksIBU4hij/KR/4EafXFdAGEz5skSTuaS8mrnFXtlu0WpJhZNx3idGgg2pzR
 8HqOBxV7S7qWHowCjllpIqi02XXxt4KLfhlzrzICV1esNAVEQuq8JGrG97EbbXG+jaEx
 QCaS0vk9Q4OP9zShkxhppzAKj8r8uVM5lGbMeAstVFp6yzUWuMJ1dYzOlZoWh56L1uuZ
 aJnQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=C8jcgeDwnK6OGjgZ5IzOd8cvxvyBxrKiFxqGU0mOHzw=;
 b=Q3sdwDKUyf5U9e2bO8FsbTfqsbaENHJN9jHL8/46Q6n5CL99KR4WUel9M3ZLFHaW7I
 QGWLJEUHv6cm5cIXKAk+ggbuYik3u6j288StDoWyQDq6KRUom9o6Nx+vRRcK8g2XwTaG
 eOZIcpYmlKzORL9HfhQabI+AXp5A3YwsLIGUn15UUiB82zzkVkxJ+RnDLWvBvhsR735I
 656vGljTn3EhNIdT0ypll8kV8Sm9OEIgbLGzWalGdBdhNKRYKI105/64zYnO1SbH+feT
 sTHlp7EHkY3OLUskthvsxKNcqhi2V1K1nDe00qBhrcyRRLezsNNQn06xD7FideIPNy/T
 Xd+g==
X-Gm-Message-State: AOAM531rW97tHLkl6U+IrGIsIwOD/0ifoah5rKcw75Z1pX0z/IlPWRe0
 rySqOUI+/2oZa8dGTVSB7TRSgHZp7d+9d90F/ts=
X-Google-Smtp-Source: ABdhPJxSydwPQIJznlrcLSTKQ93nBU6x9o/+N9IvidAXpPnE8ciDpUcSJz+/6XPYc4TBCVQ3fECbfaQoVSB3C53OH0k=
X-Received: by 2002:a05:6830:1605:: with SMTP id
 g5mr18114083otr.292.1614027154207; 
 Mon, 22 Feb 2021 12:52:34 -0800 (PST)
MIME-Version: 1.0
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN> <xjfsg5nkgqx.fsf@HIDDEN>
In-Reply-To: <xjfsg5nkgqx.fsf@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Mon, 22 Feb 2021 20:51:58 +0000
Message-ID: <CAOqdjBe9B+T44znA4VX4pAgvJ5E8zbW+_SGUf+aOct_4xH92xg@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
To: Andrea Corallo <akrl@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Mon, Feb 22, 2021 at 8:09 PM Andrea Corallo via Bug reports for GNU
Emacs, the Swiss army knife of text editors <bug-gnu-emacs@HIDDEN>
wrote:
> Eli Zaretskii <eliz@HIDDEN> writes:
> >> From: Andrea Corallo <akrl@HIDDEN>
> > Yes, '--with-native-comp' sounds better.  Maybe even
> > '--with-native-compilation', even though it's longer.  (But since this
> > option will become ON by default, users will not have to type it in
> > most cases.)
>
> I pushed the change for having '--with-native-comp' but coming here to
> acknowledge that I recalled that also '--with-native-compilation' was
> suggested.  Cause I think is important to change it only once I reverted
> the commit.

I'm not sure about the --with-, though.
--enable-native-comp{,ilation,iler} might be more consistent with
other configures. (and --with-libgccjit would go with it)

> Thinking about if we don't need to use shortcuts also
> '--with-native-compiler' might be okay WDYT?
>
> Lets just pick the one we like and I'll make the change.

I still think it would be good to split out the ability to run
natively-compiled files from the ability to generate them. We should
plan for configure options for that.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 22 Feb 2021 20:08:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 22 15:08:26 2021
Received: from localhost ([127.0.0.1]:57682 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lEHVK-00010a-Mq
	for submit <at> debbugs.gnu.org; Mon, 22 Feb 2021 15:08:26 -0500
Received: from mx.sdf.org ([205.166.94.24]:63686)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lEHVI-00010R-DC
 for 43725 <at> debbugs.gnu.org; Mon, 22 Feb 2021 15:08:25 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11MK8Ms6024310
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Mon, 22 Feb 2021 20:08:23 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN> <83a6s04glg.fsf@HIDDEN>
Date: Mon, 22 Feb 2021 20:08:22 +0000
In-Reply-To: <83a6s04glg.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 19 Feb
 2021 10:16:59 +0200")
Message-ID: <xjfsg5nkgqx.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: 43725 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>,
>>         Lars Ingebrigtsen
>>  <larsi@HIDDEN>, monnier@HIDDEN
>> Date: Thu, 18 Feb 2021 21:58:32 +0000
>> 
>> Side question:  do we all agree that the current configure flag
>> '--with-nativecomp' should be '--with-native-comp'?
>
> Yes, '--with-native-comp' sounds better.  Maybe even
> '--with-native-compilation', even though it's longer.  (But since this
> option will become ON by default, users will not have to type it in
> most cases.)

I pushed the change for having '--with-native-comp' but coming here to
acknowledge that I recalled that also '--with-native-compilation' was
suggested.  Cause I think is important to change it only once I reverted
the commit.

Thinking about if we don't need to use shortcuts also
'--with-native-compiler' might be okay WDYT?

Lets just pick the one we like and I'll make the change.

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 20 Feb 2021 06:57:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 20 01:57:32 2021
Received: from localhost ([127.0.0.1]:50846 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lDMCq-0003gn-2Y
	for submit <at> debbugs.gnu.org; Sat, 20 Feb 2021 01:57:32 -0500
Received: from eggs.gnu.org ([209.51.188.92]:45464)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lDMCo-0003gb-Br
 for 43725 <at> debbugs.gnu.org; Sat, 20 Feb 2021 01:57:30 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:39903)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lDMCi-0004yc-Tx; Sat, 20 Feb 2021 01:57:24 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2097
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lDMCh-0006QE-LB; Sat, 20 Feb 2021 01:57:24 -0500
Date: Sat, 20 Feb 2021 08:57:10 +0200
Message-Id: <83mtvz1b21.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjf4ki7n2a3.fsf@HIDDEN> (message from Andrea Corallo on Fri, 19
 Feb 2021 22:03:32 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN> <83k0r53ygd.fsf@HIDDEN>
 <xjftuq9nln2.fsf@HIDDEN> <83im6o4hrc.fsf@HIDDEN>
 <xjf8s7knwdx.fsf@HIDDEN> <83tuq82qmb.fsf@HIDDEN>
 <xjf4ki7n2a3.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
> Date: Fri, 19 Feb 2021 22:03:32 +0000
> 
> Okay 14e6268d14 is arranging things as follow:
> 
>  #ifdef WIDE_EMACS_INT
>    if (val > LONG_MAX || val < LONG_MIN)
>      return emit_rvalue_from_unsigned_long_long (comp.emacs_uint_type, val);
>  #endif
>    return gcc_jit_context_new_rvalue_from_long (comp.ctxt,
>                                                 comp.emacs_uint_type,
>                                                 val);

Thanks.

> >> 'emit_rvalue_from_unsigned_long_long' was added by me as libgccjit so
> >> far has no long long support.  As this is shifting the numeric argument
> >> to emit the code that re-create the long long equivalent using an
> >> unsigned was the natural choice to avoid UB.
> >>
> >> Admittedly we could just cast inside
> >> 'emit_rvalue_from_unsigned_long_long' and rename it into
> >> 'emit_rvalue_from_long_long' but I'm not sure is that important.
> >
> > Either that, or some comment would be good enough.
> 
> I realized we already had also the signed variant so with 92fe7a91f4 I
> removed the unsigned one and we always use 'emit_rvalue_from_long_long'
> now.

Great, thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 19 Feb 2021 22:03:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 17:03:41 2021
Received: from localhost ([127.0.0.1]:50555 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lDDsD-0007v5-Jt
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 17:03:41 -0500
Received: from mx.sdf.org ([205.166.94.24]:54369)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lDDs8-0007us-V6
 for 43725 <at> debbugs.gnu.org; Fri, 19 Feb 2021 17:03:40 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11JM3Wkb017905
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Fri, 19 Feb 2021 22:03:33 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN> <83k0r53ygd.fsf@HIDDEN>
 <xjftuq9nln2.fsf@HIDDEN> <83im6o4hrc.fsf@HIDDEN>
 <xjf8s7knwdx.fsf@HIDDEN> <83tuq82qmb.fsf@HIDDEN>
Date: Fri, 19 Feb 2021 22:03:32 +0000
In-Reply-To: <83tuq82qmb.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 19 Feb
 2021 14:23:24 +0200")
Message-ID: <xjf4ki7n2a3.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: bug-gnu-emacs@HIDDEN, larsi@HIDDEN, monnier@HIDDEN,
>>         43725 <at> debbugs.gnu.org
>> Date: Fri, 19 Feb 2021 11:13:14 +0000
>>
>> >   #if EMACS_INT_MAX > LONG_MAX
>> >     return emit_rvalue_from_unsigned_long_long (...
>> >   #else
>> >     return gcc_jit_context_new_rvalue_from_long (...
>> >   #endif
>> >
>> > Does that work well?
>>
>> Unfortunately this is a compile time (for the native compiler)
>> decision.  If val fits into a long we want to emit simply that.
>
> OK, then how about my original proposal, viz.:
>
>   if (EMACS_INT_MAX > LONG_MAX)
>     {
>       if (val > LONG_MAX || val < LONG_MIN)
>         ...
>       else
>         ...
>     }
>
> You could also #ifdef this conditioned on WINDOWSNT, since MS-Windows
> is the only platform where this matters.

Okay 14e6268d14 is arranging things as follow:

 #ifdef WIDE_EMACS_INT
   if (val > LONG_MAX || val < LONG_MIN)
     return emit_rvalue_from_unsigned_long_long (comp.emacs_uint_type, val);
 #endif
   return gcc_jit_context_new_rvalue_from_long (comp.ctxt,
                                                comp.emacs_uint_type,
                                                val);


>> At this point I'm starting to think that the original formulation is
>> probably the lesser of evils.
>
> Believe me, it isn't.  For starters, it is not clear what it does.
>
>> 'emit_rvalue_from_unsigned_long_long' was added by me as libgccjit so
>> far has no long long support.  As this is shifting the numeric argument
>> to emit the code that re-create the long long equivalent using an
>> unsigned was the natural choice to avoid UB.
>>
>> Admittedly we could just cast inside
>> 'emit_rvalue_from_unsigned_long_long' and rename it into
>> 'emit_rvalue_from_long_long' but I'm not sure is that important.
>
> Either that, or some comment would be good enough.

I realized we already had also the signed variant so with 92fe7a91f4 I
removed the unsigned one and we always use 'emit_rvalue_from_long_long'
now.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 19 Feb 2021 17:33:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 12:33:14 2021
Received: from localhost ([127.0.0.1]:50309 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD9eT-0001Pg-Oz
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 12:33:14 -0500
Received: from lists.gnu.org ([209.51.188.17]:58966)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lD9eR-0001PY-EN
 for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 12:33:12 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:47334)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lD9eR-0007hZ-6S
 for bug-gnu-emacs@HIDDEN; Fri, 19 Feb 2021 12:33:11 -0500
Received: from ciao.gmane.io ([116.202.254.214]:42946)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lD9eO-0003hL-NX
 for bug-gnu-emacs@HIDDEN; Fri, 19 Feb 2021 12:33:10 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lD9eM-0005CD-Dy
 for bug-gnu-emacs@HIDDEN; Fri, 19 Feb 2021 18:33:06 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
Date: Fri, 19 Feb 2021 17:33:01 +0000
Message-ID: <86im6o55f6.fsf@HIDDEN>
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN>
 <CAOqdjBe_J1oXtaFv8v4PjYSbU2Hg=KLwSF-+WAT-VLCcXYUr-w@HIDDEN>
 <83im6o2n67.fsf@HIDDEN> <xjf4ki8nnvr.fsf@HIDDEN>
 <CAOqdjBfhH0azD90ATn6oxjabXSuBtSxaeDEmT6EOfys+9DUt5Q@HIDDEN>
 <xjfr1lcm8g0.fsf@HIDDEN>
 <CAOqdjBeGx6Bm1M3kd-tXpODcnB67nhVw6rTaEEo9sGdLHHmAOQ@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=gb2312
Content-Transfer-Encoding: 8bit
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (windows-nt)
Cancel-Lock: sha1:Q5pnw1cLfMJWxcYlxeWXd3bWW64=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 5
X-Spam_score: 0.5
X-Spam_bar: /
X-Spam_report: (0.5 / 5.0 requ) BAYES_00=-1.9, DKIM_ADSP_CUSTOM_MED=0.001,
 FORGED_GMAIL_RCVD=1, FREEMAIL_FORGED_FROMDOMAIN=0.249, FREEMAIL_FROM=0.001,
 HEADER_FROM_DIFFERENT_DOMAINS=0.249, NML_ADSP_CUSTOM_MED=0.9,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

On Fri 19 Feb 2021, Pip Cet wrote:

> On Fri, Feb 19, 2021 at 2:35 PM Andrea Corallo <akrl@HIDDEN> wrote:
>> > On Fri, Feb 19, 2021 at 2:16 PM Andrea Corallo <akrl@HIDDEN> wrote:
>> >> >> > comp.c:1174:22: warning: logical ¡®or¡¯ of collectively exhaustive tests is always true [-Wlogical-op]
>> >> >> >  1174 |   if (val > LONG_MAX || val < LONG_MIN)
>> >> >> >       |                      ^~
>> >> >> >
>> >> >> > Not sure what's the best way to silence it or if we want to revert to
>> >> >> > the previous formulation.
>> >> >>
>> >> >> Maybe it's me, but I had a hard time parsing that warning. IIUC, the
>> >> >> tests are both trivially false? And oring two trivially false
>> >> >> conditions shouldn't trigger a warning, should it?
>> >> >
>> >> > No, I think it tries to say that val is always either greater than
>> >> > LONG_MAX or smaller than LONG_MIN.
>> >>
>> >> Exactly, the warning is about the fact that all the other conditions
>> >> will never be evaluated.  The phrasing is admittedly quite cryptic tho.
>> >
>> > I thought you said this was a setup where the argument _does_ fit a long?
>>
>> There we are dispatching if 'val' can be expressed or not with a long.
>>
>> 'val' is an EMACS_INT so depending on the configuration it might fit in
>> a long by definition, when this happen GCC sees the first condition in
>> or as always true etc etc... :)
>
> So val is greater than LONG_MAX? How can this happen?

A 32bit emacs configured with "--with-wide-int" where EMACS_INT is wider
than long.

    AndyM





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 19 Feb 2021 15:11:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 10:11:15 2021
Received: from localhost ([127.0.0.1]:50114 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD7R4-00047z-Ul
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 10:11:15 -0500
Received: from mx.sdf.org ([205.166.94.24]:52610)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lD7R1-00047p-Jd
 for 43725 <at> debbugs.gnu.org; Fri, 19 Feb 2021 10:11:14 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11JFBABS012679
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Fri, 19 Feb 2021 15:11:10 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN>
 <CAOqdjBe_J1oXtaFv8v4PjYSbU2Hg=KLwSF-+WAT-VLCcXYUr-w@HIDDEN>
 <83im6o2n67.fsf@HIDDEN> <xjf4ki8nnvr.fsf@HIDDEN>
 <CAOqdjBfhH0azD90ATn6oxjabXSuBtSxaeDEmT6EOfys+9DUt5Q@HIDDEN>
 <xjfr1lcm8g0.fsf@HIDDEN>
 <CAOqdjBeGx6Bm1M3kd-tXpODcnB67nhVw6rTaEEo9sGdLHHmAOQ@HIDDEN>
Date: Fri, 19 Feb 2021 15:11:10 +0000
In-Reply-To: <CAOqdjBeGx6Bm1M3kd-tXpODcnB67nhVw6rTaEEo9sGdLHHmAOQ@HIDDEN>
 (Pip Cet's message of "Fri, 19 Feb 2021 15:00:16 +0000")
Message-ID: <xjfk0r4m6sx.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Pip Cet <pipcet@HIDDEN> writes:

> On Fri, Feb 19, 2021 at 2:35 PM Andrea Corallo <akrl@HIDDEN> wrote:
>> > On Fri, Feb 19, 2021 at 2:16 PM Andrea Corallo <akrl@HIDDEN> wrote:
>> >> >> > comp.c:1174:22: warning: logical =E2=80=98or=E2=80=99 of collect=
ively exhaustive tests is always true [-Wlogical-op]
>> >> >> >  1174 |   if (val > LONG_MAX || val < LONG_MIN)
>> >> >> >       |                      ^~
>> >> >> >
>> >> >> > Not sure what's the best way to silence it or if we want to reve=
rt to
>> >> >> > the previous formulation.
>> >> >>
>> >> >> Maybe it's me, but I had a hard time parsing that warning. IIUC, t=
he
>> >> >> tests are both trivially false? And oring two trivially false
>> >> >> conditions shouldn't trigger a warning, should it?
>> >> >
>> >> > No, I think it tries to say that val is always either greater than
>> >> > LONG_MAX or smaller than LONG_MIN.
>> >>
>> >> Exactly, the warning is about the fact that all the other conditions
>> >> will never be evaluated.  The phrasing is admittedly quite cryptic th=
o.
>> >
>> > I thought you said this was a setup where the argument _does_ fit a lo=
ng?
>>
>> There we are dispatching if 'val' can be expressed or not with a long.
>>
>> 'val' is an EMACS_INT so depending on the configuration it might fit in
>> a long by definition, when this happen GCC sees the first condition in
>> or as always true etc etc... :)
>
> So val is greater than LONG_MAX? How can this happen?

Apologies I was wrong, Eli's theory from his last message sounds like
the correct one.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 19 Feb 2021 15:01:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 10:01:00 2021
Received: from localhost ([127.0.0.1]:50097 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD7HA-0003qT-3l
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 10:01:00 -0500
Received: from mail-ot1-f42.google.com ([209.85.210.42]:37123)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1lD7H8-0003qE-BT
 for 43725 <at> debbugs.gnu.org; Fri, 19 Feb 2021 10:00:59 -0500
Received: by mail-ot1-f42.google.com with SMTP id s6so5317942otk.4
 for <43725 <at> debbugs.gnu.org>; Fri, 19 Feb 2021 07:00:58 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=rJqGnGWkmWlbtkQX2yXn9UnFMyJNnywOC2cwtIa5OQY=;
 b=OfU+xHvgxJFmbU/3MMuoDc57kkR9BBB0yaWwGy1M8IyZaizio0YgKcVaXtHDh1FIlz
 OxXztP8uVHfSJbwSkXclx8dQxePfEybre9QrzqTRAZPVBWbr8BVLgOT7avSHTrTv2L30
 MR7oBAQBz6tOGbGl7aL3Hpd7qdf/7dl+00XPnM7WApDpI0TvpKY1snj/Uj8PLk1SKehe
 frU89Rg1HgcjzXcKGYjdnKMEz5KXfQc+exhRHCSFj/5KQ9fv95G/oxfXps1k6u7HZnxn
 8Fm/KbTVl7uLhl1PVzAGskhiEsvY+EVN3Lm7Z162ROWABxf4qMI1nrJJgfQxCSc4S8B6
 XobA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=rJqGnGWkmWlbtkQX2yXn9UnFMyJNnywOC2cwtIa5OQY=;
 b=XvJ5Z20/d414doHrm7y7sFhDSZJkVnBsJ+lflQxK+qU1QlyBG3yUrMChrFd7vIF8qs
 HVNwZw07RCeYMOi6d5nro9WdRKIGmEZEHONN1twcIZmz/aInyY26LDCcU0Vwk+D+PrZQ
 4pbpubSBfZa793nskpX25JSozgQ5spfaUDlV7Gx735Od1jSPbrBBb7z/2gmKkH1rFwaz
 1UZlv9ChKo0bilfGXJbDVWh9SBTMXao96Id7uYohEKxnrkDRvD1Z8wjkdkhDlsslH94S
 UDnHi2l0eAf1kbICZ4oLaKyTJ6N010iS+LOnitIDWUkcMBcU10XC9QCS0ZLEEotyLYY9
 FjBg==
X-Gm-Message-State: AOAM530eQfEW1rBYO4Sy9ERnHwwGGBDyPw0zq4ZBMiUJW3vQyHA1lktx
 HrO4ivJIK5joqgC2MWNSWkkA8ReQDSRp69S4seE=
X-Google-Smtp-Source: ABdhPJxtY/wmUyd0eTU8QupCjHG/TbzF/mk2ZoUereRKxNz/wLwCOgY5UVyOCjq/FlQtvZbR9yQFbwlOONZVJ7Fb8Fs=
X-Received: by 2002:a05:6830:1682:: with SMTP id
 k2mr7139942otr.154.1613746852576; 
 Fri, 19 Feb 2021 07:00:52 -0800 (PST)
MIME-Version: 1.0
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN> <xjf7dq76crm.fsf@HIDDEN>
 <83v9drp8va.fsf@HIDDEN> <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN>
 <CAOqdjBe_J1oXtaFv8v4PjYSbU2Hg=KLwSF-+WAT-VLCcXYUr-w@HIDDEN>
 <83im6o2n67.fsf@HIDDEN> <xjf4ki8nnvr.fsf@HIDDEN>
 <CAOqdjBfhH0azD90ATn6oxjabXSuBtSxaeDEmT6EOfys+9DUt5Q@HIDDEN>
 <xjfr1lcm8g0.fsf@HIDDEN>
In-Reply-To: <xjfr1lcm8g0.fsf@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Fri, 19 Feb 2021 15:00:16 +0000
Message-ID: <CAOqdjBeGx6Bm1M3kd-tXpODcnB67nhVw6rTaEEo9sGdLHHmAOQ@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
To: Andrea Corallo <akrl@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Fri, Feb 19, 2021 at 2:35 PM Andrea Corallo <akrl@HIDDEN> wrote:
> > On Fri, Feb 19, 2021 at 2:16 PM Andrea Corallo <akrl@HIDDEN> wrote:
> >> >> > comp.c:1174:22: warning: logical =E2=80=98or=E2=80=99 of collecti=
vely exhaustive tests is always true [-Wlogical-op]
> >> >> >  1174 |   if (val > LONG_MAX || val < LONG_MIN)
> >> >> >       |                      ^~
> >> >> >
> >> >> > Not sure what's the best way to silence it or if we want to rever=
t to
> >> >> > the previous formulation.
> >> >>
> >> >> Maybe it's me, but I had a hard time parsing that warning. IIUC, th=
e
> >> >> tests are both trivially false? And oring two trivially false
> >> >> conditions shouldn't trigger a warning, should it?
> >> >
> >> > No, I think it tries to say that val is always either greater than
> >> > LONG_MAX or smaller than LONG_MIN.
> >>
> >> Exactly, the warning is about the fact that all the other conditions
> >> will never be evaluated.  The phrasing is admittedly quite cryptic tho=
.
> >
> > I thought you said this was a setup where the argument _does_ fit a lon=
g?
>
> There we are dispatching if 'val' can be expressed or not with a long.
>
> 'val' is an EMACS_INT so depending on the configuration it might fit in
> a long by definition, when this happen GCC sees the first condition in
> or as always true etc etc... :)

So val is greater than LONG_MAX? How can this happen?

I've got some initial results here that seem to show a serious bug in
my backend in this situation, and I hope it's not a gcc bug...




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 19 Feb 2021 14:59:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 09:59:35 2021
Received: from localhost ([127.0.0.1]:50088 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD7Fn-0003m7-HT
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 09:59:35 -0500
Received: from eggs.gnu.org ([209.51.188.92]:47632)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lD7Fl-0003ls-M4
 for 43725 <at> debbugs.gnu.org; Fri, 19 Feb 2021 09:59:34 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:50110)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lD7Fd-0000DR-CU; Fri, 19 Feb 2021 09:59:25 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3282
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lD7Fb-0003Tc-Sx; Fri, 19 Feb 2021 09:59:24 -0500
Date: Fri, 19 Feb 2021 16:59:40 +0200
Message-Id: <83a6s02jdv.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfr1lcm8g0.fsf@HIDDEN> (message from Andrea Corallo on Fri, 19
 Feb 2021 14:35:43 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN>
 <CAOqdjBe_J1oXtaFv8v4PjYSbU2Hg=KLwSF-+WAT-VLCcXYUr-w@HIDDEN>
 <83im6o2n67.fsf@HIDDEN> <xjf4ki8nnvr.fsf@HIDDEN>
 <CAOqdjBfhH0azD90ATn6oxjabXSuBtSxaeDEmT6EOfys+9DUt5Q@HIDDEN>
 <xjfr1lcm8g0.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, 43725 <at> debbugs.gnu.org, pipcet@HIDDEN,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>, 43725 <at> debbugs.gnu.org, larsi@HIDDEN,
>         Stefan Monnier <monnier@HIDDEN>
> Date: Fri, 19 Feb 2021 14:35:43 +0000
> 
> >> > No, I think it tries to say that val is always either greater than
> >> > LONG_MAX or smaller than LONG_MIN.
> >>
> >> Exactly, the warning is about the fact that all the other conditions
> >> will never be evaluated.  The phrasing is admittedly quite cryptic tho.
> >
> > I thought you said this was a setup where the argument _does_ fit a long?
> 
> There we are dispatching if 'val' can be expressed or not with a long.
> 
> 'val' is an EMACS_INT so depending on the configuration it might fit in
> a long by definition, when this happen GCC sees the first condition in
> or as always true etc etc... :)

The condition would be always true if it were written like this:

  if (val >= LONG_MIN && val <= LONG_MAX)

But that wasn't what the code was saying, it was the exact opposite of
this condition.  So I think GCC was actually complaining about the
'else' clause.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 19 Feb 2021 14:35:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 09:35:49 2021
Received: from localhost ([127.0.0.1]:49033 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD6sm-0002xA-V8
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 09:35:49 -0500
Received: from mx.sdf.org ([205.166.94.24]:54250)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lD6sj-0002wz-9W
 for 43725 <at> debbugs.gnu.org; Fri, 19 Feb 2021 09:35:47 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11JEZhqB018016
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Fri, 19 Feb 2021 14:35:44 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN>
 <CAOqdjBe_J1oXtaFv8v4PjYSbU2Hg=KLwSF-+WAT-VLCcXYUr-w@HIDDEN>
 <83im6o2n67.fsf@HIDDEN> <xjf4ki8nnvr.fsf@HIDDEN>
 <CAOqdjBfhH0azD90ATn6oxjabXSuBtSxaeDEmT6EOfys+9DUt5Q@HIDDEN>
Date: Fri, 19 Feb 2021 14:35:43 +0000
In-Reply-To: <CAOqdjBfhH0azD90ATn6oxjabXSuBtSxaeDEmT6EOfys+9DUt5Q@HIDDEN>
 (Pip Cet's message of "Fri, 19 Feb 2021 14:23:05 +0000")
Message-ID: <xjfr1lcm8g0.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Pip Cet <pipcet@HIDDEN> writes:

> On Fri, Feb 19, 2021 at 2:16 PM Andrea Corallo <akrl@HIDDEN> wrote:
>> >> > comp.c:1174:22: warning: logical =E2=80=98or=E2=80=99 of collective=
ly exhaustive tests is always true [-Wlogical-op]
>> >> >  1174 |   if (val > LONG_MAX || val < LONG_MIN)
>> >> >       |                      ^~
>> >> >
>> >> > Not sure what's the best way to silence it or if we want to revert =
to
>> >> > the previous formulation.
>> >>
>> >> Maybe it's me, but I had a hard time parsing that warning. IIUC, the
>> >> tests are both trivially false? And oring two trivially false
>> >> conditions shouldn't trigger a warning, should it?
>> >
>> > No, I think it tries to say that val is always either greater than
>> > LONG_MAX or smaller than LONG_MIN.
>>
>> Exactly, the warning is about the fact that all the other conditions
>> will never be evaluated.  The phrasing is admittedly quite cryptic tho.
>
> I thought you said this was a setup where the argument _does_ fit a long?

There we are dispatching if 'val' can be expressed or not with a long.

'val' is an EMACS_INT so depending on the configuration it might fit in
a long by definition, when this happen GCC sees the first condition in
or as always true etc etc... :)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 19 Feb 2021 14:23:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 09:23:53 2021
Received: from localhost ([127.0.0.1]:49020 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD6hF-0002fw-51
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 09:23:53 -0500
Received: from mail-ot1-f54.google.com ([209.85.210.54]:35688)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1lD6h9-0002fg-V6
 for 43725 <at> debbugs.gnu.org; Fri, 19 Feb 2021 09:23:51 -0500
Received: by mail-ot1-f54.google.com with SMTP id 80so5220576oty.2
 for <43725 <at> debbugs.gnu.org>; Fri, 19 Feb 2021 06:23:47 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=ZOw6kF5mK13x1B6ADx+dSPtTcA8w5A8FiWI5S0T+BBk=;
 b=etlxs1Nk7GYkDlaL5PmXozBby16ZBZvUh3oL12PEdB+BMRQRGoP7dNvy6RnbYaTAtH
 WTnNN6rY86Wq+JRX2X63/yisOnqql8EL9QakQdgq7SOJVI4rlzoRBHFPiwr8sPKQbaYo
 lB3dmjKvXa8IxEmNGnULcO8/HYBlPk72Bpi7hyHlydy4GiTLs+wsjNLoLTusUZL8gTnr
 5bL/SD97cY/XefDfJM8ggtivTzRAfS1zQuIogcr+I5Nq11U8XcFYCUd098xx/2BDg2Pc
 N7ViUomRrgu7UuK9SE/3x13Ld2PiD+D61Q9EhK8idJ+d9wnbsB3Z3QQboTduwG4l4u7S
 T69A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=ZOw6kF5mK13x1B6ADx+dSPtTcA8w5A8FiWI5S0T+BBk=;
 b=W69K1ZWYzBDtvNg4d4gwtbx0hVvaGdLIkuVCxnrk4LIw8yBG8uC3PVFZsNbwA3/ZaE
 psJolSHMYDl7GlbDzwWCEiwJrVij417UZu2yXl6VDlvhmfTBA1PaWSZyvhfsDQvStvbs
 Owl37CQ0MFXp1E59lMrAagQCIuQXy7yP1kWrIJfa3riqDm2UDrFND5jPnmrk7YmuyX2P
 rLzqRHjvDzlUsviiHfvfVBVkxK8oIbiPlh3PCa0K3oGgFeDLRQ+oNkq0IeLnZvrg+b1v
 DoFk9zW9ppfdTdT/rk6GT74oSPqna6bd0EIHbiKci5qC5g864FxTXt4aRmPBqQbeAyqm
 FW5g==
X-Gm-Message-State: AOAM5326wYCiPdBb7Aw2t16PHe+CzYBvIpz5glDDJmMV5Jw629usrZMx
 MTWhFvZaSWMMoKcdZV8T9I8ndFWTHl+wIYkhL3A=
X-Google-Smtp-Source: ABdhPJym1MY2a0Os+z1Hj/1viKHuO6YCjwftiqbvGX275ktrrErvAGuQMrVcbhAO8N2TClbO5uleU/U3JuoclCwho1o=
X-Received: by 2002:a05:6830:1605:: with SMTP id
 g5mr7040130otr.292.1613744622441; 
 Fri, 19 Feb 2021 06:23:42 -0800 (PST)
MIME-Version: 1.0
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN> <xjf7dq76crm.fsf@HIDDEN>
 <83v9drp8va.fsf@HIDDEN> <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN>
 <CAOqdjBe_J1oXtaFv8v4PjYSbU2Hg=KLwSF-+WAT-VLCcXYUr-w@HIDDEN>
 <83im6o2n67.fsf@HIDDEN> <xjf4ki8nnvr.fsf@HIDDEN>
In-Reply-To: <xjf4ki8nnvr.fsf@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Fri, 19 Feb 2021 14:23:05 +0000
Message-ID: <CAOqdjBfhH0azD90ATn6oxjabXSuBtSxaeDEmT6EOfys+9DUt5Q@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
To: Andrea Corallo <akrl@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Fri, Feb 19, 2021 at 2:16 PM Andrea Corallo <akrl@HIDDEN> wrote:
> >> > comp.c:1174:22: warning: logical =E2=80=98or=E2=80=99 of collectivel=
y exhaustive tests is always true [-Wlogical-op]
> >> >  1174 |   if (val > LONG_MAX || val < LONG_MIN)
> >> >       |                      ^~
> >> >
> >> > Not sure what's the best way to silence it or if we want to revert t=
o
> >> > the previous formulation.
> >>
> >> Maybe it's me, but I had a hard time parsing that warning. IIUC, the
> >> tests are both trivially false? And oring two trivially false
> >> conditions shouldn't trigger a warning, should it?
> >
> > No, I think it tries to say that val is always either greater than
> > LONG_MAX or smaller than LONG_MIN.
>
> Exactly, the warning is about the fact that all the other conditions
> will never be evaluated.  The phrasing is admittedly quite cryptic tho.

I thought you said this was a setup where the argument _does_ fit a long?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 19 Feb 2021 14:17:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 09:17:00 2021
Received: from localhost ([127.0.0.1]:49004 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD6aa-0002UW-Iq
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 09:17:00 -0500
Received: from mx.sdf.org ([205.166.94.24]:55074)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lD6aX-0002UN-NT
 for 43725 <at> debbugs.gnu.org; Fri, 19 Feb 2021 09:16:58 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11JEGu1K022977
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Fri, 19 Feb 2021 14:16:56 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN>
 <CAOqdjBe_J1oXtaFv8v4PjYSbU2Hg=KLwSF-+WAT-VLCcXYUr-w@HIDDEN>
 <83im6o2n67.fsf@HIDDEN>
Date: Fri, 19 Feb 2021 14:16:56 +0000
In-Reply-To: <83im6o2n67.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 19 Feb
 2021 15:37:52 +0200")
Message-ID: <xjf4ki8nnvr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, 43725 <at> debbugs.gnu.org, Pip Cet <pipcet@HIDDEN>,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Pip Cet <pipcet@HIDDEN>
>> Date: Fri, 19 Feb 2021 12:53:43 +0000
>> Cc: 43725 <at> debbugs.gnu.org, eliz@HIDDEN, larsi@HIDDEN,=20
>> 	Stefan Monnier <monnier@HIDDEN>
>>=20
>> > comp.c:1174:22: warning: logical =E2=80=98or=E2=80=99 of collectively =
exhaustive tests is always true [-Wlogical-op]
>> >  1174 |   if (val > LONG_MAX || val < LONG_MIN)
>> >       |                      ^~
>> >
>> > Not sure what's the best way to silence it or if we want to revert to
>> > the previous formulation.
>>=20
>> Maybe it's me, but I had a hard time parsing that warning. IIUC, the
>> tests are both trivially false? And oring two trivially false
>> conditions shouldn't trigger a warning, should it?
>
> No, I think it tries to say that val is always either greater than
> LONG_MAX or smaller than LONG_MIN.

Exactly, the warning is about the fact that all the other conditions
will never be evaluated.  The phrasing is admittedly quite cryptic tho.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 19 Feb 2021 13:37:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 08:37:50 2021
Received: from localhost ([127.0.0.1]:48955 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD5yg-0001WN-7y
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 08:37:50 -0500
Received: from eggs.gnu.org ([209.51.188.92]:56376)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lD5yc-0001W8-Ah
 for 43725 <at> debbugs.gnu.org; Fri, 19 Feb 2021 08:37:48 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:47233)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lD5yV-0007it-Fb; Fri, 19 Feb 2021 08:37:39 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2239
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lD5yU-0002Y8-7O; Fri, 19 Feb 2021 08:37:38 -0500
Date: Fri, 19 Feb 2021 15:37:52 +0200
Message-Id: <83im6o2n67.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
In-Reply-To: <CAOqdjBe_J1oXtaFv8v4PjYSbU2Hg=KLwSF-+WAT-VLCcXYUr-w@HIDDEN>
 (message from Pip Cet on Fri, 19 Feb 2021 12:53:43 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN> <xjf7dq76crm.fsf@HIDDEN>
 <83v9drp8va.fsf@HIDDEN> <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN>
 <CAOqdjBe_J1oXtaFv8v4PjYSbU2Hg=KLwSF-+WAT-VLCcXYUr-w@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org,
 akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Pip Cet <pipcet@HIDDEN>
> Date: Fri, 19 Feb 2021 12:53:43 +0000
> Cc: 43725 <at> debbugs.gnu.org, eliz@HIDDEN, larsi@HIDDEN, 
> 	Stefan Monnier <monnier@HIDDEN>
> 
> > comp.c:1174:22: warning: logical ‘or’ of collectively exhaustive tests is always true [-Wlogical-op]
> >  1174 |   if (val > LONG_MAX || val < LONG_MIN)
> >       |                      ^~
> >
> > Not sure what's the best way to silence it or if we want to revert to
> > the previous formulation.
> 
> Maybe it's me, but I had a hard time parsing that warning. IIUC, the
> tests are both trivially false? And oring two trivially false
> conditions shouldn't trigger a warning, should it?

No, I think it tries to say that val is always either greater than
LONG_MAX or smaller than LONG_MIN.

> Sounds like it's GCC that needs to be fixed.

Could be.  But I've given up on GCC's tendency to warn about perfectly
valid programs.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 19 Feb 2021 12:54:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 07:54:30 2021
Received: from localhost ([127.0.0.1]:48902 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD5Ik-0000R1-2s
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 07:54:30 -0500
Received: from mail-ot1-f46.google.com ([209.85.210.46]:33288)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1lD5If-0000Qm-9W
 for 43725 <at> debbugs.gnu.org; Fri, 19 Feb 2021 07:54:29 -0500
Received: by mail-ot1-f46.google.com with SMTP id c16so5028371otp.0
 for <43725 <at> debbugs.gnu.org>; Fri, 19 Feb 2021 04:54:25 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=4/hrh1DLZm6u4XNvqKXqmsTMBRZ/zPc12geiOVaKsWI=;
 b=e7CeWZKDwKXfshe4CDRqsSKzJQC7dxznnifGlnisdjjzNMAck84tS1OgCJ7gReqhHf
 9iHxhZeYBVs+5u5QiOPrcc+4j+EDXam5ipZqPI/05IN1D+mr1FY6hEoIU1bcj0I8Nsqt
 Ba6ZfpRZ7ydWQC13/uXs6Qo1OswWKV9q/JE5gXeu6uwKicFClSi5nYeyV+fjW5viZy8s
 FKG+dx11EMmStLOgCCW2qrJzxItD+XoBiEZm5HFLRWZmicNIYGKUJr4yf4Uk1GRgzEYe
 XWjPkpeISEF5XcrV3ObW3ndM+SKhhluYU9YjTZXDm2PoGbczJ5cnWIzFFPlbYxVTCWkL
 2ZOw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=4/hrh1DLZm6u4XNvqKXqmsTMBRZ/zPc12geiOVaKsWI=;
 b=GdArJAuvJGYbInOtpFOSAQiIA+6+pfX9IlAqTjtnRBD6SvZa+SGVWP2Bk85ztHCqBC
 qORy/y7x0Lq30iqXB0kJrR9i9QBDpSJ/Fg2nIqvAa67eXnBvrpe0fJjD+/BJIO9uEK7g
 jGHweO1ZE2WTvWNmk4EGn+D02XR6YkLRy2GRWHUR/vxnFfitpLtu/TIEbypEvLW0bwm1
 wp0ABtNF2EHoDxu40tt5p8o5q+dt8PxMeuayMZIkegOG41OZtXnIukufw5L2s0c4T76a
 7rQv6Pve78srWJ/agUlhOgZT37Y609R2XQTCU+cS7yYqt5aPjrCMzMgksZ4xhzdVeH5P
 ZO0g==
X-Gm-Message-State: AOAM531m9VAxqd2YOeMDgkb6djbN7vvjj6JRdpx8b70z6weaJoTsXXYU
 oH6PteH9xVx7DJhoAL0454ZHDyL5XUmLAnO5kuc=
X-Google-Smtp-Source: ABdhPJyGlpf3Jizh4nJkTZGk52TMI6n4jjkQ9hE6TTg0MM/QB848nUTa9cyHAXinX8o5XxIkq4fJJXLvUY++0ZGTLtg=
X-Received: by 2002:a05:6830:1605:: with SMTP id
 g5mr6719090otr.292.1613739259351; 
 Fri, 19 Feb 2021 04:54:19 -0800 (PST)
MIME-Version: 1.0
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN> <xjf7dq76crm.fsf@HIDDEN>
 <83v9drp8va.fsf@HIDDEN> <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN>
In-Reply-To: <xjfy2flnmm1.fsf@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Fri, 19 Feb 2021 12:53:43 +0000
Message-ID: <CAOqdjBe_J1oXtaFv8v4PjYSbU2Hg=KLwSF-+WAT-VLCcXYUr-w@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
To: Andrea Corallo <akrl@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: eliz@HIDDEN, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Thu, Feb 18, 2021 at 8:40 PM Andrea Corallo via Bug reports for GNU
Emacs, the Swiss army knife of text editors <bug-gnu-emacs@HIDDEN>
wrote:
> I noticed that with the suggested fix applied in configurations where
> 'val' can't exceed a long on the positive side GCC (trunk from some time
> ago) is complaining emitting the following warning:
>
> comp.c:1174:22: warning: logical =E2=80=98or=E2=80=99 of collectively exh=
austive tests is always true [-Wlogical-op]
>  1174 |   if (val > LONG_MAX || val < LONG_MIN)
>       |                      ^~
>
> Not sure what's the best way to silence it or if we want to revert to
> the previous formulation.

Maybe it's me, but I had a hard time parsing that warning. IIUC, the
tests are both trivially false? And oring two trivially false
conditions shouldn't trigger a warning, should it?

Sounds like it's GCC that needs to be fixed.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 19 Feb 2021 12:23:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 07:23:19 2021
Received: from localhost ([127.0.0.1]:48866 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD4oZ-00063B-Fp
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 07:23:19 -0500
Received: from eggs.gnu.org ([209.51.188.92]:38802)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lD4oW-00062w-3U
 for 43725 <at> debbugs.gnu.org; Fri, 19 Feb 2021 07:23:18 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:41470)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lD4oQ-00014y-6o; Fri, 19 Feb 2021 07:23:10 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1372
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lD4oP-00017O-GK; Fri, 19 Feb 2021 07:23:10 -0500
Date: Fri, 19 Feb 2021 14:23:24 +0200
Message-Id: <83tuq82qmb.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjf8s7knwdx.fsf@HIDDEN> (message from Andrea Corallo on Fri, 19
 Feb 2021 11:13:14 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN> <83k0r53ygd.fsf@HIDDEN>
 <xjftuq9nln2.fsf@HIDDEN> <83im6o4hrc.fsf@HIDDEN> <xjf8s7knwdx.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: bug-gnu-emacs@HIDDEN, larsi@HIDDEN, monnier@HIDDEN,
>         43725 <at> debbugs.gnu.org
> Date: Fri, 19 Feb 2021 11:13:14 +0000
> 
> >   #if EMACS_INT_MAX > LONG_MAX
> >     return emit_rvalue_from_unsigned_long_long (...
> >   #else
> >     return gcc_jit_context_new_rvalue_from_long (...
> >   #endif
> >
> > Does that work well?
> 
> Unfortunately this is a compile time (for the native compiler)
> decision.  If val fits into a long we want to emit simply that.

OK, then how about my original proposal, viz.:

  if (EMACS_INT_MAX > LONG_MAX)
    {
      if (val > LONG_MAX || val < LONG_MIN)
        ...
      else
        ...
    }

You could also #ifdef this conditioned on WINDOWSNT, since MS-Windows
is the only platform where this matters.

> At this point I'm starting to think that the original formulation is
> probably the lesser of evils.

Believe me, it isn't.  For starters, it is not clear what it does.

> 'emit_rvalue_from_unsigned_long_long' was added by me as libgccjit so
> far has no long long support.  As this is shifting the numeric argument
> to emit the code that re-create the long long equivalent using an
> unsigned was the natural choice to avoid UB.
> 
> Admittedly we could just cast inside
> 'emit_rvalue_from_unsigned_long_long' and rename it into
> 'emit_rvalue_from_long_long' but I'm not sure is that important.

Either that, or some comment would be good enough.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 19 Feb 2021 11:13:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 06:13:20 2021
Received: from localhost ([127.0.0.1]:48807 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD3ip-0004AW-Pk
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 06:13:20 -0500
Received: from mx.sdf.org ([205.166.94.24]:49324)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lD3in-0004AN-MZ
 for 43725 <at> debbugs.gnu.org; Fri, 19 Feb 2021 06:13:18 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11JBDFuV018550
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Fri, 19 Feb 2021 11:13:15 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN> <83k0r53ygd.fsf@HIDDEN>
 <xjftuq9nln2.fsf@HIDDEN> <83im6o4hrc.fsf@HIDDEN>
Date: Fri, 19 Feb 2021 11:13:14 +0000
In-Reply-To: <83im6o4hrc.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 19 Feb
 2021 09:51:51 +0200")
Message-ID: <xjf8s7knwdx.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: bug-gnu-emacs@HIDDEN, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: bug-gnu-emacs@HIDDEN, larsi@HIDDEN, monnier@HIDDEN,
>>         43725 <at> debbugs.gnu.org
>> Date: Thu, 18 Feb 2021 20:53:05 +0000
>>=20
>> >> comp.c:1174:22: warning: logical =E2=80=98or=E2=80=99 of collectively=
 exhaustive tests is always true [-Wlogical-op]
>> >>  1174 |   if (val > LONG_MAX || val < LONG_MIN)
>> >>       |                      ^~
>> >>=20
>> >> Not sure what's the best way to silence it or if we want to revert to
>> >> the previous formulation.
>>=20
>> Hi Eli,
>>=20
>> sorry just to make sure I understand the suggestions:
>>=20
>> > You can either condition that by WIDE_EMACS_INT,
>>=20
>> Put it under #ifdef I guess.
>>=20
>> > or add a comparison > between LONG_MAX and INT_MAX.
>>=20
>> Not sure I understand how you'd write this.
>
> Maybe it will be easier to do something like this instead:
>
>   #if EMACS_INT_MAX > LONG_MAX
>     return emit_rvalue_from_unsigned_long_long (...
>   #else
>     return gcc_jit_context_new_rvalue_from_long (...
>   #endif
>
> Does that work well?

Unfortunately this is a compile time (for the native compiler)
decision.  If val fits into a long we want to emit simply that.

At this point I'm starting to think that the original formulation is
probably the lesser of evils.

> Btw, why does the 'long long' variant say "unsigned", while the 'long'
> variant doesn't?


'emit_rvalue_from_unsigned_long_long' was added by me as libgccjit so
far has no long long support.  As this is shifting the numeric argument
to emit the code that re-create the long long equivalent using an
unsigned was the natural choice to avoid UB.

Admittedly we could just cast inside
'emit_rvalue_from_unsigned_long_long' and rename it into
'emit_rvalue_from_long_long' but I'm not sure is that important.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 19 Feb 2021 11:13:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 06:13:26 2021
Received: from localhost ([127.0.0.1]:48810 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD3it-0004An-3m
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 06:13:26 -0500
Received: from lists.gnu.org ([209.51.188.17]:39198)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lD3is-0004Ag-8A
 for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 06:13:22 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:42140)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>) id 1lD3is-0005xs-2f
 for bug-gnu-emacs@HIDDEN; Fri, 19 Feb 2021 06:13:22 -0500
Received: from mx.sdf.org ([205.166.94.24]:49321)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>)
 id 1lD3iq-0004og-29; Fri, 19 Feb 2021 06:13:21 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11JBDFuV018550
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Fri, 19 Feb 2021 11:13:15 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN> <83k0r53ygd.fsf@HIDDEN>
 <xjftuq9nln2.fsf@HIDDEN> <83im6o4hrc.fsf@HIDDEN>
Date: Fri, 19 Feb 2021 11:13:14 +0000
In-Reply-To: <83im6o4hrc.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 19 Feb
 2021 09:51:51 +0200")
Message-ID: <xjf8s7knwdx.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
Received-SPF: pass client-ip=205.166.94.24; envelope-from=akrl@HIDDEN;
 helo=mx.sdf.org
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: bug-gnu-emacs@HIDDEN, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: bug-gnu-emacs@HIDDEN, larsi@HIDDEN, monnier@HIDDEN,
>>         43725 <at> debbugs.gnu.org
>> Date: Thu, 18 Feb 2021 20:53:05 +0000
>>=20
>> >> comp.c:1174:22: warning: logical =E2=80=98or=E2=80=99 of collectively=
 exhaustive tests is always true [-Wlogical-op]
>> >>  1174 |   if (val > LONG_MAX || val < LONG_MIN)
>> >>       |                      ^~
>> >>=20
>> >> Not sure what's the best way to silence it or if we want to revert to
>> >> the previous formulation.
>>=20
>> Hi Eli,
>>=20
>> sorry just to make sure I understand the suggestions:
>>=20
>> > You can either condition that by WIDE_EMACS_INT,
>>=20
>> Put it under #ifdef I guess.
>>=20
>> > or add a comparison > between LONG_MAX and INT_MAX.
>>=20
>> Not sure I understand how you'd write this.
>
> Maybe it will be easier to do something like this instead:
>
>   #if EMACS_INT_MAX > LONG_MAX
>     return emit_rvalue_from_unsigned_long_long (...
>   #else
>     return gcc_jit_context_new_rvalue_from_long (...
>   #endif
>
> Does that work well?

Unfortunately this is a compile time (for the native compiler)
decision.  If val fits into a long we want to emit simply that.

At this point I'm starting to think that the original formulation is
probably the lesser of evils.

> Btw, why does the 'long long' variant say "unsigned", while the 'long'
> variant doesn't?


'emit_rvalue_from_unsigned_long_long' was added by me as libgccjit so
far has no long long support.  As this is shifting the numeric argument
to emit the code that re-create the long long equivalent using an
unsigned was the natural choice to avoid UB.

Admittedly we could just cast inside
'emit_rvalue_from_unsigned_long_long' and rename it into
'emit_rvalue_from_long_long' but I'm not sure is that important.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 19 Feb 2021 08:16:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 03:16:54 2021
Received: from localhost ([127.0.0.1]:48679 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD0y5-0008Gt-TB
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 03:16:54 -0500
Received: from eggs.gnu.org ([209.51.188.92]:37826)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lD0y4-0008Gg-UG
 for 43725 <at> debbugs.gnu.org; Fri, 19 Feb 2021 03:16:53 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:58615)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lD0xz-0002AI-Kr; Fri, 19 Feb 2021 03:16:47 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2247
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lD0xv-0003vl-Nm; Fri, 19 Feb 2021 03:16:47 -0500
Date: Fri, 19 Feb 2021 10:16:59 +0200
Message-Id: <83a6s04glg.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfczwxnilz.fsf@HIDDEN> (message from Andrea Corallo on Thu, 18
 Feb 2021 21:58:32 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <xjfczwxnilz.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: 43725 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>,
>         Lars Ingebrigtsen
>  <larsi@HIDDEN>, monnier@HIDDEN
> Date: Thu, 18 Feb 2021 21:58:32 +0000
> 
> Side question:  do we all agree that the current configure flag
> '--with-nativecomp' should be '--with-native-comp'?

Yes, '--with-native-comp' sounds better.  Maybe even
'--with-native-compilation', even though it's longer.  (But since this
option will become ON by default, users will not have to type it in
most cases.)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 19 Feb 2021 08:14:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 03:14:54 2021
Received: from localhost ([127.0.0.1]:48670 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD0wA-0008Cy-3w
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 03:14:54 -0500
Received: from eggs.gnu.org ([209.51.188.92]:37464)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lD0w8-0008Cl-Gq
 for 43725 <at> debbugs.gnu.org; Fri, 19 Feb 2021 03:14:52 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:58604)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lD0w0-000195-ML; Fri, 19 Feb 2021 03:14:45 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2125
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lD0vz-0003k4-L7; Fri, 19 Feb 2021 03:14:44 -0500
Date: Fri, 19 Feb 2021 10:14:59 +0200
Message-Id: <83blcg4gos.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfh7m9niow.fsf@HIDDEN> (message from Andrea Corallo on Thu, 18
 Feb 2021 21:56:47 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjfh7m9niow.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
> Date: Thu, 18 Feb 2021 21:56:47 +0000
> 
> >   +#ifdef WINDOWSNT
> >   +  /* We may need to load libgccjit when dumping before term/w32-win.el
> >   +     defines `dynamic-library-alist`. This will fail if that variable
> >   +     is empty, so add libgccjit-0.dll to it.  */
> >   +  if (will_dump_p ())
> >   +    Vdynamic_library_alist = list1 (list2 (Qgccjit,
> >   +                                           build_string ("libgccjit-0.dll")));
> >
> > Is there a more elegant way of resolving this difficulty?
> 
> I've no precise idea.  I guess `dynamic-library-alist` should be
> initialized before any compilation can be triggered, not sure how easy
> is that, is also something I can't test and as a consequence develop.

If libgccjit DLL must be loaded early on, perhaps it shouldn't use the
Vdynamic_library_alist machinery at all, but have its own loading
code?

Anyway, we can delay this cleanup until the branch is merged with
master, that's why I asked for  FIXME.

> > This lacks the ENCODE_FILE part:
> >
> >   +           char *fname = SSDATA (concat2 (Vinvocation_directory,
> >   +                                          XCAR (comp_u->file)));
> >   +           FILE *file;
> >   +           if ((file = fopen (fname, "r")))
> >
> > And why are you using fopen instead of emacs_fopen?
> 
> 2110a3faf7 fix both suggestons.

Thanks.  For the future: it is important to go through existing Emacs
APIs that accept file names, because on Windows we must convert UTF-8
encoded file names to UTF-16, so as to provide full support for
non-ASCII file names and directory names.  This conversion happens in
w32.c, which defines wrappers for functions like fopen, so directly
calling those C APIs is generally a bug waiting to happen.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 19 Feb 2021 08:08:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 03:08:44 2021
Received: from localhost ([127.0.0.1]:48666 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD0qC-00083T-CK
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 03:08:44 -0500
Received: from eggs.gnu.org ([209.51.188.92]:36400)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lD0qB-00083E-Ap
 for 43725 <at> debbugs.gnu.org; Fri, 19 Feb 2021 03:08:43 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:58424)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lD0q5-00073j-Jq; Fri, 19 Feb 2021 03:08:37 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1755
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lD0q4-00031k-Ub; Fri, 19 Feb 2021 03:08:37 -0500
Date: Fri, 19 Feb 2021 10:08:51 +0200
Message-Id: <83eehc4gz0.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjflfblnk9d.fsf@HIDDEN> (message from Andrea Corallo on Thu, 18
 Feb 2021 21:22:54 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <83wnv67mei.fsf@HIDDEN> <xjflfblnk9d.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
> Date: Thu, 18 Feb 2021 21:22:54 +0000
> 
> > We can trust that if we indeed make the value explicitly, but if
> > there's at least a tiny chance to get a value that's too large, at
> > least an assertion would be a good idea.
> 
> That's sensible.  185121da69 and b1bab6e073 are introducing assertions
> for the highlighted cases and the other one I've spotted.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 19 Feb 2021 07:51:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 02:51:48 2021
Received: from localhost ([127.0.0.1]:48657 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD0Zo-0007cb-ER
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 02:51:48 -0500
Received: from eggs.gnu.org ([209.51.188.92]:33486)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lD0Zm-0007cB-32
 for 43725 <at> debbugs.gnu.org; Fri, 19 Feb 2021 02:51:46 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:58287)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lD0Zb-0008QX-W1; Fri, 19 Feb 2021 02:51:36 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4684
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lD0Zb-0007zQ-G5; Fri, 19 Feb 2021 02:51:35 -0500
Date: Fri, 19 Feb 2021 09:51:51 +0200
Message-Id: <83im6o4hrc.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjftuq9nln2.fsf@HIDDEN> (message from Andrea Corallo on Thu, 18
 Feb 2021 20:53:05 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN> <83k0r53ygd.fsf@HIDDEN> <xjftuq9nln2.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: bug-gnu-emacs@HIDDEN, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: bug-gnu-emacs@HIDDEN, larsi@HIDDEN, monnier@HIDDEN,
>         43725 <at> debbugs.gnu.org
> Date: Thu, 18 Feb 2021 20:53:05 +0000
> 
> >> comp.c:1174:22: warning: logical ‘or’ of collectively exhaustive tests is always true [-Wlogical-op]
> >>  1174 |   if (val > LONG_MAX || val < LONG_MIN)
> >>       |                      ^~
> >> 
> >> Not sure what's the best way to silence it or if we want to revert to
> >> the previous formulation.
> 
> Hi Eli,
> 
> sorry just to make sure I understand the suggestions:
> 
> > You can either condition that by WIDE_EMACS_INT,
> 
> Put it under #ifdef I guess.
> 
> > or add a comparison > between LONG_MAX and INT_MAX.
> 
> Not sure I understand how you'd write this.

Maybe it will be easier to do something like this instead:

  #if EMACS_INT_MAX > LONG_MAX
    return emit_rvalue_from_unsigned_long_long (...
  #else
    return gcc_jit_context_new_rvalue_from_long (...
  #endif

Does that work well?

Btw, why does the 'long long' variant say "unsigned", while the 'long'
variant doesn't?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 19 Feb 2021 07:51:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 02:51:47 2021
Received: from localhost ([127.0.0.1]:48654 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD0Zk-0007cL-15
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 02:51:47 -0500
Received: from lists.gnu.org ([209.51.188.17]:45174)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lD0Zi-0007cD-JC
 for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 02:51:43 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:51346)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>) id 1lD0Zh-0002H4-2X
 for bug-gnu-emacs@HIDDEN; Fri, 19 Feb 2021 02:51:42 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:58287)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lD0Zb-0008QX-W1; Fri, 19 Feb 2021 02:51:36 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4684
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lD0Zb-0007zQ-G5; Fri, 19 Feb 2021 02:51:35 -0500
Date: Fri, 19 Feb 2021 09:51:51 +0200
Message-Id: <83im6o4hrc.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjftuq9nln2.fsf@HIDDEN> (message from Andrea Corallo on Thu, 18
 Feb 2021 20:53:05 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN> <83k0r53ygd.fsf@HIDDEN> <xjftuq9nln2.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: submit
Cc: bug-gnu-emacs@HIDDEN, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: bug-gnu-emacs@HIDDEN, larsi@HIDDEN, monnier@HIDDEN,
>         43725 <at> debbugs.gnu.org
> Date: Thu, 18 Feb 2021 20:53:05 +0000
> 
> >> comp.c:1174:22: warning: logical ‘or’ of collectively exhaustive tests is always true [-Wlogical-op]
> >>  1174 |   if (val > LONG_MAX || val < LONG_MIN)
> >>       |                      ^~
> >> 
> >> Not sure what's the best way to silence it or if we want to revert to
> >> the previous formulation.
> 
> Hi Eli,
> 
> sorry just to make sure I understand the suggestions:
> 
> > You can either condition that by WIDE_EMACS_INT,
> 
> Put it under #ifdef I guess.
> 
> > or add a comparison > between LONG_MAX and INT_MAX.
> 
> Not sure I understand how you'd write this.

Maybe it will be easier to do something like this instead:

  #if EMACS_INT_MAX > LONG_MAX
    return emit_rvalue_from_unsigned_long_long (...
  #else
    return gcc_jit_context_new_rvalue_from_long (...
  #endif

Does that work well?

Btw, why does the 'long long' variant say "unsigned", while the 'long'
variant doesn't?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 18 Feb 2021 21:58:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 18 16:58:35 2021
Received: from localhost ([127.0.0.1]:48313 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lCrJj-0000Uw-ER
	for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 16:58:35 -0500
Received: from mx.sdf.org ([205.166.94.24]:61390)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lCrJh-0000Uo-Jf
 for 43725 <at> debbugs.gnu.org; Thu, 18 Feb 2021 16:58:34 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11ILwWT4013100
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Thu, 18 Feb 2021 21:58:33 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
Date: Thu, 18 Feb 2021 21:58:32 +0000
In-Reply-To: <xjfr1oh5lp7.fsf@HIDDEN> (Andrea Corallo via's message of "Wed, 
 25 Nov 2020 18:35:16 +0000")
Message-ID: <xjfczwxnilz.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, Lars Ingebrigtsen <larsi@HIDDEN>,
 43725 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Side question:  do we all agree that the current configure flag
'--with-nativecomp' should be '--with-native-comp'?

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 18 Feb 2021 21:58:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 18 16:58:39 2021
Received: from localhost ([127.0.0.1]:48316 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lCrJn-0000VG-Ma
	for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 16:58:39 -0500
Received: from lists.gnu.org ([209.51.188.17]:37440)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lCrJl-0000V7-Cc
 for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 16:58:39 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:40190)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>) id 1lCrJl-00064Z-4W
 for bug-gnu-emacs@HIDDEN; Thu, 18 Feb 2021 16:58:37 -0500
Received: from mx.sdf.org ([205.166.94.24]:61389)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>)
 id 1lCrJj-000833-FX; Thu, 18 Feb 2021 16:58:36 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11ILwWT4013100
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Thu, 18 Feb 2021 21:58:33 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
Date: Thu, 18 Feb 2021 21:58:32 +0000
In-Reply-To: <xjfr1oh5lp7.fsf@HIDDEN> (Andrea Corallo via's message of "Wed, 
 25 Nov 2020 18:35:16 +0000")
Message-ID: <xjfczwxnilz.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
Received-SPF: pass client-ip=205.166.94.24; envelope-from=akrl@HIDDEN;
 helo=mx.sdf.org
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: Eli Zaretskii <eliz@HIDDEN>, Lars Ingebrigtsen <larsi@HIDDEN>,
 43725 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

Side question:  do we all agree that the current configure flag
'--with-nativecomp' should be '--with-native-comp'?

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 18 Feb 2021 21:56:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 18 16:56:52 2021
Received: from localhost ([127.0.0.1]:48309 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lCrI4-0000Rs-0i
	for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 16:56:52 -0500
Received: from mx.sdf.org ([205.166.94.24]:61443)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lCrI1-0000Rh-HC
 for 43725 <at> debbugs.gnu.org; Thu, 18 Feb 2021 16:56:50 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11ILulDS016007
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Thu, 18 Feb 2021 21:56:48 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN>
Date: Thu, 18 Feb 2021 21:56:47 +0000
In-Reply-To: <831rdjd95w.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 13 Feb
 2021 22:06:51 +0200")
Message-ID: <xjfh7m9niow.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

[...]

> This should have a big FIXME, since it means the name of the DLL is in
> two different places, and if we need to support a differently-named
> DLL, we are in trouble:

Done with 805cae572a.

>   +#ifdef WINDOWSNT
>   +  /* We may need to load libgccjit when dumping before term/w32-win.el
>   +     defines `dynamic-library-alist`. This will fail if that variable
>   +     is empty, so add libgccjit-0.dll to it.  */
>   +  if (will_dump_p ())
>   +    Vdynamic_library_alist = list1 (list2 (Qgccjit,
>   +                                           build_string ("libgccjit-0.dll")));
>
> Is there a more elegant way of resolving this difficulty?

I've no precise idea.  I guess `dynamic-library-alist` should be
initialized before any compilation can be triggered, not sure how easy
is that, is also something I can't test and as a consequence develop.

> This lacks the ENCODE_FILE part:
>
>   +           char *fname = SSDATA (concat2 (Vinvocation_directory,
>   +                                          XCAR (comp_u->file)));
>   +           FILE *file;
>   +           if ((file = fopen (fname, "r")))
>
> And why are you using fopen instead of emacs_fopen?

2110a3faf7 fix both suggestons.

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 18 Feb 2021 21:22:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 18 16:22:57 2021
Received: from localhost ([127.0.0.1]:48271 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lCqlF-00081H-Kg
	for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 16:22:57 -0500
Received: from mx.sdf.org ([205.166.94.24]:63424)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lCqlE-000819-Fc
 for 43725 <at> debbugs.gnu.org; Thu, 18 Feb 2021 16:22:57 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11ILMsU5015727
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Thu, 18 Feb 2021 21:22:55 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <83wnv67mei.fsf@HIDDEN>
Date: Thu, 18 Feb 2021 21:22:54 +0000
In-Reply-To: <83wnv67mei.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 17 Feb
 2021 17:18:45 +0200")
Message-ID: <xjflfblnk9d.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
>> Date: Tue, 16 Feb 2021 21:13:07 +0000
>> 
>> Addressing some easy part of the review to close the day.
>
> Thanks.
>
>> > Likewise, this is unsafe because a fixnum can be larger than INT_MAX:
>> >
>> >   +  if (!FIXNUMP (idx))
>> >   +    xsignal1 (Qnative_ice,
>> >   +             build_string ("inconsistent data relocation container"));
>> >   +  reloc.idx = gcc_jit_context_new_rvalue_from_int (comp.ctxt,
>> >   +                                                  comp.ptrdiff_type,
>> >   +                                                  XFIXNUM (idx)); <<<<<<<<
>> >
>> > (There are several more calls with the same problem.)
>> 
>> Should we never trust in C a value coming from a Lisp_Object even if is
>> supposed to be constructed on purpose?
>
> We can trust that if we indeed make the value explicitly, but if
> there's at least a tiny chance to get a value that's too large, at
> least an assertion would be a good idea.

That's sensible.  185121da69 and b1bab6e073 are introducing assertions
for the highlighted cases and the other one I've spotted.

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 18 Feb 2021 20:53:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 18 15:53:11 2021
Received: from localhost ([127.0.0.1]:48215 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lCqIR-00059P-AB
	for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 15:53:11 -0500
Received: from mx.sdf.org ([205.166.94.24]:51088)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lCqIN-00059F-I6
 for 43725 <at> debbugs.gnu.org; Thu, 18 Feb 2021 15:53:09 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11IKr5BM017159
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Thu, 18 Feb 2021 20:53:06 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN> <83k0r53ygd.fsf@HIDDEN>
Date: Thu, 18 Feb 2021 20:53:05 +0000
In-Reply-To: <83k0r53ygd.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 18 Feb
 2021 22:36:34 +0200")
Message-ID: <xjftuq9nln2.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: bug-gnu-emacs@HIDDEN, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN, monnier@HIDDEN=
ca,
>>         43725 <at> debbugs.gnu.org
>> Date: Thu, 18 Feb 2021 20:32:06 +0000
>>=20
>> >> Several comparisons like this one:
>> >>
>> >>   +  if (val !=3D (long) val)
>> >>
>> >> are IMO better written as
>> >>
>> >>   if (val > LONG_MAX || val < LONG_MIN)
>> >
>> > Fixed by 72e4a22391
>>=20
>> I noticed that with the suggested fix applied in configurations where
>> 'val' can't exceed a long on the positive side GCC (trunk from some time
>> ago) is complaining emitting the following warning:
>>=20
>> comp.c:1174:22: warning: logical =E2=80=98or=E2=80=99 of collectively ex=
haustive tests is always true [-Wlogical-op]
>>  1174 |   if (val > LONG_MAX || val < LONG_MIN)
>>       |                      ^~
>>=20
>> Not sure what's the best way to silence it or if we want to revert to
>> the previous formulation.

Hi Eli,

sorry just to make sure I understand the suggestions:

> You can either condition that by WIDE_EMACS_INT,

Put it under #ifdef I guess.

> or add a comparison > between LONG_MAX and INT_MAX.

Not sure I understand how you'd write this.

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 18 Feb 2021 20:53:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 18 15:53:20 2021
Received: from localhost ([127.0.0.1]:48218 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lCqIW-00059h-Ix
	for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 15:53:19 -0500
Received: from lists.gnu.org ([209.51.188.17]:49666)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lCqIU-00059Y-4f
 for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 15:53:14 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:55336)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>) id 1lCqIT-0007xg-Su
 for bug-gnu-emacs@HIDDEN; Thu, 18 Feb 2021 15:53:13 -0500
Received: from mx.sdf.org ([205.166.94.24]:51083)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>)
 id 1lCqIS-0001m6-1W; Thu, 18 Feb 2021 15:53:13 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11IKr5BM017159
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Thu, 18 Feb 2021 20:53:06 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
 <xjfy2flnmm1.fsf@HIDDEN> <83k0r53ygd.fsf@HIDDEN>
Date: Thu, 18 Feb 2021 20:53:05 +0000
In-Reply-To: <83k0r53ygd.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 18 Feb
 2021 22:36:34 +0200")
Message-ID: <xjftuq9nln2.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
Received-SPF: pass client-ip=205.166.94.24; envelope-from=akrl@HIDDEN;
 helo=mx.sdf.org
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: bug-gnu-emacs@HIDDEN, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN, monnier@HIDDEN=
ca,
>>         43725 <at> debbugs.gnu.org
>> Date: Thu, 18 Feb 2021 20:32:06 +0000
>>=20
>> >> Several comparisons like this one:
>> >>
>> >>   +  if (val !=3D (long) val)
>> >>
>> >> are IMO better written as
>> >>
>> >>   if (val > LONG_MAX || val < LONG_MIN)
>> >
>> > Fixed by 72e4a22391
>>=20
>> I noticed that with the suggested fix applied in configurations where
>> 'val' can't exceed a long on the positive side GCC (trunk from some time
>> ago) is complaining emitting the following warning:
>>=20
>> comp.c:1174:22: warning: logical =E2=80=98or=E2=80=99 of collectively ex=
haustive tests is always true [-Wlogical-op]
>>  1174 |   if (val > LONG_MAX || val < LONG_MIN)
>>       |                      ^~
>>=20
>> Not sure what's the best way to silence it or if we want to revert to
>> the previous formulation.

Hi Eli,

sorry just to make sure I understand the suggestions:

> You can either condition that by WIDE_EMACS_INT,

Put it under #ifdef I guess.

> or add a comparison > between LONG_MAX and INT_MAX.

Not sure I understand how you'd write this.

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 18 Feb 2021 20:36:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 18 15:36:31 2021
Received: from localhost ([127.0.0.1]:48158 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lCq2I-0002cJ-LR
	for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 15:36:30 -0500
Received: from eggs.gnu.org ([209.51.188.92]:33474)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lCq2G-0002by-Ri
 for 43725 <at> debbugs.gnu.org; Thu, 18 Feb 2021 15:36:29 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49821)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lCq2A-0001Xd-OF; Thu, 18 Feb 2021 15:36:23 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3297
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lCq29-0008Le-EK; Thu, 18 Feb 2021 15:36:22 -0500
Date: Thu, 18 Feb 2021 22:36:34 +0200
Message-Id: <83k0r53ygd.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfy2flnmm1.fsf@HIDDEN> (message from Andrea Corallo on Thu, 18
 Feb 2021 20:32:06 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN> <xjfy2flnmm1.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: bug-gnu-emacs@HIDDEN, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN, monnier@HIDDEN,
>         43725 <at> debbugs.gnu.org
> Date: Thu, 18 Feb 2021 20:32:06 +0000
> 
> >> Several comparisons like this one:
> >>
> >>   +  if (val != (long) val)
> >>
> >> are IMO better written as
> >>
> >>   if (val > LONG_MAX || val < LONG_MIN)
> >
> > Fixed by 72e4a22391
> 
> I noticed that with the suggested fix applied in configurations where
> 'val' can't exceed a long on the positive side GCC (trunk from some time
> ago) is complaining emitting the following warning:
> 
> comp.c:1174:22: warning: logical ‘or’ of collectively exhaustive tests is always true [-Wlogical-op]
>  1174 |   if (val > LONG_MAX || val < LONG_MIN)
>       |                      ^~
> 
> Not sure what's the best way to silence it or if we want to revert to
> the previous formulation.

You can either condition that by WIDE_EMACS_INT, or add a comparison
between LONG_MAX and INT_MAX.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 18 Feb 2021 20:36:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 18 15:36:30 2021
Received: from localhost ([127.0.0.1]:48155 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lCq2F-0002c8-80
	for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 15:36:30 -0500
Received: from lists.gnu.org ([209.51.188.17]:58872)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lCq2D-0002c0-Ct
 for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 15:36:26 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:51342)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>) id 1lCq2B-0007ud-TA
 for bug-gnu-emacs@HIDDEN; Thu, 18 Feb 2021 15:36:25 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49821)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lCq2A-0001Xd-OF; Thu, 18 Feb 2021 15:36:23 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3297
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lCq29-0008Le-EK; Thu, 18 Feb 2021 15:36:22 -0500
Date: Thu, 18 Feb 2021 22:36:34 +0200
Message-Id: <83k0r53ygd.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfy2flnmm1.fsf@HIDDEN> (message from Andrea Corallo on Thu, 18
 Feb 2021 20:32:06 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN> <xjfy2flnmm1.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: submit
Cc: bug-gnu-emacs@HIDDEN, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN, monnier@HIDDEN,
>         43725 <at> debbugs.gnu.org
> Date: Thu, 18 Feb 2021 20:32:06 +0000
> 
> >> Several comparisons like this one:
> >>
> >>   +  if (val != (long) val)
> >>
> >> are IMO better written as
> >>
> >>   if (val > LONG_MAX || val < LONG_MIN)
> >
> > Fixed by 72e4a22391
> 
> I noticed that with the suggested fix applied in configurations where
> 'val' can't exceed a long on the positive side GCC (trunk from some time
> ago) is complaining emitting the following warning:
> 
> comp.c:1174:22: warning: logical ‘or’ of collectively exhaustive tests is always true [-Wlogical-op]
>  1174 |   if (val > LONG_MAX || val < LONG_MIN)
>       |                      ^~
> 
> Not sure what's the best way to silence it or if we want to revert to
> the previous formulation.

You can either condition that by WIDE_EMACS_INT, or add a comparison
between LONG_MAX and INT_MAX.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 18 Feb 2021 20:32:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 18 15:32:13 2021
Received: from localhost ([127.0.0.1]:48140 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lCpy9-0002V7-MX
	for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 15:32:13 -0500
Received: from mx.sdf.org ([205.166.94.24]:52301)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lCpy5-0002Uq-N6
 for 43725 <at> debbugs.gnu.org; Thu, 18 Feb 2021 15:32:12 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11IKW6wI021863
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Thu, 18 Feb 2021 20:32:07 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
Date: Thu, 18 Feb 2021 20:32:06 +0000
In-Reply-To: <xjf5z2rsom4.fsf@HIDDEN> (Andrea Corallo via's message of "Tue, 
 16 Feb 2021 21:13:07 +0000")
Message-ID: <xjfy2flnmm1.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
text editors" <bug-gnu-emacs@HIDDEN> writes:

> Addressing some easy part of the review to close the day.
>
> Eli Zaretskii <eliz@HIDDEN> writes:
>
> [...]
>> Several comparisons like this one:
>>
>>   +  if (val !=3D (long) val)
>>
>> are IMO better written as
>>
>>   if (val > LONG_MAX || val < LONG_MIN)
>
> Fixed by 72e4a22391

I noticed that with the suggested fix applied in configurations where
'val' can't exceed a long on the positive side GCC (trunk from some time
ago) is complaining emitting the following warning:

comp.c:1174:22: warning: logical =E2=80=98or=E2=80=99 of collectively exhau=
stive tests is always true [-Wlogical-op]
 1174 |   if (val > LONG_MAX || val < LONG_MIN)
      |                      ^~

Not sure what's the best way to silence it or if we want to revert to
the previous formulation.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 18 Feb 2021 20:32:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 18 15:32:27 2021
Received: from localhost ([127.0.0.1]:48143 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lCpyM-0002Vd-V6
	for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 15:32:27 -0500
Received: from lists.gnu.org ([209.51.188.17]:50468)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lCpyL-0002VV-E3
 for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 15:32:25 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:50442)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>) id 1lCpyL-0003uj-2b
 for bug-gnu-emacs@HIDDEN; Thu, 18 Feb 2021 15:32:25 -0500
Received: from mx.sdf.org ([205.166.94.24]:52293)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>)
 id 1lCpyI-0007uc-HX; Thu, 18 Feb 2021 15:32:24 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11IKW6wI021863
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Thu, 18 Feb 2021 20:32:07 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
Date: Thu, 18 Feb 2021 20:32:06 +0000
In-Reply-To: <xjf5z2rsom4.fsf@HIDDEN> (Andrea Corallo via's message of "Tue, 
 16 Feb 2021 21:13:07 +0000")
Message-ID: <xjfy2flnmm1.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
Received-SPF: pass client-ip=205.166.94.24; envelope-from=akrl@HIDDEN;
 helo=mx.sdf.org
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN, 43725 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
text editors" <bug-gnu-emacs@HIDDEN> writes:

> Addressing some easy part of the review to close the day.
>
> Eli Zaretskii <eliz@HIDDEN> writes:
>
> [...]
>> Several comparisons like this one:
>>
>>   +  if (val !=3D (long) val)
>>
>> are IMO better written as
>>
>>   if (val > LONG_MAX || val < LONG_MIN)
>
> Fixed by 72e4a22391

I noticed that with the suggested fix applied in configurations where
'val' can't exceed a long on the positive side GCC (trunk from some time
ago) is complaining emitting the following warning:

comp.c:1174:22: warning: logical =E2=80=98or=E2=80=99 of collectively exhau=
stive tests is always true [-Wlogical-op]
 1174 |   if (val > LONG_MAX || val < LONG_MIN)
      |                      ^~

Not sure what's the best way to silence it or if we want to revert to
the previous formulation.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 17 Feb 2021 15:18:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 17 10:18:44 2021
Received: from localhost ([127.0.0.1]:44679 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lCObE-0004VL-3I
	for submit <at> debbugs.gnu.org; Wed, 17 Feb 2021 10:18:44 -0500
Received: from eggs.gnu.org ([209.51.188.92]:51828)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lCObC-0004V4-9n
 for 43725 <at> debbugs.gnu.org; Wed, 17 Feb 2021 10:18:42 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:48309)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lCOb6-00018I-Gf; Wed, 17 Feb 2021 10:18:36 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2664
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lCOb5-00017d-Ss; Wed, 17 Feb 2021 10:18:36 -0500
Date: Wed, 17 Feb 2021 17:18:45 +0200
Message-Id: <83wnv67mei.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjf5z2rsom4.fsf@HIDDEN> (message from Andrea Corallo on Tue, 16
 Feb 2021 21:13:07 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN> <xjf5z2rsom4.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
> Date: Tue, 16 Feb 2021 21:13:07 +0000
> 
> Addressing some easy part of the review to close the day.

Thanks.

> > Likewise, this is unsafe because a fixnum can be larger than INT_MAX:
> >
> >   +  if (!FIXNUMP (idx))
> >   +    xsignal1 (Qnative_ice,
> >   +             build_string ("inconsistent data relocation container"));
> >   +  reloc.idx = gcc_jit_context_new_rvalue_from_int (comp.ctxt,
> >   +                                                  comp.ptrdiff_type,
> >   +                                                  XFIXNUM (idx)); <<<<<<<<
> >
> > (There are several more calls with the same problem.)
> 
> Should we never trust in C a value coming from a Lisp_Object even if is
> supposed to be constructed on purpose?

We can trust that if we indeed make the value explicitly, but if
there's at least a tiny chance to get a value that's too large, at
least an assertion would be a good idea.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 16 Feb 2021 21:13:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 16 16:13:11 2021
Received: from localhost ([127.0.0.1]:41794 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lC7eh-0006dM-LF
	for submit <at> debbugs.gnu.org; Tue, 16 Feb 2021 16:13:11 -0500
Received: from mx.sdf.org ([205.166.94.24]:51731)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lC7ef-0006dD-K1
 for 43725 <at> debbugs.gnu.org; Tue, 16 Feb 2021 16:13:10 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11GLD7cc025090
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Tue, 16 Feb 2021 21:13:08 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN>
Date: Tue, 16 Feb 2021 21:13:07 +0000
In-Reply-To: <831rdjd95w.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 13 Feb
 2021 22:06:51 +0200")
Message-ID: <xjf5z2rsom4.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Addressing some easy part of the review to close the day.

Eli Zaretskii <eliz@HIDDEN> writes:

[...]

> This is unsafe, because a fixnum can be larger than PTRDIFF_MAX:
>
>   +static gcc_jit_lvalue *
>   +emit_mvar_lval (Lisp_Object mvar)
>   +{
>   +  Lisp_Object mvar_slot = CALL1I (comp-mvar-slot, mvar);
>   +
>   +  if (EQ (mvar_slot, Qscratch))
>   +    {
>   +      if (!comp.scratch)
>   +       comp.scratch = gcc_jit_function_new_local (comp.func,
>   +                                                  NULL,
>   +                                                  comp.lisp_obj_type,
>   +                                                  "scratch");
>   +      return comp.scratch;
>   +    }
>   +
>   +  return comp.frame[XFIXNUM (mvar_slot)];  <<<<<<<<<<<<<<<<<<<<
>   +}

Fixed by 543e6e664c

> Likewise, this is unsafe because a fixnum can be larger than INT_MAX:
>
>   +  if (!FIXNUMP (idx))
>   +    xsignal1 (Qnative_ice,
>   +             build_string ("inconsistent data relocation container"));
>   +  reloc.idx = gcc_jit_context_new_rvalue_from_int (comp.ctxt,
>   +                                                  comp.ptrdiff_type,
>   +                                                  XFIXNUM (idx)); <<<<<<<<
>
> (There are several more calls with the same problem.)

Should we never trust in C a value coming from a Lisp_Object even if is
supposed to be constructed on purpose?

> Several comparisons like this one:
>
>   +  if (val != (long) val)
>
> are IMO better written as
>
>   if (val > LONG_MAX || val < LONG_MIN)

Fixed by 72e4a22391

> Here, wouldn't it be better to have an assertion that there are no
> more than 6 elements in the list:
>
>   +  Lisp_Object arg[6];
>   +
>   +  Lisp_Object p = XCDR (insn);
>   +  ptrdiff_t i = 0;
>   +  FOR_EACH_TAIL (p)
>   +    {
>   +      if (i == sizeof (arg) / sizeof (Lisp_Object))
>   +       break;
>   +      arg[i++] = XCAR (p);
>   +    }

This way we can have insns longer than 6 operands but we don't load
them.  These are tipically comment insn we use as a debug note therefore
not relevant here (code generation).

> This is nonportable:
>
>   +  if (!noninteractive)
>   +    {
>   +      sigset_t blocked;
>   +      /* Gcc doesn't like being interrupted at all.  */
>   +      block_input ();
>   +      sigemptyset (&blocked);
>   +      sigaddset (&blocked, SIGALRM);
>   +      sigaddset (&blocked, SIGINT);
>   +#ifdef USABLE_SIGIO
>   +      sigaddset (&blocked, SIGIO);
>   +#endif
>   +      pthread_sigmask (SIG_BLOCK, &blocked, &saved_sigset); <<<<<<<<<<<
>   +      count = SPECPDL_INDEX ();
>   +      record_unwind_protect_void (restore_sigmask);
>   +    }
>
> We shouldn't use pthread_sigmask unconditionally, we should use it
> only on Posix platforms.  Can you explain why the signals here should
> be blocked?  What happens if they aren't, and a signal arrives while
> the compilation runs?  I'm asking because on MS-Windows blocking
> signals with sigaddset/sigmask doesn't really work, so the question is
> what if anything should be done here on Windows.

IIRC the compilation was crashing.  Actually we should be able to get
rid of this piece of code.  ATM we always run in a non interactive
(typically child) process compilations so this code is not exercised
anymore.

Removed by 21858596f0

> Here, 'i' could be ptrdiff_t, no need to use EMACS_INT:
>
>   +  EMACS_INT d_vec_len = XFIXNUM (Flength (comp_u->data_vec));
>   +  for (EMACS_INT i = 0; i < d_vec_len; i++)
>   +    if (!EQ (data_relocs[i],  AREF (comp_u->data_vec, i)))
>   +      return false;
>   +
>   +  d_vec_len = XFIXNUM (Flength (comp_u->data_impure_vec));
>   +  for (EMACS_INT i = 0; i < d_vec_len; i++)

Fixed by 7b676861dd

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 14 Feb 2021 20:22:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 14 15:22:16 2021
Received: from localhost ([127.0.0.1]:36817 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBNuK-000659-Dk
	for submit <at> debbugs.gnu.org; Sun, 14 Feb 2021 15:22:16 -0500
Received: from mx.sdf.org ([205.166.94.24]:58567)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lBNuI-00064x-2X
 for 43725 <at> debbugs.gnu.org; Sun, 14 Feb 2021 15:22:14 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11EKMAdf010265
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Sun, 14 Feb 2021 20:22:11 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
 <xjf7dq76crm.fsf@HIDDEN> <83v9drp8va.fsf@HIDDEN>
 <831rdjd95w.fsf@HIDDEN>
Date: Sun, 14 Feb 2021 20:22:10 +0000
In-Reply-To: <831rdjd95w.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 13 Feb
 2021 22:06:51 +0200")
Message-ID: <xjfczx2tn65.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Andrea, can you please explain why there are so many changes in Lisp
> files on the branch?
>
> For example, what are changes like this one about:
>
>   +(declare-function subr-native-lambda-list "data.c")

`subr-native-lambda-list' returns the lambda list for a dynamic native
compiled function or t if lexically scoped.

This is available only building "--with-nativecomp", this is to remove a
bytecompiler warning for vanilla build.  

> Or this:
>
>   +   ((and (featurep 'nativecomp)
>   +         (subrp def)
>   +         (listp (subr-native-lambda-list def)))
>   +    (subr-native-lambda-list def))

This is to retrive the lambda list of dynamic scoped native compiled
lisp function so that `help-function-arglist' can return it.

> Or this:
>
>   +  ;; Never native compile to allow cc-defs.el:2345 hack.
>   +  (declare (speed -1))

cc-defs does a dirty hack where is capturing the bytecode object of
`cc-bytecomp-compiling-or-loading'.

From cc-defs.el:
========
;; Ugly hack to pull in the definition of `cc-bytecomp-compiling-or-loading'
;; from cc-bytecomp to make it available at loadtime.  This is the same
;; mechanism used in cc-mode.el for `c-populate-syntax-table'.
(defalias 'cc-bytecomp-compiling-or-loading
  (cc-eval-when-compile
    (let ((f (symbol-function 'cc-bytecomp-compiling-or-loading)))
      (if (byte-code-function-p f) f (byte-compile f)))))
========

Native code cannot go through the read print loop so this hack can't
work native compiling the function, speed -1 ensure the function is
present in the eln file but in form of bytecode.

> This will not work on MS-Windows, you need to use path-separator to do
> it portably:
>
>   +    (when (featurep 'nativecomp)
>   +      (defvar comp-eln-load-path)
>   +      (let ((path-env (getenv "EMACSNATIVELOADPATH")))
>   +        (when path-env
>   +          (dolist (path (split-string path-env ":")) <<<<<<<<<<<<<
>   +            (unless (string= "" path)
>   +              (push path comp-eln-load-path)))))
>   +      (push (concat user-emacs-directory "eln-cache/") comp-eln-load-path))

Fixed by 31416495ad.

I'll keep on working through your points the coming week, sincere thanks
for reviewing.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 13 Feb 2021 20:07:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 13 15:07:06 2021
Received: from localhost ([127.0.0.1]:35104 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lB1C6-0003yU-9F
	for submit <at> debbugs.gnu.org; Sat, 13 Feb 2021 15:07:06 -0500
Received: from eggs.gnu.org ([209.51.188.92]:45150)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lB1C4-0003xu-SU
 for 43725 <at> debbugs.gnu.org; Sat, 13 Feb 2021 15:07:05 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:56676)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lB1Bz-0000Bw-IN; Sat, 13 Feb 2021 15:06:59 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3655
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lB1Bv-0007cM-VY; Sat, 13 Feb 2021 15:06:56 -0500
Date: Sat, 13 Feb 2021 22:06:51 +0200
Message-Id: <831rdjd95w.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: akrl@HIDDEN
In-Reply-To: <83v9drp8va.fsf@HIDDEN> (message from Eli Zaretskii on Fri, 27
 Nov 2020 09:16:41 +0200)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN> <xjf7dq76crm.fsf@HIDDEN>
 <83v9drp8va.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Andrea, can you please explain why there are so many changes in Lisp
files on the branch?

For example, what are changes like this one about:

  +(declare-function subr-native-lambda-list "data.c")

Or this:

  +   ((and (featurep 'nativecomp)
  +         (subrp def)
  +         (listp (subr-native-lambda-list def)))
  +    (subr-native-lambda-list def))

Or this:

  +  ;; Never native compile to allow cc-defs.el:2345 hack.
  +  (declare (speed -1))

This will not work on MS-Windows, you need to use path-separator to do
it portably:

  +    (when (featurep 'nativecomp)
  +      (defvar comp-eln-load-path)
  +      (let ((path-env (getenv "EMACSNATIVELOADPATH")))
  +        (when path-env
  +          (dolist (path (split-string path-env ":")) <<<<<<<<<<<<<
  +            (unless (string= "" path)
  +              (push path comp-eln-load-path)))))
  +      (push (concat user-emacs-directory "eln-cache/") comp-eln-load-path))

I'm not sure I understand this addition to epaths.nt:

  +/* Like PATH_LOADSEARCH, but contains the relative path from the
  +   installation directory.
  +*/
  +#define PATH_REL_LOADSEARCH ""

Can you explain how PATH_REL_LOADSEARCH is supposed to work, and for
what purpose it was introduced?

A few minor comments about the C code:

This is unsafe, because a fixnum can be larger than PTRDIFF_MAX:

  +static gcc_jit_lvalue *
  +emit_mvar_lval (Lisp_Object mvar)
  +{
  +  Lisp_Object mvar_slot = CALL1I (comp-mvar-slot, mvar);
  +
  +  if (EQ (mvar_slot, Qscratch))
  +    {
  +      if (!comp.scratch)
  +       comp.scratch = gcc_jit_function_new_local (comp.func,
  +                                                  NULL,
  +                                                  comp.lisp_obj_type,
  +                                                  "scratch");
  +      return comp.scratch;
  +    }
  +
  +  return comp.frame[XFIXNUM (mvar_slot)];  <<<<<<<<<<<<<<<<<<<<
  +}

Likewise, this is unsafe because a fixnum can be larger than INT_MAX:

  +  if (!FIXNUMP (idx))
  +    xsignal1 (Qnative_ice,
  +             build_string ("inconsistent data relocation container"));
  +  reloc.idx = gcc_jit_context_new_rvalue_from_int (comp.ctxt,
  +                                                  comp.ptrdiff_type,
  +                                                  XFIXNUM (idx)); <<<<<<<<

(There are several more calls with the same problem.)

Several comparisons like this one:

  +  if (val != (long) val)

are IMO better written as

  if (val > LONG_MAX || val < LONG_MIN)

Here, wouldn't it be better to have an assertion that there are no
more than 6 elements in the list:

  +  Lisp_Object arg[6];
  +
  +  Lisp_Object p = XCDR (insn);
  +  ptrdiff_t i = 0;
  +  FOR_EACH_TAIL (p)
  +    {
  +      if (i == sizeof (arg) / sizeof (Lisp_Object))
  +       break;
  +      arg[i++] = XCAR (p);
  +    }

If there are more than 6, we will be writing beyond the end of the
arg[] array.

This is nonportable:

  +  if (!noninteractive)
  +    {
  +      sigset_t blocked;
  +      /* Gcc doesn't like being interrupted at all.  */
  +      block_input ();
  +      sigemptyset (&blocked);
  +      sigaddset (&blocked, SIGALRM);
  +      sigaddset (&blocked, SIGINT);
  +#ifdef USABLE_SIGIO
  +      sigaddset (&blocked, SIGIO);
  +#endif
  +      pthread_sigmask (SIG_BLOCK, &blocked, &saved_sigset); <<<<<<<<<<<
  +      count = SPECPDL_INDEX ();
  +      record_unwind_protect_void (restore_sigmask);
  +    }

We shouldn't use pthread_sigmask unconditionally, we should use it
only on Posix platforms.  Can you explain why the signals here should
be blocked?  What happens if they aren't, and a signal arrives while
the compilation runs?  I'm asking because on MS-Windows blocking
signals with sigaddset/sigmask doesn't really work, so the question is
what if anything should be done here on Windows.

Here, 'i' could be ptrdiff_t, no need to use EMACS_INT:

  +  EMACS_INT d_vec_len = XFIXNUM (Flength (comp_u->data_vec));
  +  for (EMACS_INT i = 0; i < d_vec_len; i++)
  +    if (!EQ (data_relocs[i],  AREF (comp_u->data_vec, i)))
  +      return false;
  +
  +  d_vec_len = XFIXNUM (Flength (comp_u->data_impure_vec));
  +  for (EMACS_INT i = 0; i < d_vec_len; i++)

This should have a big FIXME, since it means the name of the DLL is in
two different places, and if we need to support a differently-named
DLL, we are in trouble:

  +#ifdef WINDOWSNT
  +  /* We may need to load libgccjit when dumping before term/w32-win.el
  +     defines `dynamic-library-alist`. This will fail if that variable
  +     is empty, so add libgccjit-0.dll to it.  */
  +  if (will_dump_p ())
  +    Vdynamic_library_alist = list1 (list2 (Qgccjit,
  +                                           build_string ("libgccjit-0.dll")));

Is there a more elegant way of resolving this difficulty?

This lacks the ENCODE_FILE part:

  +           char *fname = SSDATA (concat2 (Vinvocation_directory,
  +                                          XCAR (comp_u->file)));
  +           FILE *file;
  +           if ((file = fopen (fname, "r")))

And why are you using fopen instead of emacs_fopen?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 6 Dec 2020 13:13:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 06 08:13:37 2020
Received: from localhost ([127.0.0.1]:49155 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kltr6-00057Q-Rq
	for submit <at> debbugs.gnu.org; Sun, 06 Dec 2020 08:13:37 -0500
Received: from quimby.gnus.org ([95.216.78.240]:52460)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kltr4-00057C-O5
 for 43725 <at> debbugs.gnu.org; Sun, 06 Dec 2020 08:13:35 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=+yBtEXllEPC2g0Zq8Fwv4Zof4gxADFwO34BsY7SqMuU=; b=bHySCXLJ1XUK/8tjfASs+9s/56
 0z9vfgZn5t4S+HAtSAK9E5yEoL8ITyIfcJC/OxLkAH30cpKeh3a1ETBQoXEkwLAd6tw9dv+M5OEU0
 LnIPu7/fNMQCyCHvQkbL0tnfR3jdb9sVot9HPDexqNhCrnASU1x59DoVGZqCxzGLXAkw=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kltqs-0004Qg-Cd; Sun, 06 Dec 2020 14:13:26 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <xjfk0u85prh.fsf@HIDDEN>
 <87sg8wuzky.fsf@HIDDEN> <xjfft4w5nrx.fsf@HIDDEN>
 <xjf7dpx2olf.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAGFBMVEUOCQktDAtcEA/h
 HBTXRzjai3brvK7///9zpNO7AAAAAWJLR0QHFmGI6wAAAAd0SU1FB+QMBg0JMF5ZWV8AAAGvSURB
 VDjLjZNhktMwDIXdlgN0CQcIDQfYRsp/qOQegLV8AUjufwSelGyYZFsGTaZ29VnSs2ynlNKhIyYi
 xceUBdP+8AJ/OjJpGLGI3hyksI6EJdfCQgUzfgcHClMTFVbSDn/ODk75zT2cC5tqsW+gbWQys5Jt
 sJxtvE/ZrMp3zzQEyIOPVif/lR+eiUMQJCGP1umtRw0HHStSlFivANIvejnnglx8LwYBdaQrAIdY
 ZMCumSBXAVrXu+zicnn5jKFoycWBytn3TSEbI3atQm3DAY5LLR/Fu3nGzMEaMncGnfXYc/ob0s0A
 JcQiIpa2K3AVPAMPQT+XVMHXAyG6fZGFoDVzQITwWFa3apsWa2iwCODi4JZWu3z66e5cp60fBjE8
 wcpaIL3XwXKY6uvGH2Xgl47aLegi1YhK1y2Af5jqb9ytfuPHseD0pl84sn5Xm2qFWBuFdgAV7iPj
 MmyrnwCq2jDtQYNuGJf8IQJPRI0UAoRed2Ao3q2PIF4V7phsd7icK8gzsO/Jv8HXZ+DaPQCCJ903
 DwFu0/EBwPN4CNArgMMjEBez+39wnEHzDJxW8AeobKeu9nzLPgAAACV0RVh0ZGF0ZTpjcmVhdGUA
 MjAyMC0xMi0wNlQxMzowOTo0NyswMDowMNPjpKcAAAAldEVYdGRhdGU6bW9kaWZ5ADIwMjAtMTIt
 MDZUMTM6MDk6NDcrMDA6MDCivhwbAAAAAElFTkSuQmCC
X-Now-Playing: Joan as Police Woman's _Cover Two_: "Kiss"
Date: Sun, 06 Dec 2020 14:13:21 +0100
In-Reply-To: <xjf7dpx2olf.fsf@HIDDEN> (Andrea Corallo's message of "Fri, 04
 Dec 2020 22:28:12 +0000")
Message-ID: <87czzndqmm.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Andrea Corallo <akrl@HIDDEN> writes: > quite happy to
 mention
 that dcfd367d28 should fix the issue of the > spurious warnings. A little
 less proud of the fact that took me good > part of the day to track this
 stupid bug down :/ 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, monnier@HIDDEN,
 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andrea Corallo <akrl@HIDDEN> writes:

> quite happy to mention that dcfd367d28 should fix the issue of the
> spurious warnings.  A little less proud of the fact that took me good
> part of the day to track this stupid bug down :/

:-)

Thanks; I did a new AOT build, and I can confirm that all these warnings
are gone.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 4 Dec 2020 22:28:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 04 17:28:29 2020
Received: from localhost ([127.0.0.1]:46082 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1klJYy-0006tl-Mg
	for submit <at> debbugs.gnu.org; Fri, 04 Dec 2020 17:28:28 -0500
Received: from mab.sdf.org ([205.166.94.33]:56646 helo=ma.sdf.org)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1klJYx-0006tc-2E
 for 43725 <at> debbugs.gnu.org; Fri, 04 Dec 2020 17:28:27 -0500
Received: from akrl by ma.sdf.org with local (Exim 4.92)
 (envelope-from <akrl@HIDDEN>)
 id 1klJYi-0006Zb-Nf; Fri, 04 Dec 2020 22:28:12 +0000
From: Andrea Corallo <akrl@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <xjfk0u85prh.fsf@HIDDEN>
 <87sg8wuzky.fsf@HIDDEN> <xjfft4w5nrx.fsf@HIDDEN>
Date: Fri, 04 Dec 2020 22:28:12 +0000
In-Reply-To: <xjfft4w5nrx.fsf@HIDDEN> (Andrea Corallo via's message of "Thu, 
 26 Nov 2020 12:02:42 +0000")
Message-ID: <xjf7dpx2olf.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, monnier@HIDDEN,
 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
text editors" <bug-gnu-emacs@HIDDEN> writes:

> Lars Ingebrigtsen <larsi@HIDDEN> writes:
>
>> Andrea Corallo <akrl@HIDDEN> writes:
>>
>>> Are these warnings related to compiler specific files or related to
>>> other compilation units?
>>
>> I'm not quite sure I understand the question, but it's things like:
>>
>>  ELC+ELN   gnus/message.elc
>>
>> In end of data:
>> message.el:8873:1: Warning: the function =E2=80=98safe-date-to-time=E2=
=80=99 might not be
>>     defined at runtime.
>>
>> And:
>>
>> ;;;###autoload
>> (defun safe-date-to-time (date)
>>   ...)
>>
>> I don't see any patterns to which ;;;###autoloads are "missing" in
>> native-comp.
>
> Interesting, I've completely missed this :/
>
> Gonna look into it
>
>   Andrea

Hi Lars,

quite happy to mention that dcfd367d28 should fix the issue of the
spurious warnings.  A little less proud of the fact that took me good
part of the day to track this stupid bug down :/

Anyway I've build the branch with and without --with-nativecomp and
(after some clean-up on the vanilla build) I count the same number of
warnings now on both builds.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 27 Nov 2020 07:17:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 27 02:17:06 2020
Received: from localhost ([127.0.0.1]:43648 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiY0A-0006ZI-0A
	for submit <at> debbugs.gnu.org; Fri, 27 Nov 2020 02:17:06 -0500
Received: from eggs.gnu.org ([209.51.188.92]:37084)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kiY07-0006Yl-JD
 for 43725 <at> debbugs.gnu.org; Fri, 27 Nov 2020 02:17:04 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:60414)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kiY02-00079o-AH; Fri, 27 Nov 2020 02:16:58 -0500
Received: from [176.228.60.248] (port=2600 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kiY01-0006Rq-PB; Fri, 27 Nov 2020 02:16:58 -0500
Date: Fri, 27 Nov 2020 09:16:41 +0200
Message-Id: <83v9drp8va.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjf7dq76crm.fsf@HIDDEN> (message from Andrea Corallo on Thu, 26
 Nov 2020 21:15:09 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN> <xjf7dq76crm.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, monnier@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: Lars Ingebrigtsen <larsi@HIDDEN>,  43725 <at> debbugs.gnu.org,
>   monnier@HIDDEN
> Date: Thu, 26 Nov 2020 21:15:09 +0000
> 
> >> I wonder whether Stefan of Eli has found time to take a look at it?
> >
> > It's on my todo, so I will get to it eventually.
> 
> Please while assessing the priorities of your todo, account for the fact
> that with the current user-base of the branch the flow of "important"
> bugs is ATM zeroed.  If we want to have this in 28 would be wise to have
> the larger coverage earlier than later to increase the verification
> surface.

Will do, thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 26 Nov 2020 21:15:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 16:15:16 2020
Received: from localhost ([127.0.0.1]:43055 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiObk-0006Q3-4C
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 16:15:16 -0500
Received: from mab.sdf.org ([205.166.94.33]:55234 helo=ma.sdf.org)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1kiObh-0006Pt-VB
 for 43725 <at> debbugs.gnu.org; Thu, 26 Nov 2020 16:15:14 -0500
Received: from akrl by ma.sdf.org with local (Exim 4.92)
 (envelope-from <akrl@HIDDEN>)
 id 1kiObd-0007eE-FS; Thu, 26 Nov 2020 21:15:09 +0000
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
In-Reply-To: <83im9sqk1b.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 26 Nov
 2020 16:17:52 +0200")
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <83im9sqk1b.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
Date: Thu, 26 Nov 2020 21:15:09 +0000
Message-ID: <xjf7dq76crm.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Lars Ingebrigtsen <larsi@HIDDEN>, monnier@HIDDEN,
 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Lars Ingebrigtsen <larsi@HIDDEN>
>> Cc: 43725 <at> debbugs.gnu.org,  Eli Zaretskii <eliz@HIDDEN>,
>>   monnier@HIDDEN
>> Date: Thu, 26 Nov 2020 11:10:11 +0100
>> 
>> > I was wondering: is there anything I can do to help the progress of
>> > this?
>> 
>> There's a lot of code, and very little of it is in areas where I have
>> much knowledge, so I'm not much help here, I'm afraid.  (I think I read
>> about a fifth of the diff and didn't have any comments.)
>> 
>> I wonder whether Stefan of Eli has found time to take a look at it?
>
> It's on my todo, so I will get to it eventually.

Please while assessing the priorities of your todo, account for the fact
that with the current user-base of the branch the flow of "important"
bugs is ATM zeroed.  If we want to have this in 28 would be wise to have
the larger coverage earlier than later to increase the verification
surface.

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 26 Nov 2020 14:18:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 09:18:18 2020
Received: from localhost ([127.0.0.1]:40401 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiI6E-00088m-Ej
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 09:18:18 -0500
Received: from eggs.gnu.org ([209.51.188.92]:39798)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kiI6C-00088Z-K5
 for 43725 <at> debbugs.gnu.org; Thu, 26 Nov 2020 09:18:17 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:42834)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kiI67-0004KK-1L; Thu, 26 Nov 2020 09:18:11 -0500
Received: from [176.228.60.248] (port=3421 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kiI66-0007X3-BX; Thu, 26 Nov 2020 09:18:10 -0500
Date: Thu, 26 Nov 2020 16:17:52 +0200
Message-Id: <83im9sqk1b.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87wny8xwcc.fsf@HIDDEN> (message from Lars Ingebrigtsen on Thu, 
 26 Nov 2020 11:10:11 +0100)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43725
Cc: monnier@HIDDEN, 43725 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 43725 <at> debbugs.gnu.org,  Eli Zaretskii <eliz@HIDDEN>,
>   monnier@HIDDEN
> Date: Thu, 26 Nov 2020 11:10:11 +0100
> 
> > I was wondering: is there anything I can do to help the progress of
> > this?
> 
> There's a lot of code, and very little of it is in areas where I have
> much knowledge, so I'm not much help here, I'm afraid.  (I think I read
> about a fifth of the diff and didn't have any comments.)
> 
> I wonder whether Stefan of Eli has found time to take a look at it?

It's on my todo, so I will get to it eventually.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 26 Nov 2020 12:02:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 07:02:49 2020
Received: from localhost ([127.0.0.1]:39919 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiFz7-0004hl-00
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 07:02:49 -0500
Received: from mx.sdf.org ([205.166.94.24]:50053)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1kiFz3-0004hY-Dp
 for 43725 <at> debbugs.gnu.org; Thu, 26 Nov 2020 07:02:47 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTP id 0AQC2gt4026924;
 Thu, 26 Nov 2020 12:02:42 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <xjfk0u85prh.fsf@HIDDEN>
 <87sg8wuzky.fsf@HIDDEN>
Date: Thu, 26 Nov 2020 12:02:42 +0000
In-Reply-To: <87sg8wuzky.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Thu,
 26 Nov 2020 12:28:29 +0100")
Message-ID: <xjfft4w5nrx.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, monnier@HIDDEN,
 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> Andrea Corallo <akrl@HIDDEN> writes:
>
>> Are these warnings related to compiler specific files or related to
>> other compilation units?
>
> I'm not quite sure I understand the question, but it's things like:
>
>  ELC+ELN   gnus/message.elc
>
> In end of data:
> message.el:8873:1: Warning: the function =E2=80=98safe-date-to-time=E2=80=
=99 might not be
>     defined at runtime.
>
> And:
>
> ;;;###autoload
> (defun safe-date-to-time (date)
>   ...)
>
> I don't see any patterns to which ;;;###autoloads are "missing" in
> native-comp.

Interesting, I've completely missed this :/

Gonna look into it

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 26 Nov 2020 11:28:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 06:28:53 2020
Received: from localhost ([127.0.0.1]:38719 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiFSH-0000tL-4x
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 06:28:53 -0500
Received: from quimby.gnus.org ([95.216.78.240]:48944)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kiFSD-0000t4-E3
 for 43725 <at> debbugs.gnu.org; Thu, 26 Nov 2020 06:28:51 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Transfer-Encoding:Content-Type:MIME-Version:Message-ID
 :In-Reply-To:Date:References:Subject:Cc:To:From:Sender:Reply-To:Content-ID:
 Content-Description:Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc
 :Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:List-Subscribe:
 List-Post:List-Owner:List-Archive;
 bh=/3WLbRTMBxj2qX/Fqp6tDs0Ltn21IiFv40TOyCq82qo=; b=hkfa+e5w/llcuAFD6WZM5Y8iw0
 iS4ex6qNGUeZ6yayQ2bzMpfaDAjejNt4W9spMxQwI/5MFl8bbXElI6lcJeCq+Ge5IJ1MkJVFAP70X
 vRb4WBkBZSyyVFOmthLd8y/ke8jvvjK4N+ecvd1oVVDaxg8DFDx0iDWqfhmBHgLupS5o=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kiFRv-0000jN-3G; Thu, 26 Nov 2020 12:28:33 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN> <xjfk0u85prh.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAD1BMVEXBt6OWiXOFeWVM
 Rjr///91XVO0AAAAAWJLR0QEj2jZUQAAAAd0SU1FB+QLGgsZCef8i4MAAAGMSURBVDjLdZMLlsIw
 CEVpZwMN2YDABhT2vzf5JGkcZ+rxaHuBxyMUDuZGKGamjISmJGhiAti1tQE8woz947fQRF5FlFpj
 BxHkAC8xZgfKAxSB67S4YYmECTRK9QJZqb0kwVMMzgDEcQVg5aoFJ0cGBqB2Qf5JcBTABFCA74zm
 d0i8gwPTcyaYA1qAwlqJf2XYo7R9OCyMZTC6DdceqqG1nNdk3AP7bEIhI3fQqP7aF7CPC+on5uQk
 kjSbmhlECVJ3gPAsnBl+XvFM8gsxi/k8bFg+lspYAAEOFzGdoEiMPYAtjQkQGnCXHXh1Jm6HxvqM
 LRkZiXEzWBlM/wBJGRpAJvBwLf0iPDXIV7TAcZcah1prhecvMDoze21AFomZ3wBvYH0/qAlUWX8+
 wIx3sB96+NAU8DfL/gS8taR3Ka1XclzPCYxq60e46DQofnR3S8940SNDar9vhZwuqoOPRk37AOzr
 L5u0LeCb2e0hcy1tlgp3ptcaeecBLu8J4FwG3aspuG/fswPJi1WpWtM3HWupy85LmzoAAAAldEVY
 dGRhdGU6Y3JlYXRlADIwMjAtMTEtMjZUMTE6MjU6MDgrMDA6MDD0hyDeAAAAJXRFWHRkYXRlOm1v
 ZGlmeQAyMDIwLTExLTI2VDExOjI1OjA4KzAwOjAwhdqYYgAAAABJRU5ErkJggg==
X-Now-Playing: Japan's _Tin Drum (1)_: "The Art of Parties"
Date: Thu, 26 Nov 2020 12:28:29 +0100
In-Reply-To: <xjfk0u85prh.fsf@HIDDEN> (Andrea Corallo's message of "Thu, 26
 Nov 2020 11:19:46 +0000")
Message-ID: <87sg8wuzky.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Andrea Corallo <akrl@HIDDEN> writes: > Are these warnings
 related to compiler specific files or related to > other compilation units?
 I'm not quite sure I understand the question, but it's things like: 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, monnier@HIDDEN,
 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andrea Corallo <akrl@HIDDEN> writes:

> Are these warnings related to compiler specific files or related to
> other compilation units?

I'm not quite sure I understand the question, but it's things like:

 ELC+ELN   gnus/message.elc

In end of data:
message.el:8873:1: Warning: the function =E2=80=98safe-date-to-time=E2=80=
=99 might not be
    defined at runtime.

And:

;;;###autoload
(defun safe-date-to-time (date)
  ...)

I don't see any patterns to which ;;;###autoloads are "missing" in
native-comp.

--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 26 Nov 2020 11:19:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 06:19:50 2020
Received: from localhost ([127.0.0.1]:38701 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiFJW-0000bR-L9
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 06:19:50 -0500
Received: from mx.sdf.org ([205.166.94.24]:52855)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1kiFJT-0000bH-Rf
 for 43725 <at> debbugs.gnu.org; Thu, 26 Nov 2020 06:19:49 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTP id 0AQBJkqg029769;
 Thu, 26 Nov 2020 11:19:46 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
 <87wny8xwcc.fsf@HIDDEN>
Date: Thu, 26 Nov 2020 11:19:46 +0000
In-Reply-To: <87wny8xwcc.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Thu,
 26 Nov 2020 11:10:11 +0100")
Message-ID: <xjfk0u85prh.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, monnier@HIDDEN,
 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> Andrea Corallo <akrl@HIDDEN> writes:
>
>> I was wondering: is there anything I can do to help the progress of
>> this?
>
> There's a lot of code, and very little of it is in areas where I have
> much knowledge, so I'm not much help here, I'm afraid.  (I think I read
> about a fifth of the diff and didn't have any comments.)
>
> I wonder whether Stefan of Eli has found time to take a look at it?
>
> There's a few compilation warnings in the native-comp tree that hasn't
> been fixed yet (mostly due to ;;;###autoload stuff)?  That should be
> fixed before merging, I think.

Hi Lars,

thanks for the reply.

Are these warnings related to compiler specific files or related to
other compilation units?

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 26 Nov 2020 10:10:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 05:10:39 2020
Received: from localhost ([127.0.0.1]:38534 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiEEZ-0007Jb-0B
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 05:10:39 -0500
Received: from quimby.gnus.org ([95.216.78.240]:47746)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kiEEW-0007JL-1M
 for 43725 <at> debbugs.gnu.org; Thu, 26 Nov 2020 05:10:37 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=QPljaZ1jHArGtcxeFl1QwmyB6q6kTWekuUeoXFIkZp8=; b=VqkJxQ2eUc+kVRZyh1daSg2fK8
 cpkM0jWueCaOXOydxe9Bv5yqqrpwE1fp5XmJvvAfSjoFtiL1Z4vDMuQ+HxWuG/L/ajhfmvX3QOy5a
 XyxPeKBW2OOL5qi16MZUdycq4SoM2HEFwSfEZYVCNoQvZS18Sze7ue2pizUFJJ8KWpeo=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kiEE8-00005c-F0; Thu, 26 Nov 2020 11:10:20 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfr1oh5lp7.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAFVBMVEUZKTEZKTIkOkUt
 SVdNU2JJc4v////jk2ZGAAAAAWJLR0QGYWa4fQAAAAd0SU1FB+QLGgkqG+OqS5UAAAG6SURBVDjL
 lZNNkhoxDIVl4ACWMgdoyxwgWMwesDlAKvT9rzKS7G7oYbKIiuqFPz/9WA8A4lzYgiJsgkmYRWoi
 ZJp2EeK0m/R8l1QgIn+v5SYfUuRWc5HrpILMWUG9nv6U/eGSW91fjucISJZfQZMsR9HbWT+/JkDM
 DiQjEMbDbxXsLwyQhkIYrZVju7Xc2g2AnKxAPq6H1upFFcheXIHNcaz13Ko0AEwdFEaThEi7PuiS
 iDm5JPjPBnfACwjaZnwB/loYgycLAb8BtDyKY3QgJS+59BA1VsDSNdqXA5cq8LaMJAQc0WuMQZTE
 odDOeBTRjyULq4T6g4iM6VeAG5D+BTgtuXQfBnhh6UXhgy+At+AZRSW0gPxKVEKsWzWXrIe2u6K3
 bWZT8BO0nsvBWKG2aqDKBvSQdp8ftbyDfL7PcxsSCOMUEzp4SJk6oL5VDRIFc5WTXX4HXmULMH8q
 mFvVKk8AagQ6z060PkP/D/qWYYCHnAzgSGVey/cOigPivjiT2PA6vSQCL5LMBObcvL6xefIJujWK
 Ld+AEregVfHEaqQEneh1B2BWhNGL+zVCQHiLfj3AT/Hz6X/FFzD4giiy6Z5hAAAAJXRFWHRkYXRl
 OmNyZWF0ZQAyMDIwLTExLTI2VDA5OjQyOjI3KzAwOjAwjY+0awAAACV0RVh0ZGF0ZTptb2RpZnkA
 MjAyMC0xMS0yNlQwOTo0MjoyNyswMDowMPzSDNcAAAAASUVORK5CYII=
X-Now-Playing: Tuxedomoon's _Desire_: "Again"
Date: Thu, 26 Nov 2020 11:10:11 +0100
In-Reply-To: <xjfr1oh5lp7.fsf@HIDDEN> (Andrea Corallo's message of "Wed, 25
 Nov 2020 18:35:16 +0000")
Message-ID: <87wny8xwcc.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Andrea Corallo <akrl@HIDDEN> writes: > I was wondering: is
 there anything I can do to help the progress of > this? There's a lot of
 code, and very little of it is in areas where I have much knowledge, so I'm
 not much help here, I'm afraid. (I think I read about a fifth of the diff
 and didn't have any comments.) 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, monnier@HIDDEN,
 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andrea Corallo <akrl@HIDDEN> writes:

> I was wondering: is there anything I can do to help the progress of
> this?

There's a lot of code, and very little of it is in areas where I have
much knowledge, so I'm not much help here, I'm afraid.  (I think I read
about a fifth of the diff and didn't have any comments.)

I wonder whether Stefan of Eli has found time to take a look at it?

There's a few compilation warnings in the native-comp tree that hasn't
been fixed yet (mostly due to ;;;###autoload stuff)?  That should be
fixed before merging, I think.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 25 Nov 2020 18:35:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 13:35:21 2020
Received: from localhost ([127.0.0.1]:36948 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khzdQ-0005ex-Qv
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 13:35:21 -0500
Received: from mx.sdf.org ([205.166.94.24]:59650)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1khzdQ-0005el-3C
 for 43725 <at> debbugs.gnu.org; Wed, 25 Nov 2020 13:35:20 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTP id 0APIZGIO003190;
 Wed, 25 Nov 2020 18:35:16 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: 43725 <at> debbugs.gnu.org
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN>
Date: Wed, 25 Nov 2020 18:35:16 +0000
In-Reply-To: <xjfzh57w9pt.fsf@HIDDEN> (Andrea Corallo via's message of "Wed, 
 30 Sep 2020 15:44:14 +0000")
Message-ID: <xjfr1oh5lp7.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, Lars Ingebrigtsen <larsi@HIDDEN>,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi all,

I was wondering: is there anything I can do to help the progress of
this?

Regards

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 9 Oct 2020 04:21:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 09 00:21:11 2020
Received: from localhost ([127.0.0.1]:33815 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kQju3-0004x0-H1
	for submit <at> debbugs.gnu.org; Fri, 09 Oct 2020 00:21:11 -0400
Received: from quimby.gnus.org ([95.216.78.240]:33804)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kQjtz-0004w9-7a
 for 43725 <at> debbugs.gnu.org; Fri, 09 Oct 2020 00:21:10 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=s8B/JSuh2qDj6cRqrbvSX3krHgR/J8Te3Mho288+6RE=; b=Vb8D4+jQ5isiiy6/RtBNTBEovj
 JSKmjeccoQ4jBPG5hsRno0bTfMZITXgD35YnQq6SJ7sIwhsIc2rzz748VmKGCnihjP9vruT+qvgkc
 vTJLxR42Pp1mmg9uFSb+j4+BDFlH3MXnV7DrqrZq+FduMw8ONQ+9Ei4+IKuEiJ4aqCFQ=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kQjto-0007hD-Fq; Fri, 09 Oct 2020 06:21:00 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfmu14v2mm.fsf@HIDDEN>
 <83imbse7hi.fsf@HIDDEN> <xjfimbsv1qv.fsf@HIDDEN>
 <83d01zeplw.fsf@HIDDEN> <87mu13ustj.fsf@HIDDEN>
 <xjfa6x3up9d.fsf@HIDDEN> <xjfh7r7s40g.fsf@HIDDEN>
 <877ds264n6.fsf@HIDDEN> <xjfblhert2u.fsf@HIDDEN>
X-Now-Playing: M.I.A.'s _Galang_: "Galang"
Date: Fri, 09 Oct 2020 06:20:55 +0200
In-Reply-To: <xjfblhert2u.fsf@HIDDEN> (Andrea Corallo's message of "Wed, 07
 Oct 2020 14:47:37 +0000")
Message-ID: <87zh4w58t4.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Andrea Corallo <akrl@HIDDEN> writes: > thanks for commenting,
 I pushed bd27257965 and 58d85f4dbb to address > your two suggestions. Thanks; 
 works fine now. 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, Stefan Monnier <monnier@HIDDEN>,
 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andrea Corallo <akrl@HIDDEN> writes:

> thanks for commenting, I pushed bd27257965 and 58d85f4dbb to address
> your two suggestions.

Thanks; works fine now.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 7 Oct 2020 14:47:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 07 10:47:51 2020
Received: from localhost ([127.0.0.1]:57670 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kQAjP-0005UN-F0
	for submit <at> debbugs.gnu.org; Wed, 07 Oct 2020 10:47:51 -0400
Received: from mab.sdf.org ([205.166.94.33]:39804 helo=ma.sdf.org)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1kQAjM-0005UD-Ah
 for 43725 <at> debbugs.gnu.org; Wed, 07 Oct 2020 10:47:50 -0400
Received: from akrl by ma.sdf.org with local (Exim 4.92)
 (envelope-from <akrl@HIDDEN>)
 id 1kQAjB-0008Ho-Iq; Wed, 07 Oct 2020 14:47:37 +0000
From: Andrea Corallo <akrl@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
In-Reply-To: <877ds264n6.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Wed,
 07 Oct 2020 06:28:45 +0200")
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfmu14v2mm.fsf@HIDDEN>
 <83imbse7hi.fsf@HIDDEN> <xjfimbsv1qv.fsf@HIDDEN>
 <83d01zeplw.fsf@HIDDEN> <87mu13ustj.fsf@HIDDEN>
 <xjfa6x3up9d.fsf@HIDDEN> <xjfh7r7s40g.fsf@HIDDEN>
 <877ds264n6.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
Date: Wed, 07 Oct 2020 14:47:37 +0000
Message-ID: <xjfblhert2u.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, Stefan Monnier <monnier@HIDDEN>,
 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> I haven't gotten very far in reviewing the patch set (because it's very
> large), and I don't have any comments so far (because it all looks very
> good :-)).  Just two minor comments on building and running:
>
> If libgccjit isn't installed, configure says this:
>
> checking for dlfunc... no
> configure: error: Installed libgccjit has failed passing the smoke test.
> You can verify it yourself compiling:
> <https://gcc.gnu.org/onlinedocs/jit/intro/tutorial01.html>.
> Please report the issue to your distribution.
> Here instructions on how to compile and install libgccjit from source:
> <https://gcc.gnu.org/wiki/JIT>.
>
> Instead of saying that it isn't installed.
>
> Also -- starting Emacs says "Compilation started.", and it seems like
> it'll say that now and then when using Emacs, too.

Hi Lars,

thanks for commenting, I pushed bd27257965 and 58d85f4dbb to address
your two suggestions.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 7 Oct 2020 04:29:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 07 00:29:01 2020
Received: from localhost ([127.0.0.1]:54778 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kQ14W-0006CJ-99
	for submit <at> debbugs.gnu.org; Wed, 07 Oct 2020 00:29:01 -0400
Received: from quimby.gnus.org ([95.216.78.240]:40038)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kQ14U-0006C8-0Q
 for 43725 <at> debbugs.gnu.org; Wed, 07 Oct 2020 00:28:58 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=ZEuRaXP3YGABTT9tmbDLgEw/9bvnq8I0xBBLedwzfDY=; b=Ql3WfLFPW9BIDefb7QzdS2ly8V
 +SJ9De4xoTV7aTlRuGuVfgaDqUdiR36smiYBND1ycdckXO04nMm053VmQljFI2ZQDF7P3EkE3eAhA
 gqwQM53Xzwy7MyFaHsjm/+0ZM/zitsDevlI1DJh5+lF1dNhNXL+nEWZHwwL8EpoIgq0Q=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kQ14J-00015p-Cw; Wed, 07 Oct 2020 06:28:51 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfmu14v2mm.fsf@HIDDEN>
 <83imbse7hi.fsf@HIDDEN> <xjfimbsv1qv.fsf@HIDDEN>
 <83d01zeplw.fsf@HIDDEN> <87mu13ustj.fsf@HIDDEN>
 <xjfa6x3up9d.fsf@HIDDEN> <xjfh7r7s40g.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAMAAABg3Am1AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAM1BMVEXqXjH1mCvdNTrP
 KGnFMoGsJXPx0R2tuSFZjmdXO1ewx7H7/PpljyRGYKc1Mm1ejqj///+YEbP1AAAAAWJLR0QQlbIN
 LAAAAAd0SU1FB+QKBwQaMAebsYcAAAEsSURBVEjHnc/RtoUQFIXhpSKFev+3PaiwmOw6626P8X/N
 jUgI4jflm+tbFvJAoBaCZZYRdEWz8ADxGsw36Ij+QhLvARRfAXjCnHokZrQgajH+Rx4o1RWgj6AS
 w/4CmTAB8gQS6QNZASBAXoKHJAB7BhSfQLkHq1IVaYAcgFLAvgGRlEDKX+ARMIcgkBvIl8ATmmDe
 BUpMuPcgHI/973XVG74LsNvNbq11x3G8BMYYbfUZBDA1sNaE0+cNGkO8vntjPEiCISrj3HvBQDZU
 1tbuGTTiMmRzXfY7AsGQ7fUeIEHdHk+UC7rq4UQJcq8x2Cqw8+9HUE9sG3jDeRZiCC5xMuAGb7iE
 1kNwcGBZH4EbAxt6/Q3oDJCgpq8f8R24AdDx/gl8eQPXBboCDoA/hdJDqQhsRcQAAAAldEVYdGRh
 dGU6Y3JlYXRlADIwMjAtMTAtMDdUMDQ6MjY6NDgrMDA6MDC2bEZMAAAAJXRFWHRkYXRlOm1vZGlm
 eQAyMDIwLTEwLTA3VDA0OjI2OjQ4KzAwOjAwxzH+8AAAAABJRU5ErkJggg==
X-Now-Playing: Jamie XX's _In Colour_: "Hold Tight"
Date: Wed, 07 Oct 2020 06:28:45 +0200
In-Reply-To: <xjfh7r7s40g.fsf@HIDDEN> (Andrea Corallo's message of "Tue, 06
 Oct 2020 16:39:11 +0000")
Message-ID: <877ds264n6.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: I haven't gotten very far in reviewing the patch set (because
 it's very large), and I don't have any comments so far (because it all looks
 very good :-)). Just two minor comments on building and runni [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, Stefan Monnier <monnier@HIDDEN>,
 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

I haven't gotten very far in reviewing the patch set (because it's very
large), and I don't have any comments so far (because it all looks very
good :-)).  Just two minor comments on building and running:

If libgccjit isn't installed, configure says this:

checking for dlfunc... no
configure: error: Installed libgccjit has failed passing the smoke test.
You can verify it yourself compiling:
<https://gcc.gnu.org/onlinedocs/jit/intro/tutorial01.html>.
Please report the issue to your distribution.
Here instructions on how to compile and install libgccjit from source:
<https://gcc.gnu.org/wiki/JIT>.

Instead of saying that it isn't installed.

Also -- starting Emacs says "Compilation started.", and it seems like
it'll say that now and then when using Emacs, too.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 6 Oct 2020 17:11:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 06 13:11:26 2020
Received: from localhost ([127.0.0.1]:54049 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kPqUn-0002Ox-O9
	for submit <at> debbugs.gnu.org; Tue, 06 Oct 2020 13:11:25 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:47586)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1kPqUl-0002Oj-Gj
 for 43725 <at> debbugs.gnu.org; Tue, 06 Oct 2020 13:11:24 -0400
Received: from pmg3.iro.umontreal.ca (localhost [127.0.0.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id E3CE5440ABD;
 Tue,  6 Oct 2020 13:11:17 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id 9C1BE440132;
 Tue,  6 Oct 2020 13:11:16 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1602004276;
 bh=AfN6rJRhG63exvKffsNYMP8Kd7kn2ZGORRy+dqUgIiE=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=cJd8++N52NEJm9zGmKDetKcFM+2tky5l8BsF6Zyjy5YzcuAbs32xTUnK7NOgJWYLM
 LbN/QdEahIdJV8RX12hy+NEdf+2HzcSrSqqye17g5iMt9yfuBTafIkxc9lz1NOGrXs
 Kr5lYb3emAHLIyXR7Q2GdVNqglQq/faYPnq8iiKxfFXYn5sFoQGMeGdMYTgdpbF2Im
 rX/f6uVTeFnAb7OeuZG5HsIwTIZ9vxrlSBLvZB8i/U4WbStGEyqYuEVcI434+ekw4H
 iKzUPCIMekqqgPcIfEvVNXBzFugZvFAAFjON248h+Skh4i3HEhV/530eTs3u8GL3j1
 04REDRaS+SMGw==
Received: from alfajor (unknown [157.52.9.240])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id D1F1212006A;
 Tue,  6 Oct 2020 13:11:15 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
Message-ID: <jwvo8lfth4l.fsf-monnier+emacs@HIDDEN>
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfmu14v2mm.fsf@HIDDEN>
 <83imbse7hi.fsf@HIDDEN> <xjfimbsv1qv.fsf@HIDDEN>
 <83d01zeplw.fsf@HIDDEN>
Date: Tue, 06 Oct 2020 13:11:15 -0400
In-Reply-To: <83d01zeplw.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 03 Oct
 2020 10:27:23 +0300")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.039 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43725
Cc: 43725 <at> debbugs.gnu.org, Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Lars, Stefan: do you agree that this is the preferred way?

Yes,


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 6 Oct 2020 16:39:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 06 12:39:16 2020
Received: from localhost ([127.0.0.1]:54009 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kPpzf-0001bl-Q7
	for submit <at> debbugs.gnu.org; Tue, 06 Oct 2020 12:39:16 -0400
Received: from mx.sdf.org ([205.166.94.24]:60119)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1kPpzd-0001bc-33
 for 43725 <at> debbugs.gnu.org; Tue, 06 Oct 2020 12:39:14 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTP id 096GdB8p020438;
 Tue, 6 Oct 2020 16:39:11 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfmu14v2mm.fsf@HIDDEN>
 <83imbse7hi.fsf@HIDDEN> <xjfimbsv1qv.fsf@HIDDEN>
 <83d01zeplw.fsf@HIDDEN> <87mu13ustj.fsf@HIDDEN>
 <xjfa6x3up9d.fsf@HIDDEN>
Date: Tue, 06 Oct 2020 16:39:11 +0000
In-Reply-To: <xjfa6x3up9d.fsf@HIDDEN> (Andrea Corallo via's message of "Sat, 
 03 Oct 2020 18:40:30 +0000")
Message-ID: <xjfh7r7s40g.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Lars Ingebrigtsen <larsi@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 43725 <at> debbugs.gnu.org, Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
text editors" <bug-gnu-emacs@HIDDEN> writes:

> Lars Ingebrigtsen <larsi@HIDDEN> writes:
>
>> Eli Zaretskii <eliz@HIDDEN> writes:
>>
>>>> Mmmh, I think technically we could, similarly to what we do for the
>>>> advice, synthesize compile and install a trampoline.  This would read
>>>> the symbol-function and calls what's in inside.
>>>> 
>>>> This trampoline installation would be triggered inside Ffset.
>>>> 
>>>> So yeah I think we could, if that's the preferred way I can try this
>>>> way.
>>>
>>> Lars, Stefan: do you agree that this is the preferred way?
>>
>> I'm not really qualified to have an opinion here, but if this allows
>> redefining primitives, I'm all for it.  Redefining primitives is a
>> useful tool.
>>
>> Would these trampolines be installed only if the primitives are
>> redefined, so there'd be no performance impact on code running normally?
>
> That's correct.
>
> I did some experimentation today and also the implementation was easy as
> the trampoline to be synthesized is exactly the same to what we
> synthesize already for advising, essentially I just had to add the
> proper trigger in fset.
>
> At this point I'm also for going this way as it just reduce the
> incompatibly surface and I don't see considerable downsides.
>
>   Andrea

As my understanding is that that's the consensus I've pushed the revert
of those changes in the testsuite and made Ffset effective also for
redefining primitives.

FYI with the last tweaks `make check` is clean.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 6 Oct 2020 16:39:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 06 12:39:24 2020
Received: from localhost ([127.0.0.1]:54012 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kPpzo-0001c7-2n
	for submit <at> debbugs.gnu.org; Tue, 06 Oct 2020 12:39:24 -0400
Received: from lists.gnu.org ([209.51.188.17]:47658)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1kPpzm-0001bz-0g
 for submit <at> debbugs.gnu.org; Tue, 06 Oct 2020 12:39:22 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:33268)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>) id 1kPpzl-0000L9-PR
 for bug-gnu-emacs@HIDDEN; Tue, 06 Oct 2020 12:39:21 -0400
Received: from mx.sdf.org ([205.166.94.24]:60115)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>)
 id 1kPpzj-0000a3-HS; Tue, 06 Oct 2020 12:39:21 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTP id 096GdB8p020438;
 Tue, 6 Oct 2020 16:39:11 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfmu14v2mm.fsf@HIDDEN>
 <83imbse7hi.fsf@HIDDEN> <xjfimbsv1qv.fsf@HIDDEN>
 <83d01zeplw.fsf@HIDDEN> <87mu13ustj.fsf@HIDDEN>
 <xjfa6x3up9d.fsf@HIDDEN>
Date: Tue, 06 Oct 2020 16:39:11 +0000
In-Reply-To: <xjfa6x3up9d.fsf@HIDDEN> (Andrea Corallo via's message of "Sat, 
 03 Oct 2020 18:40:30 +0000")
Message-ID: <xjfh7r7s40g.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
Received-SPF: pass client-ip=205.166.94.24; envelope-from=akrl@HIDDEN;
 helo=mx.sdf.org
X-detected-operating-system: by eggs.gnu.org: First seen = 2020/10/06 12:39:14
X-ACL-Warn: Detected OS   = ???
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: Lars Ingebrigtsen <larsi@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 43725 <at> debbugs.gnu.org, Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
text editors" <bug-gnu-emacs@HIDDEN> writes:

> Lars Ingebrigtsen <larsi@HIDDEN> writes:
>
>> Eli Zaretskii <eliz@HIDDEN> writes:
>>
>>>> Mmmh, I think technically we could, similarly to what we do for the
>>>> advice, synthesize compile and install a trampoline.  This would read
>>>> the symbol-function and calls what's in inside.
>>>> 
>>>> This trampoline installation would be triggered inside Ffset.
>>>> 
>>>> So yeah I think we could, if that's the preferred way I can try this
>>>> way.
>>>
>>> Lars, Stefan: do you agree that this is the preferred way?
>>
>> I'm not really qualified to have an opinion here, but if this allows
>> redefining primitives, I'm all for it.  Redefining primitives is a
>> useful tool.
>>
>> Would these trampolines be installed only if the primitives are
>> redefined, so there'd be no performance impact on code running normally?
>
> That's correct.
>
> I did some experimentation today and also the implementation was easy as
> the trampoline to be synthesized is exactly the same to what we
> synthesize already for advising, essentially I just had to add the
> proper trigger in fset.
>
> At this point I'm also for going this way as it just reduce the
> incompatibly surface and I don't see considerable downsides.
>
>   Andrea

As my understanding is that that's the consensus I've pushed the revert
of those changes in the testsuite and made Ffset effective also for
redefining primitives.

FYI with the last tweaks `make check` is clean.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 3 Oct 2020 18:40:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 03 14:40:34 2020
Received: from localhost ([127.0.0.1]:44470 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kOmSP-0001Zz-O6
	for submit <at> debbugs.gnu.org; Sat, 03 Oct 2020 14:40:34 -0400
Received: from mx.sdf.org ([205.166.94.24]:54851)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1kOmSN-0001Zq-Ce
 for 43725 <at> debbugs.gnu.org; Sat, 03 Oct 2020 14:40:32 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTP id 093IeUtU029374;
 Sat, 3 Oct 2020 18:40:30 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfmu14v2mm.fsf@HIDDEN>
 <83imbse7hi.fsf@HIDDEN> <xjfimbsv1qv.fsf@HIDDEN>
 <83d01zeplw.fsf@HIDDEN> <87mu13ustj.fsf@HIDDEN>
Date: Sat, 03 Oct 2020 18:40:30 +0000
In-Reply-To: <87mu13ustj.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Sat,
 03 Oct 2020 19:23:36 +0200")
Message-ID: <xjfa6x3up9d.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Eli Zaretskii <eliz@HIDDEN>, Stefan Monnier <monnier@HIDDEN>,
 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> Eli Zaretskii <eliz@HIDDEN> writes:
>
>>> Mmmh, I think technically we could, similarly to what we do for the
>>> advice, synthesize compile and install a trampoline.  This would read
>>> the symbol-function and calls what's in inside.
>>> 
>>> This trampoline installation would be triggered inside Ffset.
>>> 
>>> So yeah I think we could, if that's the preferred way I can try this
>>> way.
>>
>> Lars, Stefan: do you agree that this is the preferred way?
>
> I'm not really qualified to have an opinion here, but if this allows
> redefining primitives, I'm all for it.  Redefining primitives is a
> useful tool.
>
> Would these trampolines be installed only if the primitives are
> redefined, so there'd be no performance impact on code running normally?

That's correct.

I did some experimentation today and also the implementation was easy as
the trampoline to be synthesized is exactly the same to what we
synthesize already for advising, essentially I just had to add the
proper trigger in fset.

At this point I'm also for going this way as it just reduce the
incompatibly surface and I don't see considerable downsides.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 3 Oct 2020 17:23:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 03 13:23:57 2020
Received: from localhost ([127.0.0.1]:44355 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kOlGH-0008BO-N4
	for submit <at> debbugs.gnu.org; Sat, 03 Oct 2020 13:23:57 -0400
Received: from quimby.gnus.org ([95.216.78.240]:55546)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kOlGF-0008BB-Gw
 for 43725 <at> debbugs.gnu.org; Sat, 03 Oct 2020 13:23:56 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=m0gaSD1jtZw9BVw1JvaaV1srTqPSB3yHkvDlfByqCVM=; b=ZZNlqgUjkf2GtajzQmcC4xj7ii
 Iom9pir+Ok2rg3zI+daE/1REk2mJR0pQ8CrnGavIiVTAf2QyFA3zmjq8RncAfl6s+VZTpqp/paDcK
 B//X3Dn2ITG6pFoyxc1IEd79xJUWEBOOq62BtP/0vFrKKcrwkMKv6/4+XBJ8bA8HghvE=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kOlFx-0000f9-NS; Sat, 03 Oct 2020 19:23:47 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfmu14v2mm.fsf@HIDDEN>
 <83imbse7hi.fsf@HIDDEN> <xjfimbsv1qv.fsf@HIDDEN>
 <83d01zeplw.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAG1BMVEUFBAUmGDNMMTe0
 SCi/k1G8rpzk3cz9/f3///+cFMj3AAAAAWJLR0QIht6VegAAAAd0SU1FB+QKAxEVEVnlS9oAAAGa
 SURBVDjLfZRNc5swEIY3DL1bDr2DEPc2qOk1gZVzbQgi14wH0D2Tor/fFTgYK3JfgWD2YfXxLgBw
 XXseUEqgDOnOB3Jun6CW1MoacbmTJS5AonQqcbnKFdBzkk43RF1uM65Nnl8Dgudu5XgWzVoR6MaA
 egLGWjuozl7o7wIauGFPAfBOfZS/fgXOMRjQ+OB9NrkY7n3wNoPvxdB5YB4JvtVKd5dgN4OoaVHp
 cbST28eRIiMV0SW9UHxV45YDUVlSlvjVFqewUg4YxHEg05L2Ida6Wxz6OFli+x00RRMdzMmrFUw/
 II17UONozDiZM7B/gMd6V/juWnuEhOm0aNV5VctQPcSPh0dBMUTV4gp4D9FzIrDKJaLWw/EEnoEB
 VFo0+cFsbJ8ygJsd7V/dvm69mvvZrvTglfZhAVns1/wjXRLufTC9cMaA698+sFNbcr5vn74AQgNK
 EQLOYW7CwH+vNgW9LG3wqyUvgAXlwB6ZqBgyKTMhfyaYifoMkNWuo+h8fIIsqVZwuwVMZG4ol+ky
 qGf/nTwM2JV/0j//Gg73lH+4MQAAACV0RVh0ZGF0ZTpjcmVhdGUAMjAyMC0xMC0wM1QxNzoyMTox
 NyswMDowMB7s4ocAAAAldEVYdGRhdGU6bW9kaWZ5ADIwMjAtMTAtMDNUMTc6MjE6MTcrMDA6MDBv
 sVo7AAAAAElFTkSuQmCC
X-Now-Playing: Brian Eno, Jah Wobble's _Spinner_: "Transmitter and Trumpet"
Date: Sat, 03 Oct 2020 19:23:36 +0200
In-Reply-To: <83d01zeplw.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 03 Oct
 2020 10:27:23 +0300")
Message-ID: <87mu13ustj.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: >> Mmmh,
 I think technically
 we could, similarly to what we do for the >> advice, synthesize compile and
 install a trampoline. This would read >> the symbol-function and calls what's
 in inside. >> >> [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: Lars Ingebrigtsen <larsi@HIDDEN>,
 Stefan Monnier <monnier@HIDDEN>, 43725 <at> debbugs.gnu.org,
 Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> Mmmh, I think technically we could, similarly to what we do for the
>> advice, synthesize compile and install a trampoline.  This would read
>> the symbol-function and calls what's in inside.
>> 
>> This trampoline installation would be triggered inside Ffset.
>> 
>> So yeah I think we could, if that's the preferred way I can try this
>> way.
>
> Lars, Stefan: do you agree that this is the preferred way?

I'm not really qualified to have an opinion here, but if this allows
redefining primitives, I'm all for it.  Redefining primitives is a
useful tool.

Would these trampolines be installed only if the primitives are
redefined, so there'd be no performance impact on code running normally?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 3 Oct 2020 07:27:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 03 03:27:36 2020
Received: from localhost ([127.0.0.1]:42902 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kObxA-0008Ip-9n
	for submit <at> debbugs.gnu.org; Sat, 03 Oct 2020 03:27:36 -0400
Received: from eggs.gnu.org ([209.51.188.92]:38670)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kObx9-0008Ic-0R
 for 43725 <at> debbugs.gnu.org; Sat, 03 Oct 2020 03:27:35 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:50988)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kObx3-0002sK-Kk; Sat, 03 Oct 2020 03:27:29 -0400
Received: from [176.228.60.248] (port=1455 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kObwy-0004km-CZ; Sat, 03 Oct 2020 03:27:26 -0400
Date: Sat, 03 Oct 2020 10:27:23 +0300
Message-Id: <83d01zeplw.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>, Lars Ingebrigtsen <larsi@HIDDEN>
 Stefan Monnier <monnier@HIDDEN>
In-Reply-To: <xjfimbsv1qv.fsf@HIDDEN> (message from Andrea Corallo on Fri, 02
 Oct 2020 19:58:32 +0000)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfmu14v2mm.fsf@HIDDEN>
 <83imbse7hi.fsf@HIDDEN> <xjfimbsv1qv.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43725
Cc: 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: 43725 <at> debbugs.gnu.org
> Date: Fri, 02 Oct 2020 19:58:32 +0000
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> >> Date: Fri, 02 Oct 2020 19:39:29 +0000
> >> From: Andrea Corallo via "Bug reports for GNU Emacs,
> >>  the Swiss army knife of text editors" <bug-gnu-emacs@HIDDEN>
> >> 
> >> redefining primitives does not take effect in optimized code
> >
> > Why doesn't it?  Can it be made to take effect, like it does in
> > interpreted code?
> 
> Mmmh, I think technically we could, similarly to what we do for the
> advice, synthesize compile and install a trampoline.  This would read
> the symbol-function and calls what's in inside.
> 
> This trampoline installation would be triggered inside Ffset.
> 
> So yeah I think we could, if that's the preferred way I can try this
> way.

Lars, Stefan: do you agree that this is the preferred way?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 2 Oct 2020 19:58:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 02 15:58:36 2020
Received: from localhost ([127.0.0.1]:42635 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kORCO-0004YE-9Q
	for submit <at> debbugs.gnu.org; Fri, 02 Oct 2020 15:58:36 -0400
Received: from mx.sdf.org ([205.166.94.24]:56258)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1kORCM-0004Y5-1u
 for 43725 <at> debbugs.gnu.org; Fri, 02 Oct 2020 15:58:35 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTP id 092JwWMh005569;
 Fri, 2 Oct 2020 19:58:32 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfmu14v2mm.fsf@HIDDEN>
 <83imbse7hi.fsf@HIDDEN>
Date: Fri, 02 Oct 2020 19:58:32 +0000
In-Reply-To: <83imbse7hi.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 02 Oct
 2020 22:46:33 +0300")
Message-ID: <xjfimbsv1qv.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> Date: Fri, 02 Oct 2020 19:39:29 +0000
>> From: Andrea Corallo via "Bug reports for GNU Emacs,
>>  the Swiss army knife of text editors" <bug-gnu-emacs@HIDDEN>
>> 
>> redefining primitives does not take effect in optimized code
>
> Why doesn't it?  Can it be made to take effect, like it does in
> interpreted code?

Mmmh, I think technically we could, similarly to what we do for the
advice, synthesize compile and install a trampoline.  This would read
the symbol-function and calls what's in inside.

This trampoline installation would be triggered inside Ffset.

So yeah I think we could, if that's the preferred way I can try this
way.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 2 Oct 2020 19:46:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 02 15:46:47 2020
Received: from localhost ([127.0.0.1]:42626 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kOR0w-0004IO-TI
	for submit <at> debbugs.gnu.org; Fri, 02 Oct 2020 15:46:47 -0400
Received: from eggs.gnu.org ([209.51.188.92]:34430)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kOR0u-0004I9-73
 for 43725 <at> debbugs.gnu.org; Fri, 02 Oct 2020 15:46:45 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:39087)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kOR0m-0001W4-FA; Fri, 02 Oct 2020 15:46:36 -0400
Received: from [176.228.60.248] (port=2545 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kOR0l-0001AP-8P; Fri, 02 Oct 2020 15:46:36 -0400
Date: Fri, 02 Oct 2020 22:46:33 +0300
Message-Id: <83imbse7hi.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfmu14v2mm.fsf@HIDDEN> (bug-gnu-emacs@HIDDEN)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <xjfmu14v2mm.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43725
Cc: 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Fri, 02 Oct 2020 19:39:29 +0000
> From: Andrea Corallo via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <bug-gnu-emacs@HIDDEN>
> 
> redefining primitives does not take effect in optimized code

Why doesn't it?  Can it be made to take effect, like it does in
interpreted code?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 2 Oct 2020 19:39:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 02 15:39:35 2020
Received: from localhost ([127.0.0.1]:42610 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kOQtz-000478-3D
	for submit <at> debbugs.gnu.org; Fri, 02 Oct 2020 15:39:35 -0400
Received: from mx.sdf.org ([205.166.94.24]:57209)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1kOQtv-00046w-B6
 for 43725 <at> debbugs.gnu.org; Fri, 02 Oct 2020 15:39:34 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTP id 092JdTOv006207;
 Fri, 2 Oct 2020 19:39:29 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN>
Date: Fri, 02 Oct 2020 19:39:29 +0000
In-Reply-To: <xjfzh57w9pt.fsf@HIDDEN> (Andrea Corallo via's message of "Wed, 
 30 Sep 2020 15:44:14 +0000")
Message-ID: <xjfmu14v2mm.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi all,

FYI today I did some work to put the testsuite in shape also for the
native build (vanilla pass clean already).

The main challenge is related to the fact that the testsuite does large
use of primitive redefinition (tipically through `cl-letf').

As redefining primitives does not take effect in optimized code I
defined a macro (`advice-flet') with similar use but to advice instead
and put it in place in a numer of tests.  You'll see this work in
d07d7ab1a0 825e85b393.

I hope this approach is accettable (thought was good to ask for a
feedback), otherwise we can revert and find another solution.

ATM the testsuite for the native build runs still not clean, I'll finish
with cleaning it up.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 2 Oct 2020 19:39:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 02 15:39:44 2020
Received: from localhost ([127.0.0.1]:42613 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kOQu8-00047U-EF
	for submit <at> debbugs.gnu.org; Fri, 02 Oct 2020 15:39:44 -0400
Received: from lists.gnu.org ([209.51.188.17]:47702)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1kOQu5-00047M-VF
 for submit <at> debbugs.gnu.org; Fri, 02 Oct 2020 15:39:42 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:39682)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>) id 1kOQu5-00083P-O3
 for bug-gnu-emacs@HIDDEN; Fri, 02 Oct 2020 15:39:41 -0400
Received: from mx.sdf.org ([205.166.94.24]:57206)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>) id 1kOQu3-0000WQ-P0
 for bug-gnu-emacs@HIDDEN; Fri, 02 Oct 2020 15:39:41 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTP id 092JdTOv006207;
 Fri, 2 Oct 2020 19:39:29 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN>
Date: Fri, 02 Oct 2020 19:39:29 +0000
In-Reply-To: <xjfzh57w9pt.fsf@HIDDEN> (Andrea Corallo via's message of "Wed, 
 30 Sep 2020 15:44:14 +0000")
Message-ID: <xjfmu14v2mm.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
Received-SPF: pass client-ip=205.166.94.24; envelope-from=akrl@HIDDEN;
 helo=mx.sdf.org
X-detected-operating-system: by eggs.gnu.org: First seen = 2020/10/02 15:39:34
X-ACL-Warn: Detected OS   = ???
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

Hi all,

FYI today I did some work to put the testsuite in shape also for the
native build (vanilla pass clean already).

The main challenge is related to the fact that the testsuite does large
use of primitive redefinition (tipically through `cl-letf').

As redefining primitives does not take effect in optimized code I
defined a macro (`advice-flet') with similar use but to advice instead
and put it in place in a numer of tests.  You'll see this work in
d07d7ab1a0 825e85b393.

I hope this approach is accettable (thought was good to ask for a
feedback), otherwise we can revert and find another solution.

ATM the testsuite for the native build runs still not clean, I'll finish
with cleaning it up.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 1 Oct 2020 15:56:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 01 11:56:09 2020
Received: from localhost ([127.0.0.1]:38007 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kO0wD-0005qK-H1
	for submit <at> debbugs.gnu.org; Thu, 01 Oct 2020 11:56:09 -0400
Received: from quimby.gnus.org ([95.216.78.240]:60484)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kO0wB-0005pt-GH
 for 43725 <at> debbugs.gnu.org; Thu, 01 Oct 2020 11:56:08 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=7WaVnIm9myhgnoTP+IrWdaw0YubuIWVXY2NN9twd1Ys=; b=s8l7MGcCqMz6vm2K+CoEoh5MrL
 iWpUIKEe5mbkOGZGxW1a+aOv2b9OIzdKVfu4guUDEw05TTWVv/YeVT/N5J98vTXIjXdcgrMVJj7Ro
 gpAjfSXMiP0yCqyQbLh4dJhdpz0+urL9san4xrYmPGQZpvFEL6QxxihSrFuyYXl5B9Zk=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kO0vy-0000BA-Rd; Thu, 01 Oct 2020 17:56:00 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <87d02318fl.fsf@HIDDEN>
 <xjfpn62x55j.fsf@HIDDEN> <878scqwwyw.fsf@HIDDEN>
 <xjfh7rewfij.fsf@HIDDEN> <83r1qigkcu.fsf@HIDDEN>
X-Now-Playing: Boris's _NO_: "Zerkalo"
Date: Thu, 01 Oct 2020 17:55:53 +0200
In-Reply-To: <83r1qigkcu.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 01 Oct
 2020 16:13:21 +0300")
Message-ID: <87sgayq6t2.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: > I suggest this: > >
 git diff ...origin/feature/native-comp > > That's how I always produce changes
 introduced by a branch that > diverged from the current branch. 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: 43725 <at> debbugs.gnu.org, Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> I suggest this:
>
>    git diff ...origin/feature/native-comp
>
> That's how I always produce changes introduced by a branch that
> diverged from the current branch.

Thanks; very handy.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 1 Oct 2020 13:40:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 01 09:40:31 2020
Received: from localhost ([127.0.0.1]:34853 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kNyox-0001eY-CU
	for submit <at> debbugs.gnu.org; Thu, 01 Oct 2020 09:40:31 -0400
Received: from mx.sdf.org ([205.166.94.24]:63575)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1kNyou-0001eO-2Z
 for 43725 <at> debbugs.gnu.org; Thu, 01 Oct 2020 09:40:30 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTP id 091DeRU4018187;
 Thu, 1 Oct 2020 13:40:27 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <87d02318fl.fsf@HIDDEN>
 <xjfpn62x55j.fsf@HIDDEN> <878scqwwyw.fsf@HIDDEN>
 <xjfh7rewfij.fsf@HIDDEN> <83r1qigkcu.fsf@HIDDEN>
Date: Thu, 01 Oct 2020 13:40:27 +0000
In-Reply-To: <83r1qigkcu.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 01 Oct
 2020 16:13:21 +0300")
Message-ID: <xjfzh56uks4.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> Cc: 43725 <at> debbugs.gnu.org
>> Date: Thu, 01 Oct 2020 07:51:16 +0000
>> From: Andrea Corallo via "Bug reports for GNU Emacs,
>>  the Swiss army knife of text editors" <bug-gnu-emacs@HIDDEN>
>> 
>> > git diff origin/feature/native-comp..origin/master
>> >
>> > ?
>> 
>> I think something like this would add into the diff all new commits that
>> where pushed to master.
>> 
>> One option is to do the same but against the last commit from master
>> included into the branch (it's easy to identify as just under the last
>> merge).  ATM would be:
>> 
>> git diff 6c0f1c26d2...origin/feature/native-comp
>
> I suggest this:
>
>    git diff ...origin/feature/native-comp
>
> That's how I always produce changes introduced by a branch that
> diverged from the current branch.

Wow that's very handy thanks.

Expanding what you have posted this should work regardless what is the
current checkouted branch:

git diff $(git merge-base origin/master origin/feature/native-comp)..origin/feature/native-comp




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 1 Oct 2020 13:13:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 01 09:13:37 2020
Received: from localhost ([127.0.0.1]:34778 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kNyOv-0000xq-CF
	for submit <at> debbugs.gnu.org; Thu, 01 Oct 2020 09:13:37 -0400
Received: from eggs.gnu.org ([209.51.188.92]:38736)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kNyOq-0000xa-Tp
 for 43725 <at> debbugs.gnu.org; Thu, 01 Oct 2020 09:13:36 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:54412)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kNyOl-0006io-FO; Thu, 01 Oct 2020 09:13:27 -0400
Received: from [176.228.60.248] (port=4417 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kNyOj-0006Xe-Cy; Thu, 01 Oct 2020 09:13:26 -0400
Date: Thu, 01 Oct 2020 16:13:21 +0300
Message-Id: <83r1qigkcu.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfh7rewfij.fsf@HIDDEN> (bug-gnu-emacs@HIDDEN)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <87d02318fl.fsf@HIDDEN>
 <xjfpn62x55j.fsf@HIDDEN> <878scqwwyw.fsf@HIDDEN> <xjfh7rewfij.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: 43725 <at> debbugs.gnu.org
> Date: Thu, 01 Oct 2020 07:51:16 +0000
> From: Andrea Corallo via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <bug-gnu-emacs@HIDDEN>
> 
> > git diff origin/feature/native-comp..origin/master
> >
> > ?
> 
> I think something like this would add into the diff all new commits that
> where pushed to master.
> 
> One option is to do the same but against the last commit from master
> included into the branch (it's easy to identify as just under the last
> merge).  ATM would be:
> 
> git diff 6c0f1c26d2...origin/feature/native-comp

I suggest this:

   git diff ...origin/feature/native-comp

That's how I always produce changes introduced by a branch that
diverged from the current branch.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 1 Oct 2020 07:51:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 01 03:51:21 2020
Received: from localhost ([127.0.0.1]:33924 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kNtN3-00070q-Ai
	for submit <at> debbugs.gnu.org; Thu, 01 Oct 2020 03:51:21 -0400
Received: from mx.sdf.org ([205.166.94.24]:55922)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1kNtMz-00070e-PC
 for 43725 <at> debbugs.gnu.org; Thu, 01 Oct 2020 03:51:20 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTP id 0917pGiT006149;
 Thu, 1 Oct 2020 07:51:16 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <87d02318fl.fsf@HIDDEN>
 <xjfpn62x55j.fsf@HIDDEN> <878scqwwyw.fsf@HIDDEN>
Date: Thu, 01 Oct 2020 07:51:16 +0000
In-Reply-To: <878scqwwyw.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Thu,
 01 Oct 2020 03:34:15 +0200")
Message-ID: <xjfh7rewfij.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> Andrea Corallo <akrl@HIDDEN> writes:
>
>>> Was the patch against the trunk supposed to be included here?
>>
>> Hi Lars, no it wasn't :)
>>
>> In the sense that I'm not sure how do we prefer to proceed with the
>> review and I'm open for inputs on that.
>
> Right.  :-)
>
>> I didn't know if every time I update the branch is worth posting here a
>> 10K+ LOC patch, so I waited.  Also assuming the review will take some
>> time to go through I'm not really sure how this is practical.
>>
>> OTOH as the branch is already in emacs.git should be trivial for
>> reviewers at any point in time to produce the diff and quote the parts
>> they like to discuss.
>
> Sure, that's fine.  That would be
>
> git diff origin/feature/native-comp..origin/master
>
> ?

I think something like this would add into the diff all new commits that
where pushed to master.

One option is to do the same but against the last commit from master
included into the branch (it's easy to identify as just under the last
merge).  ATM would be:

git diff 6c0f1c26d2...origin/feature/native-comp

Other option is to just merge master into native-comp and do the diff
against master.

Not a git wizard so there could be even simpler ways to do that :)

>> Slightly different but related: I wanted to mention that I think would
>> be really good if possible to retain the current history.  That is going
>> for a merge instead of applying a single patch.  I believe this would be
>> of great help for me to maintain the code in the future.
>
> Sure, sounds good.

Great

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 1 Oct 2020 02:40:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 30 22:40:18 2020
Received: from localhost ([127.0.0.1]:33575 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kNoW1-0003Gj-Ue
	for submit <at> debbugs.gnu.org; Wed, 30 Sep 2020 22:40:18 -0400
Received: from eggs.gnu.org ([209.51.188.92]:46302)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kNoW0-0003GI-5g
 for 43725 <at> debbugs.gnu.org; Wed, 30 Sep 2020 22:40:16 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:46658)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kNoVs-0001Mp-H1; Wed, 30 Sep 2020 22:40:08 -0400
Received: from [176.228.60.248] (port=1626 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kNoVr-0008Lj-Fk; Wed, 30 Sep 2020 22:40:08 -0400
Date: Thu, 01 Oct 2020 05:40:02 +0300
Message-Id: <831riiis8t.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfpn62x55j.fsf@HIDDEN> (bug-gnu-emacs@HIDDEN)
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <87d02318fl.fsf@HIDDEN>
 <xjfpn62x55j.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43725
Cc: larsi@HIDDEN, 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: 43725 <at> debbugs.gnu.org
> Date: Wed, 30 Sep 2020 22:37:28 +0000
> From: Andrea Corallo via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <bug-gnu-emacs@HIDDEN>
> 
> OTOH as the branch is already in emacs.git should be trivial for
> reviewers at any point in time to produce the diff and quote the parts
> they like to discuss.

That's what I intended to do, FWIW.

> Slightly different but related: I wanted to mention that I think would
> be really good if possible to retain the current history.  That is going
> for a merge instead of applying a single patch.  I believe this would be
> of great help for me to maintain the code in the future.

Fine by me.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 1 Oct 2020 01:34:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 30 21:34:29 2020
Received: from localhost ([127.0.0.1]:33458 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kNnUL-0005lC-1F
	for submit <at> debbugs.gnu.org; Wed, 30 Sep 2020 21:34:29 -0400
Received: from quimby.gnus.org ([95.216.78.240]:52108)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kNnUI-0005kz-1y
 for 43725 <at> debbugs.gnu.org; Wed, 30 Sep 2020 21:34:27 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=iK2JK5B1136773bNtthPCy2K1T+h1x+SWv8kbl8gNeY=; b=Cvs7O7R5P+zYl2bIPj58l5dX18
 kdovxj+suPQ1GfcsaiMl8YC359CTaFKmIXY2lrjPL4v2njGkAykoIaksDMzLdnblV/Hktcul0987O
 PzyHw0CenWRlaPH+F7tXDer7nvkvUnfb8OD5jb+S4siJSkhU2TEfHTeITQ23nIYaXm68=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kNnU9-0000Em-9B; Thu, 01 Oct 2020 03:34:19 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <87d02318fl.fsf@HIDDEN>
 <xjfpn62x55j.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAElBMVEU0OUQnKjNCSlZr
 eIQYGiD///9of+7CAAAAAWJLR0QF+G/pxwAAAAd0SU1FB+QKAQEVOzRx6fcAAAG+SURBVDjLbVSB
 jdwwDJODDiA+NECQjtAFToD2n6mk5Nzl0PqAQ2BaJEUrsQX4df3+s9d1ma3kphm07Nori6sBQI/1
 M/sn7kUggaj0g9vnqnuZG9mC5VS6bACRGHxVRjMDC7X4DP6ZnRtIE1kGQZdGrhjSpMODZm3hEH+S
 cKjERQDSIKLNG4h8Gd0sCwL1AAppZ1QgSDtHK0fI7STTL1FtYEpWqpP/AEYAFVF+CMiMGAxUZg8Z
 fimOF7jfWboauA62d1gfqA6SFXDdwHITFVL7pOsWleX5QyBopfo8KLYBpzhzlDYhqEP0vQzVS8K6
 tI7rAcwNMqjJ8egLNns4aioBl+zyTr0BmQ62yLE4TQCGPtU7AQ0BpIFuQqNSyhirZ4eLVnNXocad
 ctFN8sfz1OnWF1PBAG1rnE0Fx0iAksqW/wAqEUliT7CKsWV27TfgtoFwAW3Xa9vdTt8D1A7/BWhX
 wPIeUWUxGrI95zU+tyOpxP0Exv4APk9l9b0QUfc7uFd8n2DwfFUktio+kWwHndl6RqI3/66wd0EO
 cL65GIlFt4ueXvEoAV+MOTCTijuUx5fio/EE3t8dAeuJhKq48xdILZi4Di/3IgAAACV0RVh0ZGF0
 ZTpjcmVhdGUAMjAyMC0xMC0wMVQwMToyMTo1OSswMDowMHDTjOgAAAAldEVYdGRhdGU6bW9kaWZ5
 ADIwMjAtMTAtMDFUMDE6MjE6NTkrMDA6MDABjjRUAAAAAElFTkSuQmCC
X-Now-Playing: The Breeders's _Off You_: "The She"
Date: Thu, 01 Oct 2020 03:34:15 +0200
In-Reply-To: <xjfpn62x55j.fsf@HIDDEN> (Andrea Corallo's message of "Wed, 30
 Sep 2020 22:37:28 +0000")
Message-ID: <878scqwwyw.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Andrea Corallo <akrl@HIDDEN> writes: >> Was the patch
 against
 the trunk supposed to be included here? > > Hi Lars, no it wasn't :) > >
 In the sense that I'm not sure how do we prefer to proceed with the > review
 and I'm open for inputs o [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andrea Corallo <akrl@HIDDEN> writes:

>> Was the patch against the trunk supposed to be included here?
>
> Hi Lars, no it wasn't :)
>
> In the sense that I'm not sure how do we prefer to proceed with the
> review and I'm open for inputs on that.

Right.  :-)

> I didn't know if every time I update the branch is worth posting here a
> 10K+ LOC patch, so I waited.  Also assuming the review will take some
> time to go through I'm not really sure how this is practical.
>
> OTOH as the branch is already in emacs.git should be trivial for
> reviewers at any point in time to produce the diff and quote the parts
> they like to discuss.

Sure, that's fine.  That would be

git diff origin/feature/native-comp..origin/master

?

> Slightly different but related: I wanted to mention that I think would
> be really good if possible to retain the current history.  That is going
> for a merge instead of applying a single patch.  I believe this would be
> of great help for me to maintain the code in the future.

Sure, sounds good.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 30 Sep 2020 22:37:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 30 18:37:33 2020
Received: from localhost ([127.0.0.1]:33349 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kNkj7-0001Yx-BN
	for submit <at> debbugs.gnu.org; Wed, 30 Sep 2020 18:37:33 -0400
Received: from mx.sdf.org ([205.166.94.24]:57871)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1kNkj5-0001Yi-IQ
 for 43725 <at> debbugs.gnu.org; Wed, 30 Sep 2020 18:37:32 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTP id 08UMbS4s004172;
 Wed, 30 Sep 2020 22:37:28 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN> <87d02318fl.fsf@HIDDEN>
Date: Wed, 30 Sep 2020 22:37:28 +0000
In-Reply-To: <87d02318fl.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Wed,
 30 Sep 2020 19:27:42 +0200")
Message-ID: <xjfpn62x55j.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> Andrea Corallo <akrl@HIDDEN> writes:
>
>> this is to handle code-review and process whose final goal is to have
>> the feature/native-comp branch merged into master.
>
> Was the patch against the trunk supposed to be included here?

Hi Lars, no it wasn't :)

In the sense that I'm not sure how do we prefer to proceed with the
review and I'm open for inputs on that.

I didn't know if every time I update the branch is worth posting here a
10K+ LOC patch, so I waited.  Also assuming the review will take some
time to go through I'm not really sure how this is practical.

OTOH as the branch is already in emacs.git should be trivial for
reviewers at any point in time to produce the diff and quote the parts
they like to discuss.

Slightly different but related: I wanted to mention that I think would
be really good if possible to retain the current history.  That is going
for a merge instead of applying a single patch.  I believe this would be
of great help for me to maintain the code in the future.

Please let me know how you prefer we proceed.

Thanks!

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at 43725 <at> debbugs.gnu.org:


Received: (at 43725) by debbugs.gnu.org; 30 Sep 2020 17:27:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 30 13:27:57 2020
Received: from localhost ([127.0.0.1]:32994 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kNftV-0002L8-6r
	for submit <at> debbugs.gnu.org; Wed, 30 Sep 2020 13:27:57 -0400
Received: from quimby.gnus.org ([95.216.78.240]:47868)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kNftR-0002Kt-Hh
 for 43725 <at> debbugs.gnu.org; Wed, 30 Sep 2020 13:27:56 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=uC9OkBqQN2gI5cv+e945bYEWW53XeZm68daGxRwfMns=; b=gion0k40KMcFoy4Czz949mJEW1
 c0pHWW0eXrw7/gOlIpIl5O9wxT06Q9nK9cEiAWMrAmA1EbDbcJRkwP9Q/ptimGo93u+QEtmyQvX1I
 AUYNFzLjUkQTiph+TdT3w3cfD+Haw5E+T68TvUh4hh9nrW8O6gt2Y5salYGg5dnjxge8=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kNftI-0003xV-8e; Wed, 30 Sep 2020 19:27:46 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
Subject: Re: bug#43725: 28.0.50; Include feature/native-comp into master
References: <xjfzh57w9pt.fsf@HIDDEN>
X-Now-Playing: Laub's _Unter Anderen Bedingungen als Liebe_: "Augenscheinlich"
Date: Wed, 30 Sep 2020 19:27:42 +0200
In-Reply-To: <xjfzh57w9pt.fsf@HIDDEN> (Andrea Corallo's message of "Wed, 30
 Sep 2020 15:44:14 +0000")
Message-ID: <87d02318fl.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Andrea Corallo <akrl@HIDDEN> writes: > this is to handle
 code-review and process whose final goal is to have > the feature/native-comp
 branch merged into master. Was the patch against the trunk supposed to be
 included here? If so, something went wrong somewhere. :-) 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43725
Cc: 43725 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andrea Corallo <akrl@HIDDEN> writes:

> this is to handle code-review and process whose final goal is to have
> the feature/native-comp branch merged into master.

Was the patch against the trunk supposed to be included here?  If so,
something went wrong somewhere.  :-)

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 30 Sep 2020 15:44:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 30 11:44:24 2020
Received: from localhost ([127.0.0.1]:60868 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kNeHH-0001eT-Iv
	for submit <at> debbugs.gnu.org; Wed, 30 Sep 2020 11:44:24 -0400
Received: from lists.gnu.org ([209.51.188.17]:40396)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1kNeHD-0001eK-U5
 for submit <at> debbugs.gnu.org; Wed, 30 Sep 2020 11:44:21 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:45850)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>) id 1kNeHD-000723-Mi
 for bug-gnu-emacs@HIDDEN; Wed, 30 Sep 2020 11:44:19 -0400
Received: from mx.sdf.org ([205.166.94.24]:61203)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>) id 1kNeHB-0000YJ-Bd
 for bug-gnu-emacs@HIDDEN; Wed, 30 Sep 2020 11:44:19 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTP id 08UFiEd4022777
 for <bug-gnu-emacs@HIDDEN>; Wed, 30 Sep 2020 15:44:14 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 28.0.50; Include feature/native-comp into master
Date: Wed, 30 Sep 2020 15:44:14 +0000
Message-ID: <xjfzh57w9pt.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
Received-SPF: pass client-ip=205.166.94.24; envelope-from=akrl@HIDDEN;
 helo=mx.sdf.org
X-detected-operating-system: by eggs.gnu.org: First seen = 2020/09/30 10:24:05
X-ACL-Warn: Detected OS   = ???
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

Hi all,

this is to handle code-review and process whose final goal is to have
the feature/native-comp branch merged into master.

I'll try to make this as easy as possible implementing suggestions.
Also please feel free to install directly changes on the branch if you
feel.

Thanks in advance to the reviewers for the time.

  Andrea




Acknowledgement sent to Andrea Corallo <akrl@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#43725; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Sat, 20 Mar 2021 11:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.